SystemOrganization addCategory: #'Monticello-Bootstrap'!
SystemOrganization addCategory: #'Monticello-Base'!
SystemOrganization addCategory: #'Monticello-Modeling'!
SystemOrganization addCategory: #'Monticello-Loading'!
SystemOrganization addCategory: #'Monticello-Merging'!
SystemOrganization addCategory: #'Monticello-Patching'!
SystemOrganization addCategory: #'Monticello-Storing'!
SystemOrganization addCategory: #'Monticello-Versioning'!
SystemOrganization addCategory: #'Monticello-Repositories'!
SystemOrganization addCategory: #'Monticello-UI'!
SystemOrganization addCategory: #'Monticello-Mocks'!
SystemOrganization addCategory: #'Monticello-Tests'!

!Time class methodsFor: '*monticello' stamp: 'cwp 7/21/2003 13:51'!
fromString: aString
	^ self readFrom: (ReadStream on: aString).
! !

!MethodReference methodsFor: '*monticello' stamp: 'ab 8/22/2003 17:55'!
asMethodDefinition
	^ MCMethodDefinition forMethodReference: self! !

!MethodReference methodsFor: '*monticello' stamp: 'ab 8/22/2003 17:58'!
compiledMethod
	^ self actualClass compiledMethodAt: methodSymbol! !

!MethodReference methodsFor: '*monticello' stamp: 'ab 8/22/2003 17:59'!
source
	^ (self actualClass sourceCodeAt: methodSymbol) asString withSqueakLineEndings! !

!MethodReference methodsFor: '*monticello' stamp: 'ab 8/22/2003 17:58'!
timeStamp
	^ self compiledMethod timeStamp! !

!MethodReference class methodsFor: '*monticello' stamp: 'cwp 8/2/2003 12:27'!
class: aClass selector: aSelector
	^ self new setStandardClass: aClass methodSymbol: aSelector! !

!MethodReference methodsFor: '*monticello' stamp: 'ab 8/22/2003 17:58'!
category
	^ self actualClass organization categoryOfElement: methodSymbol! !

!ChangeList class methodsFor: '*monticello' stamp: 'dvf 7/23/2003 15:12'!
recentLogOn: origChangesFile startingFrom: initialPos 
	"Prompt with a menu of how far back to go when browsing a changes file."

	| end banners positions pos chunk i changesFile |
	changesFile _ origChangesFile readOnlyCopy.
	banners _ OrderedCollection new.
	positions _ OrderedCollection new.
	end _ changesFile size.
	pos _ initialPos.
	[pos = 0
		or: [banners size > 20]]
		whileFalse: [changesFile position: pos.
			chunk _ changesFile nextChunk.
			i _ chunk indexOfSubCollection: 'priorSource: ' startingAt: 1.
			i > 0
				ifTrue: [positions addLast: pos.
					banners
						addLast: (chunk copyFrom: 5 to: i - 2).
					pos _ Number
								readFrom: (chunk copyFrom: i + 13 to: chunk size)]
				ifFalse: [pos _ 0]].
	changesFile close.
	banners size == 0 ifTrue: [^self recent: end on: origChangesFile].

	pos _ (SelectionMenu labelList: banners selections: positions)
				startUpWithCaption: 'Browse as far back as...'.
	pos == nil
		ifTrue: [^ self].
	^self recent: end - pos on: origChangesFile! !

!ChangeList class methodsFor: '*monticello' stamp: 'dvf 7/23/2003 14:20'!
recent: charCount on: origChangesFile 
	"Opens a changeList on the end of the specified changes log file"
	| changeList end changesFile |
	changesFile _ origChangesFile readOnlyCopy.
	end _ changesFile size.
	Cursor read
		showWhile: [changeList _ self new
						scanFile: changesFile
						from: (0 max: end - charCount)
						to: end].
	changesFile close.
	^changeList! !

!ChangeList methodsFor: '*monticello' stamp: 'dvf 7/23/2003 14:44'!
changeTo: changeSubset
	| newList newChangeList |

	newChangeList _ OrderedCollection new.
	newList _ OrderedCollection new.

	1 to: changeList size do:
		[:i | (changeSubset includes: (changeList at: i)) ifTrue:
			[newChangeList add: (changeList at: i).
			newList add: (list at: i)]].
	newChangeList size < changeList size
		ifTrue:
			[changeList _ newChangeList.
			list _ newList.
			listIndex _ 0.
			listSelections _ Array new: list size withAll: false].
	self changed: #list

	! !

Object weakSubclass: #MCMockClassI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

Object subclass: #MCVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:42'!
visitVersionInfo: aVersionInfo
! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 21:35'!
visitDefinition: aDefinition! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 21:36'!
visitMethodDefinition: aMethodDefinition
	^ self visitDefinition: aMethodDefinition! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 21:36'!
visitClassDefinition: aClassDefinition
	^ self visitDefinition: aClassDefinition! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 21:36'!
visitOrganizationDefinition: anOrganizationDefinition
	^ self visitDefinition: anOrganizationDefinition! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:41'!
visitVersion: aVersion
	aVersion package accept: self.
	aVersion info accept: self.
	aVersion snapshot accept: self.! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 22:17'!
visitSnapshot: aSnapshot
	aSnapshot definitions do: [:ea | ea accept: self]! !

MCVisitor subclass: #MCWriter
	instanceVariableNames: 'stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCWriter methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 01:14'!
stream
	^ stream! !

!MCWriter methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 21:37'!
stream: aStream
	stream _ aStream! !

MCWriter subclass: #MCStInitializerWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCStInitializerWriter methodsFor: 'as yet unclassified' stamp: 'ab 8/8/2003 17:14'!
visitMethodDefinition: aMethodDefinition
	aMethodDefinition isInitializer ifTrue:
		[stream nextChunkPut: aMethodDefinition className, ' initialize'; cr]! !

MCWriter subclass: #MCChunkWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'JF 7/23/2003 17:55'!
visitOrganizationDefinition: aDefinition	
	aDefinition categories notEmpty ifTrue:
		[self chunkContents:
			[:s |
			s
				nextPutAll: 'MCOrganization', self definitionSuffix;
				space; nextPutAll: 'categories: ';
				cr; nextPutAll: '  #('.
			aDefinition categories do:
				[:ea |
				s cr; space; space; store: ea asString].
			s nextPutAll: ')']]! !

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 17:35'!
basicChunkContents: aBlock
	stream nextChunkPut: (String streamContents: aBlock)! !

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 17:35'!
chunkContents: aBlock
	stream cr; cr.
	self basicChunkContents: aBlock! !

MCChunkWriter subclass: #MCMcvWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMcvWriter methodsFor: 'visiting' stamp: 'cwp 8/3/2003 17:46'!
visitVersionInfo: aVersionInfo
	self chunkContents: [:aStream |
		aStream
			nextPutAll: 'MCVersionInfo fromArray:';
			cr; nextPut: $#.
			self writeVersionInfo: aVersionInfo on: aStream.
	]! !

!MCMcvWriter methodsFor: 'writing' stamp: 'cwp 8/3/2003 17:49'!
writeVersionInfo: aVersionInfo on: aStream
	aStream
		nextPutAll: '('; store: aVersionInfo name;
		cr; store: aVersionInfo id asString;
		cr; store: aVersionInfo message.
	aVersionInfo date ifNotNil:
		[aStream
			cr; store: aVersionInfo date asString;
			cr; store: aVersionInfo time asString;
			cr; store: aVersionInfo author].
		
	aStream cr; nextPutAll: '('.
	aVersionInfo ancestors 
		do: [:ea | self writeVersionInfo: ea on: aStream] 
		separatedBy: [aStream cr].
	aStream nextPutAll: '))'.! !

!MCMcvWriter methodsFor: 'visiting' stamp: 'cwp 8/3/2003 17:51'!
visitPackage: aPackage
	self basicChunkContents: [:s | s
		nextPutAll: 'MCPackage named: ''';
		nextPutAll: aPackage name;
		nextPut: $']! !

!MCMcvWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:35'!
supportsVersions
	^ true! !

!MCMcvWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 14:57'!
readerClass
	^ MCMcvReader! !

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 22:16'!
visitMethodDefinition: aDefinition	
	self chunkContents:
		[:s |
		s
			nextPutAll: 'MCMethod', self definitionSuffix;
			space; nextPutAll: 'className: '; store: aDefinition className.
		aDefinition classIsMeta ifTrue: [s space; nextPutAll: 'classIsMeta: true'].
		s
			space; nextPutAll: 'selector: '; store: aDefinition selector;
			space; nextPutAll: 'category: '; store: aDefinition category;
			space; nextPutAll: 'timeStamp: '; store: aDefinition timeStamp.
		s
			space; nextPutAll: 'source: '; cr; store: aDefinition source]! !

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2003 02:32'!
visitClassDefinition: aDefinition
	self chunkContents:
		[:s |
		s 
			nextPutAll: 'MCClass', self definitionSuffix;
			cr; space; space; nextPutAll: 'name: '; store: aDefinition className;
			cr; space; space; nextPutAll: 'superclassName: '; store: aDefinition superclassName;
			cr; space; space; nextPutAll: 'category: '; store: aDefinition category;
			cr; space; space; nextPutAll: 'instVarNames: '; store: aDefinition instVarNames asArray;
			cr; space; space; nextPutAll: 'classVarNames: '; store: aDefinition classVarNames asArray;
			cr; space; space; nextPutAll: 'poolDictionaryNames: '; store: aDefinition poolDictionaries asArray;
			cr; space; space; nextPutAll: 'classInstVarNames: '; store: aDefinition classInstVarNames asArray.
			s cr; space; space; nextPutAll: 'type: '; store: aDefinition type.
			s cr; space; space; nextPutAll: 'comment: '; store: aDefinition comment]! !

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 22:16'!
definitionSuffix
	^ 'Definition'! !

!MCChunkWriter methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 21:46'!
visitSnapshot: aSnapshot
	aSnapshot definitions do: [:ea | ea accept: self] displayingProgress: 'Writing definitions...'! !

MCChunkWriter subclass: #MCMcWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMcWriter methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 17:53'!
visitPackage: aPackage
	self basicChunkContents: [:s | s
		nextPutAll: 'MCRevisionInfo packageName: ''';
		nextPutAll: aPackage name;
		nextPut: $']! !

!MCMcWriter methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 22:17'!
definitionSuffix
	^ 'Declaration'! !

!MCMcWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 14:28'!
readerClass
	^ MCMcReader! !

!MCMcWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 17:53'!
fileOutSnapshot: aSnapshot named: packageName on: aStream
	self fileOut: (MCPackage named: packageName) on: aStream.
	self fileOut: aSnapshot on: aStream.! !

!MCMcWriter methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:02'!
visitSnapshot: aSnapshot
	aSnapshot definitions asSortedCollection do: [:ea | ea accept: self]! !

!MCWriter class methodsFor: 'writing' stamp: 'cwp 8/1/2003 01:16'!
fileOut: anObject on: aStream
	anObject accept: (self on: aStream)
! !

!MCWriter class methodsFor: 'accessing' stamp: 'cwp 8/1/2003 15:00'!
extension
	^ self readerClass extension! !

MCWriter subclass: #MCMczWriter
	instanceVariableNames: 'zip '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMczWriter methodsFor: 'visiting' stamp: 'cwp 8/7/2003 15:31'!
visitSnapshot: aSnapshot
	| writer |
	writer _ self snapshotWriter.
	aSnapshot accept: writer.
	self addString: writer stream contents at: 'snapshot/source.', writer class extension.! !

!MCMczWriter methodsFor: 'serializing' stamp: 'cwp 8/13/2003 01:25'!
serializeVersionInfo: aVersionInfo
	| str |
	str _ RWBinaryOrTextStream on: String new.
	self storeVersionInfo: aVersionInfo on: str.
	^ str contents! !

!MCMczWriter methodsFor: 'writing' stamp: 'cwp 8/1/2003 01:38'!
addString: string at: path
	| member |
	member _ zip addString: string as: path.
	member desiredCompressionMethod: ZipArchive compressionDeflated 
	! !

!MCMczWriter methodsFor: 'visiting' stamp: 'cwp 8/13/2003 01:18'!
visitVersionInfo: aVersionInfo
	| string |
	string _ (self serializeVersionInfo: aVersionInfo).
	self addString: string at: 'version'! !

!MCMczWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 01:25'!
fileOut: anObject on: aStream
	| inst |
	inst _ self on: aStream.
	anObject accept: inst.
	inst flush.
	
! !

!MCMczWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 00:07'!
new
	^ super new initialize! !

!MCMczWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 12:35'!
readerClass
	^ MCMczReader! !

!MCMczWriter methodsFor: 'visiting' stamp: 'cwp 8/13/2003 01:07'!
visitPackage: aPackage
	self addString: (self serializePackage: aPackage) at: 'package'! !

!MCMczWriter methodsFor: 'accessing' stamp: 'cwp 8/4/2003 00:13'!
snapshotWriter
	^ MCStWriter on: (RWBinaryOrTextStream on: String new)! !

!MCMczWriter methodsFor: 'serializing' stamp: 'cwp 8/13/2003 01:25'!
storeVersionInfo: aVersionInfo on: aStream
	aStream nextPut: $(.
	#(name message id date time author) 
		do: [:sel | 
			aStream nextPutAll: sel.
			aStream nextPut: $ .
			(aVersionInfo perform: sel) asString printOn: aStream.
			aStream nextPut: $ ].
	aStream nextPutAll: 'ancestors ('.
	aVersionInfo ancestors do: [:ea | self storeVersionInfo: ea on: aStream].
	aStream nextPutAll: '))'.
		! !

!MCMczWriter methodsFor: 'accessing' stamp: 'cwp 8/1/2003 00:06'!
zip
	^ zip! !

!MCMczWriter methodsFor: 'initializing' stamp: 'cwp 8/1/2003 01:18'!
initialize
	zip _ ZipArchive new.
! !

!MCMczWriter methodsFor: 'serializing' stamp: 'cwp 8/13/2003 01:06'!
serializePackage: aPackage
	^ '(name ''', aPackage name, ''')'! !

!MCMczWriter methodsFor: 'writing' stamp: 'cwp 8/1/2003 01:30'!
flush
	zip writeTo: stream.
	stream close! !

!MCWriter class methodsFor: 'writing' stamp: 'cwp 8/1/2003 01:16'!
on: aStream
	^ self new stream: aStream! !

!MCWriter class methodsFor: 'accessing' stamp: 'cwp 7/28/2003 23:46'!
readerClass
	^ self subclassResponsibility ! !

MCWriter subclass: #MCStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/2/2003 02:34'!
chunkContents: aBlock
	stream cr; nextChunkPut: (String streamContents: aBlock); cr! !

!MCStWriter methodsFor: 'writing' stamp: 'ab 8/17/2003 17:09'!
writeClassComment: definition
	stream
		cr;
		nextPut: $!!;
		nextPutAll: definition className;
		nextPutAll: ' commentStamp: ';
		store: definition commentStamp;
		nextPutAll: ' prior: 0!!';
		cr;
		nextChunkPut: definition comment;
		cr.! !

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/2/2003 02:32'!
writeMetaclassDefinition: definition
	self chunkContents: [:s | s
		nextPutAll: definition className;
		nextPutAll: ' class';
		cr; tab;
		nextPutAll: 'instanceVariableNames: ''';
		nextPutAll: definition classInstanceVariablesString;
		nextPut: $'.
	]! !

!MCStWriter methodsFor: 'visiting' stamp: 'cwp 8/2/2003 11:02'!
visitClassDefinition: definition
	self writeClassDefinition: definition.
	definition hasClassInstanceVariables ifTrue: [self writeMetaclassDefinition: definition].
	definition hasComment ifTrue: [self writeClassComment: definition].! !

!MCStWriter methodsFor: 'visiting' stamp: 'cwp 8/2/2003 12:43'!
visitMethodDefinition: definition
	self writeMethodPreamble: definition.
	self writeMethodSource: definition.
	self writeMethodPostscript.! !

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/4/2003 01:35'!
writeMethodSource: definition
	stream nextChunkPut: definition source! !

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/2/2003 12:43'!
writeMethodPostscript
	stream
		space;
		nextPut: $!!;
		cr! !

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/2/2003 02:16'!
writeClassDefinition: definition
	self chunkContents: [:s | definition printDefinitionOn: stream]! !

!MCStWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 18:44'!
readerClass
	^ MCStReader! !

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/2/2003 14:46'!
writeMethodPreamble: definition
	stream
		cr;
		nextPut: $!!;
		nextPutAll: definition fullClassName;
		nextPutAll: ' methodsFor: ''';
		nextPutAll: definition category;
		nextPutAll: ''' stamp: ''';
		nextPutAll: definition timeStamp;
		nextPutAll: '''!!';
		cr! !

!MCStWriter methodsFor: 'writing' stamp: 'cwp 8/2/2003 01:46'!
writeCategory: categoryName
	stream
		nextChunkPut: 'SystemOrganization addCategory: ', categoryName printString;
		cr! !

!MCStWriter methodsFor: 'visiting' stamp: 'ab 8/8/2003 17:06'!
visitSnapshot: aSnapshot
	(MCDependencySorter sortItems: aSnapshot definitions)
		do: [:ea | ea accept: self]
		displayingProgress: 'Writing definitons...'.
		
	(MCStInitializerWriter on: stream) visitSnapshot: aSnapshot.! !

!MCStWriter methodsFor: 'visiting' stamp: 'cwp 8/2/2003 11:02'!
visitOrganizationDefinition: defintion
	defintion categories do: [:cat | self writeCategory: cat].
! !

!MCVisitor methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:41'!
visitPackage: aPackage
! !

Object subclass: #MCRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCRepository methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:46'!
closestAncestorVersionFor: aVersionInfo ifNone: errorBlock
	aVersionInfo allAncestors do:
		[:ancestorInfo |
		(self versionWithInfo: ancestorInfo) ifNotNilDo: [:v | ^ v]].
	^ errorBlock value! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:40'!
morphicOpen
	self subclassResponsibility ! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:43'!
versionWithInfo: aVersionInfo
	| version |
	^ MCVersion withInfo: aVersionInfo ifAbsent: 
		[version _ self versionWithInfo: aVersionInfo ifAbsent: [^ nil].
		version info = aVersionInfo
			ifTrue: [version]
			ifFalse: [self notify: 'Found version named ', aVersionInfo name, ' with incorrect ID'. nil]]! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 20:13'!
initialize! !

MCRepository subclass: #MCDictionaryRepository
	instanceVariableNames: 'description dict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:47'!
dictionary

	^ dict! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:50'!
description: aString

	description _ aString ! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:47'!
dictionary: aDictionary

	dict _ aDictionary! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 19:49'!
closestAncestorVersionFor: aVersionInfo ifNone: errorBlock
	| info |
	info _ aVersionInfo allAncestors
			detect: [:ea | self includesVersionWithInfo: ea]
			ifNone: [^ errorBlock value].
	^ self versionWithInfo: info! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:47'!
description

	^ description ifNil: ['cache']! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:56'!
= other
	^ self == other! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2003 23:39'!
includesVersionNamed: aString
	^ dict anySatisfy: [:ea | ea info name = aString]! !

!MCDictionaryRepository class methodsFor: 'accessing' stamp: 'ab 7/26/2003 02:47'!
description

	^ 'cache'! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:47'!
initialize

	dict _ Dictionary new! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:40'!
sortedVersionInfos
	| sorter |
	sorter _ MCVersionSorter new.
	self allVersionInfos do: [:ea | sorter addVersionInfo: ea].
	^ sorter sortedVersionInfos
! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:40'!
morphicOpen
	| names index infos |
	infos _ self sortedVersionInfos.
	infos isEmpty ifTrue: [^ self inform: 'No versions'].
	names _ infos collect: [:ea | ea name].
	index _ (PopUpMenu labelArray: names) startUpWithCaption: 'Open version:'.
	index = 0 ifFalse: [(self versionWithInfo: (infos at: index)) open]! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 19:49'!
includesVersionWithInfo: aVersionInfo
	^ dict includesKey: aVersionInfo! !

!MCDictionaryRepository class methodsFor: 'accessing' stamp: 'ab 7/26/2003 02:50'!
morphicConfigure
	| desc |
	desc _ FillInTheBlank request: 'Cache name:'.
	^ desc isEmpty ifFalse:

		[self new description: desc].! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:05'!
storeVersion: aVersion
	dict at: aVersion info put: aVersion! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 18:22'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	^ dict at: aVersionInfo ifAbsent: errorBlock! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 21:04'!
allVersionInfos
	^ dict values collect: [:ea | ea info]! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:40'!
includesVersionNamed: aString
	self subclassResponsibility! !

!MCRepository class methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:59'!
isAbstract
	^ self description isNil! !

!MCRepository class methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:29'!
description
	^ nil! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 15:57'!
description
	^ self printString! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:36'!
hash
	^ self description hash! !

!MCRepository class methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 20:13'!
new
	^ super new initialize! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 18:22'!
versionWithInfo: aVersionInfo ifAbsent: aBlock
	self subclassResponsibility ! !

!MCRepository class methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:30'!
allConcreteSubclasses
	^ self withAllSubclasses reject: [:ea | ea isAbstract]! !

!MCRepository class methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 21:01'!
morphicConfigure
	^ self new! !

MCRepository subclass: #MCFileBasedRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCFileBasedRepository class methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:31'!
defaultReaderClass
	^ self defaultWriterClass readerClass! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:39'!
loadVersionFromFileNamed: aString
	^ self
		readStreamForFileNamed: aString
		do:[:s | (MCReader readerClassForFileNamed: aString) versionFromStream: s]! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:31'!
defaultReaderClass
	^ self class defaultReaderClass! !

MCFileBasedRepository subclass: #MCDirectoryRepository
	instanceVariableNames: 'directory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCDirectoryRepository methodsFor: 'comparing' stamp: 'ab 7/19/2003 21:40'!
hash
	^ directory pathName hash! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:56'!
directory: aDirectory
	directory _ aDirectory! !

!MCDirectoryRepository class methodsFor: 'accessing' stamp: 'cwp 7/31/2003 19:26'!
extension
	^ self defaultWriterClass extension! !

!MCDirectoryRepository class methodsFor: 'instance creation' stamp: 'ab 7/24/2003 21:01'!
morphicConfigure
	^ FileList2 modalFolderSelector ifNotNilDo:
		[:directory |
		self new directory: directory]! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 17:49'!
directory
	^ directory! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:37'!
initialize
	directory _ FileDirectory default! !

!MCDirectoryRepository class methodsFor: 'instance creation' stamp: 'ab 7/24/2003 21:20'!
description
	^ 'directory'! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 15:28'!
allFileNames
	^ (directory entries sortBy: [:a :b | a modificationTime >= b modificationTime]) collect: [:ea | ea name]! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 16:07'!
description
	^ directory pathName! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:45'!
writeStreamForFileNamed: aString do: aBlock 
	| file |
	file _ FileStream newFileNamed: (directory fullNameFor: aString).
	aBlock value: file.
	file close.! !

!MCDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:45'!
readStreamForFileNamed: aString do: aBlock
	| file val |
	file _ FileStream readOnlyFileNamed: (directory fullNameFor: aString).
	val _ aBlock value: file.
	file close.
	^ val! !

!MCFileBasedRepository class methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:31'!
defaultWriterClass
	^ MCMczWriter! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 20:01'!
allFileNamesForVersionNamed: aString
	^ self filterFileNames: self readableFileNames forVersionNamed: aString! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:36'!
includesVersionNamed: aString
	^ self allVersionNames includes: aString! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:33'!
storeVersion: aVersion
	self
		writeStreamForFileNamed: (self fileNameForVersionName: aVersion info name)
		do: [:s | self defaultWriterClass fileOut: aVersion on: s].
! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:36'!
fileNameForVersionName: aString
	^ aString, '.', self defaultWriterClass extension! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:35'!
allFileNames
	self subclassResponsibility! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 13:00'!
canReadFileNamed: aString
	| reader |
	reader _ MCReader readerClassForFileNamed: aString.
	^ reader notNil and: [reader supportsVersions]! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'nk 8/24/2003 00:02'!
morphicOpen
	| names index |
	names _ self readableFileNames.
	names isEmpty ifTrue: [ self inform: 'no readable files'. ^self ].
	index _ (PopUpMenu labelArray: names) startUpWithCaption: 'Open version:'.
	index = 0 ifFalse: [(self loadVersionFromFileNamed: (names at: index)) open].	! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 20:01'!
filterFileNames: aCollection forVersionNamed: aString
	^ aCollection select: [:ea | (self versionNameFromFileName: ea) = aString] ! !

MCFileBasedRepository subclass: #MCHttpRepository
	instanceVariableNames: 'location user password '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCHttpRepository methodsFor: 'required' stamp: 'ab 8/21/2003 12:33'!
writeStreamForFileNamed: aString do: aBlock
	| stream response |
	stream _ RWBinaryOrTextStream on: String new.
	aBlock value: stream.
	response _ HTTPSocket
					httpPut: stream contents
					to: (self urlForFileNamed: aString)
					user: user
					passwd: password.
	(response beginsWith: 'HTTP/1.1 201 Created')
		ifFalse: [self error: response].! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 20:41'!
user: userString
	user _ userString! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 20:41'!
location: aUrlString
	location _ aUrlString! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 22:17'!
locationWithTrailingSlash
	^ (location endsWith: '/')
		ifTrue: [location]
		ifFalse: [location, '/']! !

!MCHttpRepository methodsFor: 'required' stamp: 'ab 8/21/2003 12:39'!
readStreamForFileNamed: aString do: aBlock
	| contents |
	contents _ HTTPSocket httpGet: (self urlForFileNamed: aString) user: user passwd: password.
	^ contents isString ifFalse: [aBlock value: contents]! !

!MCHttpRepository methodsFor: 'required' stamp: 'ab 7/24/2003 21:10'!
description
	^ location! !

!MCHttpRepository methodsFor: 'required' stamp: 'ab 8/20/2003 21:15'!
allFileNames
	| index |
	index _ HTTPSocket httpGet: self locationWithTrailingSlash, '?C=M;O=D' user: user passwd: password.
	index isString ifTrue: [self error: 'Could not access ', location].
	^ self parseFileNamesFromStream: index	! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:59'!
parseFileNamesFromStream: aStream
	| names fullName |
	names _ OrderedCollection new.
	[aStream atEnd] whileFalse:
		[[aStream upTo: $<. 'aA' includes: aStream next] whileFalse.
		aStream upTo: $".
		aStream atEnd ifFalse: [
			fullName _ aStream upTo: $".
			names add: fullName unescapePercents]].
	^ names! !

!MCHttpRepository class methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 21:15'!
morphicConfigure
	| chunk |
	chunk _ FillInTheBlankMorph 
			request: 'HTTP Repository:'
			initialAnswer: self creationTemplate
			centerAt: Sensor cursorPoint
			inWorld: World
			onCancelReturn: nil
			acceptOnCR: false
			answerExtent: 400@120.
	^ chunk ifNotNil: [self readFrom: chunk readStream]! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 13:08'!
urlForFileNamed: aString
	^ self locationWithTrailingSlash, aString encodeForHTTP! !

!MCHttpRepository class methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 21:33'!
creationTemplate
	^
'MCHttpRepository
	location: ''http://foo.com/bar''
	user: ''squeak''
	password: ''squeak'''
	! !

!MCHttpRepository class methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 21:32'!
location: location user: user password: password
	^ self new
		location: location;
		user: user;
		password: password! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 20:41'!
password: passwordString
	password _ passwordString! !

!MCHttpRepository class methodsFor: 'as yet unclassified' stamp: 'ab 7/24/2003 21:20'!
description
	^ 'HTTP'! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:34'!
versionNameFromFileName: aString
	^ aString copyUpToLast: $.! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:40'!
allVersionNames
	^ self readableFileNames collect: [:ea | self versionNameFromFileName: ea]! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:32'!
defaultWriterClass
	^ self class defaultWriterClass! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 00:40'!
readableFileNames
	^ self allFileNames select: [:ea | self canReadFileNamed: ea]! !

!MCFileBasedRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 20:00'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	| version |
	(self allFileNamesForVersionNamed: aVersionInfo name) do:
		[:fileName |
		version _ self loadVersionFromFileNamed: fileName.
		version info = aVersionInfo ifTrue: [^ version]].
	^ errorBlock value! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:36'!
= other
	^ other species = self species and: [other description = self description]! !

!MCRepository methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 15:53'!
storeVersion: aVersion
	self subclassResponsibility ! !

Object subclass: #MCReader
	instanceVariableNames: 'stream package info definitions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCReader methodsFor: 'accessing' stamp: 'ab 8/20/2003 19:53'!
definitions
	definitions ifNil: [self loadDefinitions].
	^ definitions! !

!MCReader methodsFor: 'accessing' stamp: 'ab 8/20/2003 19:53'!
package
	package ifNil: [self loadPackage].
	^ package! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 8/4/2003 00:37'!
readerClassForFileNamed: fileName
	^ self concreteSubclasses
		detect: [:c | c canReadFileNamed: fileName]
		ifNone: [nil]! !

!MCReader methodsFor: 'accessing' stamp: 'cwp 7/29/2003 00:03'!
stream: aStream
	stream _ aStream! !

!MCReader class methodsFor: 'reading' stamp: 'ab 8/18/2003 00:45'!
versionInfoFromStream: aStream
	^ self supportsVersions 
		ifTrue: [(self on: aStream) info]
		ifFalse: [self error: 'This file format doesn''t support versions']! !

!MCReader class methodsFor: 'file services' stamp: 'cwp 8/1/2003 14:33'!
unload
	FileList unregisterFileReader: self ! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 8/4/2003 00:32'!
canReadFileNamed: fileName
	^ (fileName endsWith: self extension)! !

MCReader subclass: #MCMczReader
	instanceVariableNames: 'zip '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMczReader class methodsFor: 'accessing' stamp: 'cwp 8/1/2003 14:59'!
extension
	^ 'mcz'! !

!MCMczReader class methodsFor: 'testing' stamp: 'cwp 8/1/2003 12:19'!
supportsVersions
	^ true! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 19:58'!
loadDefinitions
	definitions _ OrderedCollection new.
	(self zip membersMatching: 'snapshot/*')
		do: [:m | self extractDefinitionsFrom: m].
	definitions _ definitions asArray.
! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'nk 8/17/2003 20:08'!
extractInfoFrom: dict
	^ MCVersionInfo
		name: (dict at: #name)
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message)
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author)
		ancestors: ((dict at: #ancestors) collect: [:ea | self extractInfoFrom: ea]).
	! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2003 00:43'!
extractDefinitionsFrom: member
	| reader |
	(MCReader readerClassForFileNamed: member fileName)
		ifNotNilDo: [:rc | reader _ rc on: member contentStream text.
					definitions addAll: reader definitions]
! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 01:47'!
scanner
	^ Scanner new! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 01:55'!
associate: tokens
	| result |
	result _ Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value _ value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'ab 8/18/2003 00:50'!
parseMember: fileName
	| tokens |
	tokens _ (self scanner scanTokens: (self zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 19:58'!
loadVersionInfo
	info _ self extractInfoFrom: (self parseMember: 'version')! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 19:58'!
loadPackage
	| dict |
	dict _ self parseMember: 'package'.
	package _ MCPackage named: (dict at: #name)! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'ab 8/18/2003 00:50'!
zip
	zip ifNil:
		[zip _ ZipArchive new.
		zip readFrom: stream].
	^ zip! !

!MCReader class methodsFor: 'file services' stamp: 'cwp 8/1/2003 14:46'!
openVersionFile: fileName
	(self versionFromFile: fileName) open! !

!MCReader class methodsFor: 'file services' stamp: 'cwp 8/1/2003 14:47'!
loadSnapshotFile: fileName
	| reader |
	reader _ self on: (FileStream readOnlyFileNamed: fileName).
	(reader snapshot) updatePackage: (reader package)
! !

!MCReader methodsFor: 'lifecycle' stamp: 'cwp 8/3/2003 18:48'!
initialize! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 8/1/2003 14:39'!
suppliesFileReaderServices
	^ self supportsPackageName ! !

!MCReader class methodsFor: 'file services' stamp: 'nk 8/24/2003 00:15'!
serviceLoadVersion
	^ SimpleServiceEntry
		provider: self
		label: 'load version'
		selector: #loadVersionFile:
		description: 'load a package version'
		buttonLabel: 'loadV'! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 8/4/2003 00:38'!
concreteSubclasses
	^ self allSubclasses reject: [:c | c isAbstract]! !

!MCReader class methodsFor: 'file services' stamp: 'nk 8/23/2003 23:56'!
initialize
	"MCReader initialize"
	FileList unregisterFileReader: MCBootstrapLoader.
	FileList unregisterFileReader: self.
	Smalltalk 
		at: #MczInstaller
		ifPresent: [:installer | FileList unregisterFileReader: installer].
	self allSubclasses do: [:aClass | (aClass suppliesFileReaderServices) 
							ifTrue: [FileList registerFileReader: aClass]]! !

!MCReader methodsFor: 'accessing' stamp: 'ab 8/20/2003 19:54'!
snapshot
	^ MCSnapshot fromDefinitions: self definitions! !

!MCReader methodsFor: 'loading' stamp: 'ab 8/20/2003 19:54'!
loadDefinitions
	self subclassResponsibility ! !

!MCReader methodsFor: 'loading' stamp: 'ab 8/20/2003 19:54'!
loadPackage
	self subclassResponsibility ! !

!MCReader class methodsFor: 'instance creation' stamp: 'cwp 7/30/2003 03:01'!
on: aStream
	^ self new stream: aStream! !

!MCReader methodsFor: 'accessing' stamp: 'ab 8/20/2003 19:53'!
info
	info ifNil: [self loadVersionInfo].
	^ info! !

!MCReader methodsFor: 'loading' stamp: 'ab 8/20/2003 19:54'!
loadVersionInfo
	self subclassResponsibility! !

!MCReader class methodsFor: 'instance creation' stamp: 'cwp 8/3/2003 18:49'!
new
	^ self basicNew initialize! !

!MCReader class methodsFor: 'file services' stamp: 'cwp 8/1/2003 14:46'!
mergeVersionFile: fileName
	(self versionFromFile: fileName) merge! !

!MCReader class methodsFor: 'reading' stamp: 'cwp 7/31/2003 23:03'!
versionFromFile: fileName
	^ self file: fileName streamDo: [:stream | self versionFromStream: stream]! !

!MCReader class methodsFor: 'file services' stamp: 'nk 8/24/2003 00:15'!
serviceLoadSnapshot
	^ SimpleServiceEntry
		provider: self
		label: 'load snapshot'
		selector: #loadSnapshotFile:
		description: 'load a package snapshot'
		buttonLabel: 'loadS'! !

!MCReader class methodsFor: 'reading' stamp: 'cwp 7/31/2003 23:04'!
snapshotFromFile: fileName
	^ self file: fileName streamDo: [:stream | self snapshotFromStream: stream]! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 7/31/2003 22:48'!
supportsPackageName
	^ self supportsVersions! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 8/4/2003 00:33'!
canReadFileStream: aFileStream
	^ self canReadFileNamed: aFileStream name! !

!MCReader class methodsFor: 'reading' stamp: 'cwp 7/31/2003 22:45'!
versionFromStream: aStream
	^ self supportsVersions 
		ifTrue: [(self on: aStream) version]
		ifFalse: [self error: 'This file format doesn''t support versions']! !

!MCReader class methodsFor: 'file services' stamp: 'cwp 8/1/2003 14:46'!
loadVersionFile: fileName
	(self versionFromFile: fileName) load
! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 7/31/2003 17:45'!
isAbstract
	^ (self respondsTo: #extension) not! !

!MCReader class methodsFor: 'instance creation' stamp: 'cwp 8/4/2003 00:54'!
on: aStream name: aFileName
	| class |
	class _ self readerClassForFileNamed: aFileName.
	^ class
		ifNil: [self error: 'Unsupported format: ', aFileName]
		ifNotNil: [class on: aStream]! !

!MCReader class methodsFor: 'reading' stamp: 'cwp 7/30/2003 03:00'!
snapshotFromStream: aStream
	^ (self on: aStream) snapshot.! !

!MCReader methodsFor: 'accessing' stamp: 'avi 8/31/2003 16:33'!
version
	^ MCVersion withInfo: self info ifAbsent: [self basicVersion]! !

!MCReader class methodsFor: 'file services' stamp: 'nk 8/24/2003 00:06'!
fileReaderServicesForFile: fullName suffix: suffix
	^ ((suffix = self extension) or: [ suffix = '*' ])
		ifTrue: [self services]
		ifFalse: [Array new: 0]
		! !

!MCReader class methodsFor: 'reading' stamp: 'cwp 7/31/2003 23:02'!
file: fileName streamDo: aBlock
	| file |
	^ 	[file _ FileStream readOnlyFileNamed: fileName.
		aBlock value: file]
			ensure: [file close]! !

MCReader subclass: #MCChunkReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCChunkReader methodsFor: 'reading' stamp: 'ab 8/20/2003 19:59'!
read
	self nextDefinition ifNotNilDo: [:next | definitions add: next]! !

!MCChunkReader methodsFor: 'errors' stamp: 'cwp 8/1/2003 22:04'!
unknownReceiver
	^ self error: 'Unknown Receiver'.! !

!MCChunkReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 20:15'!
untilStreamEndDo: aBlock
	stream
		untilEnd: aBlock
		displayingProgress: 'Reading definitions...'.! !

!MCChunkReader methodsFor: 'accessing' stamp: 'cwp 8/9/2003 12:09'!
stream: aStream
	stream _ aStream isMessageStream
		ifTrue: [aStream]
		ifFalse: [MCMessageStream on: aStream]
	 ! !

MCChunkReader subclass: #MCStReader
	instanceVariableNames: 'namespace context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCStReader methodsFor: 'evaluating' stamp: 'ab 8/17/2003 17:00'!
read
	context 
		ifNil: [self nextDefinition]
		ifNotNil: [context evaluateChunk: stream nextChunk]	! !

!MCStReader methodsFor: 'evaluating' stamp: 'cwp 8/3/2003 19:42'!
nameForContext: aContext
	^ namespace keyAtValue: aContext! !

!MCStReader methodsFor: 'evaluating' stamp: 'ab 8/20/2003 19:56'!
collectDefinitions
	definitions _ OrderedCollection new.
	"I send #values here because of an odd heisenbug where #do: wasn't iterating over every value"
	namespace values do: [:ea |  ea addDefinitionsTo: definitions.]! !

!MCStReader methodsFor: 'reading' stamp: 'cwp 8/3/2003 21:34'!
clearContext
	context _ nil! !

!MCStReader class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 18:44'!
extension
	^ 'st'! !

!MCStReader methodsFor: 'lifecycle' stamp: 'cwp 8/3/2003 19:03'!
initialize
	namespace _ Dictionary new.
	namespace at: #SystemOrganization put: MCSystemContext new.! !

!MCStReader methodsFor: 'evaluating' stamp: 'cwp 8/3/2003 19:18'!
context: anStContext
	context _ anStContext! !

!MCStReader methodsFor: 'evaluating' stamp: 'ab 8/20/2003 20:09'!
loadDefinitions
	super loadDefinitions.
	self collectDefinitions! !

!MCStReader methodsFor: 'evaluating' stamp: 'cwp 8/3/2003 19:45'!
resolve: aSymbol
	^ namespace 
		at: aSymbol 
		ifAbsentPut: [MCClassContext forReader: self]! !

MCChunkReader subclass: #MCMcReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMcReader methodsFor: 'evaluating' stamp: 'cwp 8/1/2003 23:49'!
resolve: aSymbol
	aSymbol = #MCRevisionInfo ifTrue: [^ self].
	^ Smalltalk at: (self convertSymbol: aSymbol) ifAbsent: [self unknownReceiver]! !

!MCMcReader methodsFor: 'defining' stamp: 'cwp 8/1/2003 23:45'!
packageName: aString
	package _ MCPackage named: aString.
	^ nil! !

!MCMcReader methodsFor: 'evaluating' stamp: 'cwp 8/1/2003 23:08'!
convertSymbol: aSymbol
	^ (aSymbol copyReplaceAll: 'Declaration' with: 'Definition') asSymbol! !

!MCMcReader class methodsFor: 'accessing' stamp: 'cwp 7/31/2003 22:50'!
extension
	^ 'mc'! !

!MCMcReader class methodsFor: 'testing' stamp: 'cwp 7/31/2003 22:46'!
supportsPackageName
	^ true! !

!MCChunkReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 20:16'!
loadVersionInfo
	stream reset.
	self consumeStream! !

!MCChunkReader methodsFor: 'reading' stamp: 'cwp 8/1/2003 23:15'!
resolve: aSymbol
	^ Smalltalk at: aSymbol ifAbsent: [self unknownReceiver]! !

!MCChunkReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 20:15'!
loadDefinitions
	stream reset.
	self consumeStream! !

!MCChunkReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 20:16'!
consumeStream
	definitions _ OrderedCollection new.
	self untilStreamEndDo: [self read]
	! !

!MCChunkReader methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 20:15'!
loadPackage
	stream reset.
	self consumeStream! !

MCChunkReader subclass: #MCMcvReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMcvReader class methodsFor: 'accessing' stamp: 'cwp 7/31/2003 17:47'!
extension
	^ 'mcv'! !

!MCMcvReader class methodsFor: 'testing' stamp: 'cwp 7/31/2003 19:25'!
supportsVersions
	^ true! !

!MCMcvReader methodsFor: 'reading' stamp: 'ab 8/20/2003 20:22'!
loadVersionInfo
	self loadPackage.
	self nextDefinition.! !

!MCMcvReader methodsFor: 'defining' stamp: 'cwp 8/1/2003 23:25'!
resolve: aSymbol
	aSymbol = #MCPackage ifTrue: [^ self].
	aSymbol = #MCVersionInfo ifTrue: [^ self].
	^ super resolve: aSymbol! !

!MCMcvReader methodsFor: 'defining' stamp: 'cwp 7/31/2003 15:09'!
named: aPackageName
	package _ MCPackage named: aPackageName.
	^ nil! !

!MCMcvReader methodsFor: 'defining' stamp: 'cwp 7/31/2003 15:09'!
fromArray: anArray
	info _ MCVersionInfo fromArray: anArray.
	^ nil! !

!MCMcvReader methodsFor: 'reading' stamp: 'ab 8/20/2003 20:23'!
loadPackage
	stream reset.
	self nextDefinition.! !

!MCChunkReader methodsFor: 'errors' stamp: 'cwp 8/1/2003 22:02'!
syntaxError
	^ self error: 'Syntax Error'! !

!MCChunkReader methodsFor: 'reading' stamp: 'cwp 8/8/2003 23:55'!
handleMessage: aMessageSend
	aMessageSend resolveReceiverIn: self.
	aMessageSend workAroundBugs.
	^ aMessageSend value.! !

!MCChunkReader methodsFor: 'reading' stamp: 'cwp 8/9/2003 02:49'!
nextDefinition
	^ stream next ifNotNilDo: [:message | self handleMessage: message]
! !

!MCReader methodsFor: 'accessing' stamp: 'avi 8/31/2003 16:33'!
basicVersion
	^ MCVersion
		package: self package
		info: self info
		snapshot: self snapshot! !

!MCReader class methodsFor: 'testing' stamp: 'cwp 7/31/2003 22:44'!
supportsVersions
	^ false! !

!MCReader class methodsFor: 'file services' stamp: 'nk 8/24/2003 00:15'!
serviceMergeVersion
	^ SimpleServiceEntry
		provider: self
		label: 'merge version'
		selector: #mergeVersionFile:
		description: 'merge a package version into the image'
		buttonLabel: 'merge'! !

!MCReader class methodsFor: 'file services' stamp: 'nk 8/24/2003 00:15'!
serviceOpenVersion
	^ SimpleServiceEntry
		provider: self
		label: 'open version'
		selector: #openVersionFile:
		description: 'open a package version'
		buttonLabel: 'open'! !

!MCReader class methodsFor: 'file services' stamp: 'cwp 8/1/2003 14:43'!
services
	^ self supportsVersions 
		ifTrue: [Array 
					with: self serviceLoadVersion
					with: self serviceMergeVersion
					with: self serviceOpenVersion]
		ifFalse: [Array with: self serviceLoadSnapshot]! !

Object variableWordSubclass: #MCMockClassG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

Object subclass: #MCDefinition
	instanceVariableNames: ''
	classVariableNames: 'Instances '
	poolDictionaries: ''
	category: 'Monticello-Base'!

!MCDefinition methodsFor: 'accessing' stamp: 'ab 5/24/2003 14:12'!
requirements
	^ #()! !

MCDefinition subclass: #MCOrganizationDefinition
	instanceVariableNames: 'categories '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 13:39'!
categories: anArray
	categories _ anArray! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 19:48'!
postload
	SystemOrganization categories:
		(self reorderCategories: SystemOrganization categories)! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:25'!
= aDefinition
	^ (super = aDefinition)
		and: [categories = aDefinition categories]! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 7/11/2003 01:33'!
isOrganizationDefinition
	^ true! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:01'!
sortKey
	^ '<organization>'! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 13:51'!
categories
	^ categories! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'JF 7/23/2003 17:44'!
reorderCategories: allCategories
	| first |
	first _ allCategories detect: [:ea | categories includes: ea] ifNone: [^ allCategories].
	^ 	(allCategories copyUpTo: first),
		categories,
		((allCategories copyAfter: first) copyWithoutAll: categories)
! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 13:55'!
summary
	^ categories asArray printString! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 01:14'!
source
	^ String streamContents:
		[:s |
		categories do: [:ea | s nextPutAll: ea] separatedBy: [s cr]]! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 13:46'!
description
	^ #organization! !

!MCOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 21:47'!
accept: aVisitor
	^ aVisitor visitOrganizationDefinition: self! !

!MCOrganizationDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:06'!
categories: anArray
	^ self instanceLike: (self new categories: anArray)! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:14'!
hash
	^ self description hash! !

!MCDefinition methodsFor: 'annotations' stamp: 'nk 7/24/2003 12:26'!
annotations: requests
	"Answer a string for an annotation pane, trying to fulfill the annotation requests.
	These might include anything that
		Preferences defaultAnnotationRequests 
	might return. Which includes anything in
		Preferences annotationInfo
	To edit these, use:"
	"Preferences editAnnotations"

	^String streamContents: [ :s | self printAnnotations: requests on: s ].! !

!MCDefinition methodsFor: 'installing' stamp: 'ab 7/18/2003 19:48'!
postload! !

!MCDefinition methodsFor: 'printing' stamp: 'ab 7/18/2003 19:43'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self summary, ')'! !

!MCDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 18:17'!
instanceLike: aDefinition
	Instances ifNil: [Instances _ WeakSet new. WeakArray addWeakDependent: Instances].
	^ (Instances like: aDefinition) ifNil: [Instances add: aDefinition]! !

!MCDefinition methodsFor: 'testing' stamp: 'cwp 7/11/2003 01:32'!
isOrganizationDefinition
	^false! !

MCDefinition subclass: #MCMethodDefinition
	instanceVariableNames: 'classIsMeta source category selector className timeStamp '
	classVariableNames: 'Definitions '
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCMethodDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:01'!
sortKey
	^ self className, '.', (self classIsMeta ifTrue: ['meta'] ifFalse: ['nonmeta']), '.', self selector! !

!MCMethodDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 18:15'!
forMethodReference: aMethodReference
	| definition |
	definition _ self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition category ~= aMethodReference category]
		or: [definition className ~= aMethodReference classSymbol]
		or: [definition classIsMeta ~= aMethodReference classIsMeta]
		or: [definition selector ~= aMethodReference methodSymbol])
			ifTrue: [definition _ self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference source.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition
	! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 11/15/2002 01:12'!
actualClass
	^Smalltalk at: className
		ifPresent: [:class | classIsMeta ifTrue: [class class] ifFalse: [class]]! !

!MCMethodDefinition methodsFor: 'testing' stamp: 'ab 12/4/2002 21:52'!
isMethodDefinition
	^true! !

!MCMethodDefinition methodsFor: 'installing' stamp: 'ab 8/8/2003 17:05'!
postload
	self isInitializer ifTrue: [self actualClass theNonMetaClass initialize]! !

!MCMethodDefinition methodsFor: 'testing' stamp: 'ab 5/24/2003 13:49'!
isCodeDefinition
	^ true! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 1/15/2003 13:42'!
timeStamp
	^ timeStamp! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'cwp 11/25/2002 07:26'!
classIsMeta
	^ classIsMeta! !

!MCMethodDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 18:14'!
initialize
	Smalltalk addToShutDownList: self! !

!MCMethodDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 18:14'!
shutDown
	WeakArray removeWeakDependent: Definitions.
	Definitions _ nil.! !

!MCMethodDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 18:15'!
cachedDefinitions
	Definitions ifNil: [Definitions _ WeakIdentityKeyDictionary new.  WeakArray addWeakDependent: Definitions].
	^ Definitions! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 11/13/2002 01:59'!
source
	^ source! !

!MCMethodDefinition methodsFor: 'comparing' stamp: 'ab 5/24/2003 14:11'!
requirements
	^ Array with: className! !

!MCMethodDefinition methodsFor: 'installing' stamp: 'ab 11/15/2002 01:11'!
unload
	self actualClass ifNotNilDo: [:class | class removeSelector: selector]! !

!MCMethodDefinition methodsFor: 'printing' stamp: 'ab 4/8/2003 18:05'!
fullClassName
	^ self classIsMeta
		ifFalse: [self className]
		ifTrue: [self className, ' class']! !

!MCMethodDefinition methodsFor: 'testing' stamp: 'ab 8/8/2003 17:05'!
isInitializer
	^ selector = #initialize and: [classIsMeta]
	! !

!MCMethodDefinition methodsFor: 'comparing' stamp: 'ab 8/22/2003 17:48'!
hash
	| hash |
	hash _ String stringHash: classIsMeta asString initialHash: 0.
	hash _ String stringHash: source initialHash: hash.
	hash _ String stringHash: category initialHash: hash.
	hash _ String stringHash: className initialHash: hash.
	^ hash! !

!MCMethodDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:05'!
className: classString
classIsMeta: metaBoolean
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	^ self instanceLike:
		(self new initializeWithClassName: classString
					classIsMeta: metaBoolean
					selector: selectorString
					category: catString
					timeStamp: timeString
					source: sourceString)! !

!MCMethodDefinition methodsFor: 'printing' stamp: 'ab 12/5/2002 21:25'!
description
	^ Array	
		with: className
		with: selector
		with: classIsMeta! !

!MCMethodDefinition methodsFor: 'printing' stamp: 'ab 4/8/2003 18:04'!
summary
	^ self fullClassName , '>>' , selector! !

!MCMethodDefinition methodsFor: 'visiting' stamp: 'ab 7/18/2003 21:47'!
accept: aVisitor
	^ aVisitor visitMethodDefinition: self! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 11/15/2002 01:12'!
className
	^className! !

!MCMethodDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 4/1/2003 01:40'!
className: classString
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	^ self	className: classString
			classIsMeta: false
			selector: selectorString
			category: catString
			timeStamp: timeString
			source: sourceString! !

!MCMethodDefinition methodsFor: 'serializing' stamp: 'nk 6/21/2003 08:38'!
initializeWithClassName: classString
classIsMeta: metaBoolean
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	className _ classString asSymbol.
	selector _ selectorString asSymbol.
	category _ catString asSymbol.
	timeStamp _ timeString.
	classIsMeta _ metaBoolean.
	source _ sourceString withSqueakLineEndings.
! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 5/6/2003 17:14'!
load
	self actualClass ifNotNilDo:
		[:class |
		class
			compile: source
			classified: category
			withStamp: timeStamp
			notifying: (SyntaxError new category: category)]! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 11/15/2002 01:11'!
selector
	^selector! !

!MCMethodDefinition methodsFor: 'comparing' stamp: 'ab 8/22/2003 17:49'!
= aDefinition
	^(super = aDefinition)
		and: [aDefinition source = self source]
		and: [aDefinition category = self category]
		and: [aDefinition timeStamp = self timeStamp]! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'ab 11/13/2002 01:59'!
category
	^ category! !

!MCMethodDefinition methodsFor: 'annotations' stamp: 'nk 7/24/2003 16:06'!
printAnnotations: requests on: aStream
	"Add a string for an annotation pane, trying to fulfill the annotation requests.
	These might include anything that
		Preferences defaultAnnotationRequests 
	might return. Which includes anything in
		Preferences annotationInfo
	To edit these, use:"
	"Preferences editAnnotations"

	requests do: [ :aRequest |
		aRequest == #timeStamp ifTrue: [ aStream nextPutAll: self timeStamp ].
		aRequest == #messageCategory ifTrue: [ aStream nextPutAll: self category ].
		aRequest == #requirements ifTrue: [
			self requirements do: [ :req |
				aStream nextPutAll: req ] separatedBy: [ aStream space ]].
	] separatedBy: [ aStream space ].! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 12/5/2002 21:24'!
isRevisionOf: aDefinition
	^ aDefinition description = self description! !

!MCDefinition methodsFor: 'installing' stamp: 'ab 7/18/2003 21:31'!
load
	! !

!MCDefinition methodsFor: 'testing' stamp: 'ab 12/4/2002 21:51'!
isClassDefinition
	^false! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:04'!
sortKey
	self subclassResponsibility ! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:24'!
= aDefinition
	^ self isRevisionOf: aDefinition! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:25'!
isSameRevisionAs: aDefinition
	^ self = aDefinition! !

!MCDefinition methodsFor: 'printing' stamp: 'ab 7/19/2003 18:23'!
summary
	self subclassResponsibility ! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 17:59'!
<= other
	^ self sortKey <= other sortKey! !

!MCDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 18:17'!
clearInstances
	WeakArray removeWeakDependent: Instances.
	Instances _ nil! !

!MCDefinition methodsFor: 'installing' stamp: 'ab 11/14/2002 00:08'!
unload! !

!MCDefinition methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:14'!
description
	self subclassResponsibility! !

MCDefinition subclass: #MCMockDefinition
	instanceVariableNames: 'token '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
token: aString

	token _ aString! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
printString

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
token

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:25'!
= definition
	^definition token = token! !

!MCMockDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
token: aString

	^ self new token: aString! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
hash

	^ token hash! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
description

	^ token first! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
summary

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
asString

	^ token! !

!MCMockDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:46'!
wantsChangeSetLogging
	^ false! !

!MCDefinition methodsFor: 'testing' stamp: 'ab 12/4/2002 21:51'!
isMethodDefinition
	^false! !

!MCDefinition methodsFor: 'accessing' stamp: 'ab 5/24/2003 14:12'!
provisions
	^ #()! !

!MCDefinition methodsFor: 'annotations' stamp: 'nk 7/24/2003 12:27'!
annotations
	^self annotations: Preferences defaultAnnotationRequests! !

MCDefinition subclass: #MCClassDefinition
	instanceVariableNames: 'name superclassName variables category type comment commentStamp '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassDefinition methodsFor: 'testing' stamp: 'cwp 8/10/2003 17:01'!
hasComment
	^ comment notNil and: [comment ~= '']! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 7/7/2003 23:32'!
classInstVarNames
	^ self selectVariables: #isClassInstanceVariable! !

!MCClassDefinition methodsFor: 'comparing' stamp: 'ab 5/24/2003 14:12'!
provisions
	^ Array with: name! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 7/7/2003 23:53'!
poolDictionaries
	^ self selectVariables: #isPoolImport! !

!MCClassDefinition methodsFor: 'visiting' stamp: 'ab 7/18/2003 21:48'!
accept: aVisitor
	^ aVisitor visitClassDefinition: self! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 11/24/2002 06:23'!
category
	^ category! !

!MCClassDefinition methodsFor: 'serializing' stamp: 'cwp 8/10/2003 16:34'!
initializeWithName: nameString
superclassName: superclassString
category: categoryString 
instVarNames: ivarArray
classVarNames: cvarArray
poolDictionaryNames: poolArray
classInstVarNames: civarArray
type: typeSymbol
comment: commentString
commentStamp: stampStringOrNil
	name _ nameString asSymbol.
	superclassName _ superclassString asSymbol.
	category _ categoryString.
	type _ typeSymbol.
	comment _ commentString withSqueakLineEndings.
	commentStamp _ stampStringOrNil ifNil: [self defaultCommentStamp].
	variables _ OrderedCollection  new.
	self addVariables: ivarArray ofType: MCInstanceVariableDefinition.
	self addVariables: cvarArray ofType: MCClassVariableDefinition.
	self addVariables: poolArray ofType: MCPoolImportDefinition.
	self addVariables: civarArray ofType: MCClassInstanceVariableDefinition.! !

!MCClassDefinition methodsFor: 'installing' stamp: 'ab 5/6/2003 17:17'!
createClass
	^ Smalltalk at: superclassName ifPresent:
		[:superClass |
		(ClassBuilder new)
			name: name 
			inEnvironment: superClass environment 
			subclassOf: superClass 
			type: type 
			instanceVariableNames: self instanceVariablesString 
			classVariableNames: self classVariablesString 
			poolDictionaries: self sharedPoolsString
			category: category]
! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 7/7/2003 23:54'!
sharedPoolsString
	^ self stringForVariablesOfType: #isPoolImport! !

!MCClassDefinition methodsFor: 'installing' stamp: 'cwp 7/7/2003 23:37'!
stringForVariablesOfType: aSymbol
	^ String streamContents:
		[:stream |
		(self selectVariables: aSymbol) do: [:ea | stream nextPutAll: ea; space]]! !

!MCClassDefinition methodsFor: 'comparing' stamp: 'ab 5/24/2003 14:12'!
requirements
	^ Array with: superclassName! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'ab 11/13/2002 17:41'!
superclassName
	^ superclassName! !

!MCClassDefinition methodsFor: 'comparing' stamp: 'cwp 11/25/2002 06:55'!
hash
	| hash |
	hash _ String stringHash: name initialHash: 0.
	hash _ String stringHash: superclassName initialHash: hash.
	hash _ String stringHash: category initialHash: hash.
	hash _ String stringHash: type initialHash: hash.
	variables do: [
		:v |
		hash _ String stringHash: v name initialHash: hash.
	].
	^ hash! !

!MCClassDefinition methodsFor: 'testing' stamp: 'ab 5/24/2003 13:49'!
isCodeDefinition
	^ true! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 7/7/2003 23:33'!
classVarNames
	^ self selectVariables: #isClassVariable! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 11/24/2002 22:16'!
kindOfSubclass
	type = #normal ifTrue: [^ ' subclass: '].
	type = #words ifTrue: [^ ' variableWordSubclass: '].
	type = #variable ifTrue: [^ ' variableSubclass: '].
	type = #bytes ifTrue: [^ ' variableByteSubclass: '].
	type = #weak ifTrue: [^ ' weakSubclass: ' ].
	type = #compiledMethod ifTrue: [^ ' variableByteSubclass: ' ].
	self error: 'Unrecognized class type'! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'ab 12/5/2002 21:24'!
description
	^ Array with: name
! !

!MCClassDefinition methodsFor: 'testing' stamp: 'cwp 8/2/2003 02:54'!
hasClassInstanceVariables
	^ (self selectVariables: #isClassInstanceVariable) isEmpty not! !

!MCClassDefinition class methodsFor: 'obsolete' stamp: 'cwp 8/10/2003 16:33'!
name: nameString
superclassName: superclassString
category: categoryString 
instVarNames: ivarArray
classVarNames: cvarArray
poolDictionaryNames: poolArray
classInstVarNames: civarArray
type: typeSymbol
comment: commentString
	^ self 
		name: nameString
		superclassName: superclassString
		category: categoryString 
		instVarNames: ivarArray
		classVarNames: cvarArray
		poolDictionaryNames: poolArray
		classInstVarNames: civarArray
		type: typeSymbol
		comment: commentString
		commentStamp: nil! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 7/7/2003 23:33'!
instVarNames
	^ self selectVariables: #isInstanceVariable! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 7/7/2003 23:35'!
instanceVariablesString
	^ self stringForVariablesOfType: #isInstanceVariable! !

!MCClassDefinition methodsFor: 'comparing' stamp: 'cwp 8/12/2003 02:35'!
= aDefinition
	^ ((super = aDefinition)
		and: [superclassName = aDefinition superclassName]
		and: [category = aDefinition category]
		and: [type = aDefinition type])
		and: [variables = aDefinition variables]
		and: [comment = aDefinition comment]
		! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 7/10/2003 01:29'!
source
	^ self definitionString! !

!MCClassDefinition methodsFor: 'testing' stamp: 'ab 12/4/2002 21:52'!
isClassDefinition
	^ true! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'ab 7/19/2003 18:00'!
sortKey
	^ self className! !

!MCClassDefinition class methodsFor: 'instance creation' stamp: 'cwp 8/10/2003 16:30'!
name: nameString
superclassName: superclassString
category: categoryString 
instVarNames: ivarArray
classVarNames: cvarArray
poolDictionaryNames: poolArray
classInstVarNames: civarArray
type: typeSymbol
comment: commentString
commentStamp: stampString
	^ self instanceLike:
		(self new initializeWithName: nameString
					superclassName: superclassString
					category: categoryString 
					instVarNames: ivarArray
					classVarNames: cvarArray
					poolDictionaryNames: poolArray
					classInstVarNames: civarArray
					type: typeSymbol
					comment: commentString
					commentStamp: stampString)! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 7/7/2003 23:36'!
classVariablesString
	^ self stringForVariablesOfType: #isClassVariable! !

!MCClassDefinition class methodsFor: 'obsolete' stamp: 'ab 4/1/2003 01:22'!
name: nameString
superclassName: superclassString
category: categoryString 
instVarNames: ivarArray
classVarNames: cvarArray
poolDictionaryNames: poolArray
classInstVarNames: civarArray
comment: commentString
	^ self	name: nameString
			superclassName: superclassString
			category: categoryString 
			instVarNames: ivarArray
			classVarNames: cvarArray
			poolDictionaryNames: poolArray
			classInstVarNames: civarArray
			type: #normal
			comment: commentString
! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 8/2/2003 02:03'!
definitionString
	^ String streamContents: [:stream | self printDefinitionOn: stream]! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 8/10/2003 16:40'!
commentStamp
	^ commentStamp! !

!MCClassDefinition methodsFor: 'installing' stamp: 'cwp 8/10/2003 17:03'!
load
	 self createClass ifNotNilDo:
		[:class |
		class class instanceVariableNames: self classInstanceVariablesString.
		self hasComment ifTrue: [class classComment: comment stamp: commentStamp]]! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 7/7/2003 23:28'!
selectVariables: aSelector
	^ variables select: [:v | v perform: aSelector] thenCollect: [:v | v name]! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 11/24/2002 22:35'!
type
	^ type! !

!MCClassDefinition methodsFor: 'installing' stamp: 'ab 11/13/2002 19:39'!
unload
	Smalltalk removeClassNamed: name! !

!MCClassDefinition methodsFor: 'printing' stamp: 'ab 11/16/2002 17:33'!
summary
	^ name! !

!MCClassDefinition methodsFor: 'initializing' stamp: 'cwp 8/10/2003 17:39'!
defaultCommentStamp
	^ String new

	"The version below avoids stomping on stamps already in the image

	^ (Smalltalk at: name ifPresent: [:c | c organization commentStamp])
		ifNil: ['']
	"
! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'ab 11/13/2002 01:52'!
className
	^ name! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'ab 1/15/2003 13:42'!
comment
	^ comment! !

!MCClassDefinition class methodsFor: 'obsolete' stamp: 'ab 4/1/2003 01:22'!
name: nameString
superclassName: superclassString
category: categoryString 
instVarNames: ivarArray
comment: commentString
	^ self	name: nameString
			superclassName: superclassString
			category: categoryString 
			instVarNames: ivarArray
			classVarNames: #()
			poolDictionaryNames: #()
			classInstVarNames: #()
			comment: commentString
! !

!MCClassDefinition methodsFor: 'initializing' stamp: 'cwp 7/7/2003 23:19'!
addVariables: aCollection ofType: aClass
	variables addAll: (aCollection collect: [:var | aClass name: var asString]).! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cwp 11/25/2002 06:51'!
variables
	^ variables! !

!MCClassDefinition methodsFor: 'annotations' stamp: 'nk 7/24/2003 16:05'!
printAnnotations: requests on: aStream
	"Add a string for an annotation pane, trying to fulfill the annotation requests.
	These might include anything that
		Preferences defaultAnnotationRequests 
	might return. Which includes anything in
		Preferences annotationInfo
	To edit these, use:"
	"Preferences editAnnotations"

	requests do: [ :aRequest |
		aRequest == #requirements ifTrue: [
			self requirements do: [ :req | aStream nextPutAll: req ] separatedBy: [ aStream space ]]
	] separatedBy: [ aStream space ].! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 8/2/2003 02:03'!
printDefinitionOn: stream
		stream 
			nextPutAll: self superclassName;
			nextPutAll: self kindOfSubclass;
			nextPut: $# ;
			nextPutAll: self className;
			cr; tab;
			nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString;
			cr; tab;
			nextPutAll: 'classVariableNames: ';
			store: self classVariablesString;
			cr; tab;
			nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString;
			cr; tab;
			nextPutAll: 'category: ';
			store: self category asString! !

!MCClassDefinition methodsFor: 'printing' stamp: 'cwp 7/7/2003 23:35'!
classInstanceVariablesString
	^ self stringForVariablesOfType: #isClassInstanceVariable! !

!MCDefinition methodsFor: 'annotations' stamp: 'nk 7/24/2003 12:18'!
printAnnotations: requests on: aStream
	"Add a string for an annotation pane, trying to fulfill the annotation requests.
	These might include anything that
		Preferences defaultAnnotationRequests 
	might return. Which includes anything in
		Preferences annotationInfo
	To edit these, use:"
	"Preferences editAnnotations"

	self subclassResponsibility! !

Object subclass: #MCDependencySorter
	instanceVariableNames: 'required provided orderedItems '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!

!MCDependencySorter methodsFor: 'private' stamp: 'ab 5/22/2003 23:24'!
addRequirement: reqObject for: itemObject
	(self itemsRequiring: reqObject) add: itemObject! !

!MCDependencySorter methodsFor: 'private' stamp: 'ab 5/22/2003 23:25'!
addProvision: anObject
	| newlySatisfied |
	provided add: anObject.
	newlySatisfied _ required removeKey: anObject ifAbsent: [#()].
	self addAll: newlySatisfied.! !

!MCDependencySorter methodsFor: 'private' stamp: 'ab 5/22/2003 23:23'!
addRequirements: aCollection for: anObject
	aCollection do: [:ea | self addRequirement: ea for: anObject]! !

!MCDependencySorter class methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 15:16'!
sortItems: aCollection
	| sorter |
	sorter _ self items: aCollection.
	sorter externalRequirements do: [:req  | sorter addProvision: req].
	^ sorter orderedItems.! !

!MCDependencySorter methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:15'!
itemsWithMissingRequirements
	| items |
	items _ Set new.
	required do: [:ea | items addAll: ea].
	^ items
! !

!MCDependencySorter methodsFor: 'as yet unclassified' stamp: 'ab 5/22/2003 23:21'!
addAll: aCollection
	aCollection do: [:ea | self add: ea]! !

!MCDependencySorter methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:16'!
externalRequirements
	| unloaded |
	unloaded _ self itemsWithMissingRequirements.
	^ required keys reject: [:ea | unloaded anySatisfy: [:i | i provisions includes: ea]]! !

!MCDependencySorter methodsFor: 'as yet unclassified' stamp: 'ab 5/22/2003 23:23'!
initialize
	provided _ Set new.
	required _ Dictionary new.
	orderedItems _ OrderedCollection new.! !

!MCDependencySorter methodsFor: 'private' stamp: 'ab 5/22/2003 23:24'!
itemsRequiring: anObject
	^ required at: anObject ifAbsentPut: [Set new]! !

!MCDependencySorter methodsFor: 'as yet unclassified' stamp: 'ab 5/22/2003 23:25'!
orderedItems
	^ orderedItems! !

!MCDependencySorter class methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 14:17'!
items: aCollection
	^ self new addAll: aCollection! !

!MCDependencySorter methodsFor: 'private' stamp: 'ab 5/22/2003 23:22'!
unresolvedRequirementsFor: anItem
	^ anItem requirements difference: provided! !

!MCDependencySorter methodsFor: 'private' stamp: 'ab 5/22/2003 23:15'!
addToOrder: anItem
	orderedItems add: anItem.
	anItem provisions do: [:ea | self addProvision: ea].! !

!MCDependencySorter methodsFor: 'as yet unclassified' stamp: 'ab 5/22/2003 23:13'!
add: anItem
	| requirements |
	requirements _ self unresolvedRequirementsFor: anItem.
	requirements isEmpty
		ifTrue: [self addToOrder: anItem]
		ifFalse: [self addRequirements: requirements for: anItem]! !

!MCDependencySorter class methodsFor: 'as yet unclassified' stamp: 'ab 5/22/2003 23:22'!
new
	^ super new initialize! !

Object subclass: #MCMessageSpec
	instanceVariableNames: 'definition attributes message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 12:49'!
mockStream
	^ MCMockMessageStream on: (Array with: self message)! !

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 14:16'!
message
	^ message! !

!MCMessageSpec class methodsFor: 'instance creation' stamp: 'cwp 8/9/2003 13:38'!
forClassMethod: methSelector ofClass: aCharacter receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors
	^ self
		definition: (self mockClassMethodDefinitionForLetter: aCharacter selector: methSelector)
		receiver: aSymbol
		selector: aSelector
		attributes: anArrayOfSelectors! !

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 14:21'!
receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors
	attributes _ anArrayOfSelectors.
	self 
		receiver: aSymbol
		selector: aSelector
		arguments: (attributes collect: [:sel | definition perform: sel])! !

!MCMessageSpec class methodsFor: 'instance creation' stamp: 'cwp 8/9/2003 14:25'!
definition: aDefinition receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors arguments: anArray
	^ self new
		definition: aDefinition;
		attributes: anArrayOfSelectors;
		receiver: aSymbol selector: aSelector arguments: anArray! !

!MCMessageSpec class methodsFor: 'instance creation' stamp: 'cwp 8/9/2003 13:38'!
forClass: aCharacter receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors
	^ self 
		definition: (self mockClassDefinitionForLetter: aCharacter)
		receiver: aSymbol
		selector: aSelector
		attributes: anArrayOfSelectors! !

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 14:19'!
receiver: aSymbol selector: aSelector arguments: anArray
	message _ MCMessageSend
				receiver: aSymbol
				selector: aSelector
				arguments: anArray! !

!MCMessageSpec class methodsFor: 'definitions' stamp: 'cwp 8/9/2003 13:32'!
mockClassMethodDefinitionForLetter: aCharacter selector: selector
	^ (MethodReference
		class: (self mockClassForLetter: aCharacter) class
		selector: selector) asMethodDefinition! !

!MCMessageSpec class methodsFor: 'instance creation' stamp: 'cwp 8/9/2003 14:22'!
definition: aDefinition receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors
	^ self new
		definition: aDefinition;
		receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors! !

!MCMessageSpec class methodsFor: 'definitions' stamp: 'cwp 8/9/2003 12:39'!
mockClassDefinitionForLetter: aCharacter
	^ (self mockClassForLetter: aCharacter) asClassDefinition! !

!MCMessageSpec class methodsFor: 'instance creation' stamp: 'cwp 8/9/2003 13:38'!
forMethod: methSelector ofClass: aCharacter receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors
	^ self
		definition: (self mockMethodDefinitionForLetter: aCharacter selector: methSelector)
		receiver: aSymbol
		selector: aSelector
		attributes: anArrayOfSelectors! !

!MCMessageSpec class methodsFor: 'instance creation' stamp: 'cwp 8/9/2003 14:27'!
definition: aDefinition receiver: aSymbol selector: aSelector attributes: anArrayOfSelectors argument: anObject
	^ self 
		definition: aDefinition 
		receiver: aSymbol 
		selector: aSelector
		attributes: anArrayOfSelectors
		arguments: (Array with: anObject)! !

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:00'!
definition: aDefinition
	definition _ aDefinition! !

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 14:24'!
attributes: anArrayOfSelectors
	attributes _ anArrayOfSelectors! !

!MCMessageSpec methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:00'!
compare: result using: aTwoArgBlock
	attributes do: [:sel | | actual expected |
					actual _ result perform: sel.
					expected _ definition perform: sel.
					aTwoArgBlock value: actual value: expected]! !

!MCMessageSpec class methodsFor: 'definitions' stamp: 'cwp 8/9/2003 12:38'!
mockClassForLetter: aCharacter
	^ Smalltalk at: (('MCMockClass' copyWith: aCharacter) asSymbol)! !

!MCMessageSpec class methodsFor: 'definitions' stamp: 'cwp 8/9/2003 13:26'!
mockMethodDefinitionForLetter: aCharacter selector: selector
	^ (MethodReference
		class: (self mockClassForLetter: aCharacter)
		selector: selector) asMethodDefinition! !

Object subclass: #MCMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

MCMock subclass: #MCMockClassB
	instanceVariableNames: 'ivarb '
	classVariableNames: 'CVar '
	poolDictionaries: 'MCMockClassPoolDictionary '
	category: 'Monticello-Mocks'!

MCMockClassB class
	instanceVariableNames: 'ciVar '!

!MCMockClassB commentStamp: '' prior: 0!
This comment has a bang!! Bang!! Bang!!!

!MCMockClassB methodsFor: 'numeric' stamp: 'ab 7/7/2003 23:21'!
two

	^ 2! !

MCMock subclass: #MCMockDependentItem
	instanceVariableNames: 'name provides requires '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
provides: anArray

	provides _ anArray! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
name: aString

	name _ aString! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
requires: anArray

	requires _ anArray! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
requirements

	^ requires ifNil: [#()]! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
provisions

	^ provides ifNil: [#()]! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
name

	^ name! !

MCMock subclass: #MCMockClassA
	instanceVariableNames: 'ivar '
	classVariableNames: 'CVar '
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockClassA commentStamp: 'cwp 8/10/2003 16:43' prior: 0!
This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.!

!MCMockClassA methodsFor: 'boolean' stamp: 'cwp 7/13/2003 02:49'!
falsehood
	^ false! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:32'!
touchCVar
	CVar _ #touched! !

!MCMockClassA methodsFor: 'numeric' stamp: ''!
two
	^ 2! !

MCMockClassA subclass: #MCMockASubclass
	instanceVariableNames: 'x '
	classVariableNames: 'Y '
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockASubclass methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
variables
	^ x + Y + MCMockClassA! !

!MCMockASubclass methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
variables2
	^ ivar + CVar! !

!MCMockClassA methodsFor: 'boolean' stamp: ''!
truth
	^ true! !

!MCMockClassA methodsFor: 'as yet classified' stamp: ''!
d
	^ 'd'! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
one

	^ 1! !

!MCMockClassA methodsFor: 'boolean' stamp: 'ab 7/7/2003 23:21'!
moreTruth

	^ true! !

!MCMockClassA methodsFor: 'as yet classified' stamp: ''!
c
	^ 'c'! !

!MCMockClassA methodsFor: 'numeric' stamp: 'cwp 8/2/2003 17:26'!
one
	^ 1! !

!MCMockClassA methodsFor: 'as yet classified' stamp: ''!
a
	^ 'a'! !

!MCMockClassA methodsFor: 'as yet classified' stamp: ''!
b
	^ 'b'! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:31'!
cVar
	^ CVar! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:31'!
initialize
	CVar _ #initialized! !

!MCMock class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:40'!
wantsChangeSetLogging
	^ false! !

Object subclass: #MCClassContext
	instanceVariableNames: 'reader methodDict mode methodCategory stamp className superclassName ivars cvars pools classCategory type comment commentStamp '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCClassContext methodsFor: 'emulating' stamp: 'ab 8/8/2003 17:35'!
variableSubclass: classNameSymbol instanceVariableNames: ivarNames classVariableNames: cvarNames poolDictionaries: poolDicts category: catName
	self 
		createClass: classNameSymbol
		instanceVariableNames: ivarNames 
		classVariableNames: cvarNames 
		poolDictionaries: poolDicts 
		category: catName
		type: #variable! !

!MCClassContext methodsFor: 'testing' stamp: 'cwp 8/3/2003 20:29'!
classIsMeta
	^ self className endsWith: ' class'! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 20:45'!
scanVariableNames: names
	^ (names findTokens: $ ) collect: [:token | token asSymbol]! !

!MCClassContext methodsFor: 'emulating' stamp: 'cwp 8/3/2003 21:04'!
methodsFor: aMethodCategoryName stamp: aChangeStamp
	reader context: self.
	methodCategory _ aMethodCategoryName.
	stamp _ aChangeStamp.
	mode _ #handleMethod:
	! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:17'!
type: theType
	type _ theType! !

!MCClassContext methodsFor: 'emulating' stamp: 'ab 8/8/2003 17:35'!
subclass: classNameSymbol instanceVariableNames: ivarNames classVariableNames: cvarNames poolDictionaries: poolDicts category: catName
	self 
		createClass: classNameSymbol
		instanceVariableNames: ivarNames 
		classVariableNames: cvarNames 
		poolDictionaries: poolDicts 
		category: catName
		type: #normal! !

!MCClassContext methodsFor: 'emulating' stamp: 'ab 8/8/2003 17:32'!
variableWordSubclass: classNameSymbol instanceVariableNames: ivarNames classVariableNames: cvarNames poolDictionaries: poolDicts category: catName
	self 
		createClass: classNameSymbol 
		instanceVariableNames: ivarNames 
		classVariableNames: cvarNames 
		poolDictionaries: poolDicts 
		category: catName
		type: #words! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 23:53'!
reader: anStReader
	reader _ anStReader.! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 23:32'!
metaContext
	^ self isMetaClass 
		ifTrue: [self]
		ifFalse: [reader resolve: self metaClassName]
	! !

!MCClassContext methodsFor: 'reading' stamp: 'cwp 8/16/2003 23:36'!
evaluateChunk: aString
	(aString beginsWith: ']style[')
		ifFalse: [self perform: mode with: aString]! !

!MCClassContext methodsFor: 'emulating' stamp: 'ab 8/8/2003 17:32'!
variableByteSubclass: classNameSymbol instanceVariableNames: ivarNames classVariableNames: cvarNames poolDictionaries: poolDicts category: catName
	self 
		createClass: classNameSymbol 
		instanceVariableNames: ivarNames 
		classVariableNames: cvarNames 
		poolDictionaries: poolDicts 
		category: catName
		type: #bytes! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:43'!
metaClassName
	^ (self className, ' class') asSymbol! !

!MCClassContext methodsFor: 'reading' stamp: 'cwp 8/3/2003 21:56'!
handleMethod: aString
	| selector |
	aString isAllSeparators ifTrue: [^ self clearMode].
	selector _ self class parserClass new parseSelector: aString.
	methodDict 
		at: selector 
		put: (MCMethodDefinition
				className: self realClassName
				classIsMeta: self classIsMeta
				selector: selector
				category: methodCategory
				timeStamp: stamp
				source: aString)! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:17'!
superclassName: name
	superclassName _ name! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 20:46'!
category: aString
	classCategory _ aString! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:45'!
addDefinitionsTo: aCollection
	self classIsDefined ifTrue: [aCollection add: self classDefinition].
	aCollection addAll: methodDict! !

!MCClassContext methodsFor: 'lifecycle' stamp: 'cwp 8/3/2003 23:43'!
initialize
	"The end of .st files have DoIts that call class side #initialize methods.
	We ignore them here; they'll get called when the snapshot is installed."! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:25'!
classInstVarNames
	^ self metaContext instanceVariableNames! !

!MCClassContext class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 23:41'!
new
	^ self basicNew initializeContext! !

!MCClassContext methodsFor: 'reading' stamp: 'cwp 8/3/2003 21:37'!
clearMode
	reader clearContext.
	mode _ nil
! !

!MCClassContext methodsFor: 'emulating' stamp: 'cwp 8/3/2003 21:55'!
createClass: className instanceVariableNames: ivarNames classVariableNames: cvarNames poolDictionaries: poolDicts category: catName type: theType
	| context |
	context _ reader resolve: className.
	context
		superclassName: self realClassName;
		instanceVariableNames: ivarNames;
		classVariableNames: cvarNames;
		poolDictionaries: poolDicts;
		category: catName;
		type: theType.! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:46'!
classIsDefined
	^ superclassName notNil and: [self classIsMeta not]! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 23:51'!
lookUpClassName
	^ reader nameForContext: self! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/10/2003 17:49'!
classDefinition
	^ MCClassDefinition
		name: self className
		superclassName: superclassName
		category: classCategory
		instVarNames: ivars
		classVarNames: cvars
		poolDictionaryNames: pools
		classInstVarNames: self classInstVarNames
		type: type
		comment: comment
		commentStamp: commentStamp! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 20:46'!
instanceVariableNames: names
	ivars _ self scanVariableNames: names! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 20:46'!
poolDictionaries: names
	pools _ self scanVariableNames: names! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 21:25'!
instanceVariableNames
	^ ivars! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 23:53'!
className
	^ className ifNil: [className _ self lookUpClassName]! !

!MCClassContext methodsFor: 'lifecycle' stamp: 'cwp 8/3/2003 23:50'!
initializeContext
	methodDict _ Dictionary new.
	comment _ ''.
	ivars _ #()
! !

!MCClassContext methodsFor: 'reading' stamp: 'ab 8/17/2003 16:50'!
handleComment: aString
	comment _ aString.
	self clearMode.! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 20:45'!
classVariableNames: names
	cvars _ self scanVariableNames: names! !

!MCClassContext methodsFor: 'emulating' stamp: 'cwp 8/10/2003 17:48'!
commentStamp: aString prior: aNumber
	reader context: self.
	commentStamp _ aString.
	mode _ #handleComment:! !

!MCClassContext class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 19:14'!
forReader: anStReader
	^ self new reader: anStReader! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 22:00'!
realClassName
	| name |
	name _ self className.
	^ (name endsWith: ' class')
		ifTrue: [(name allButLast: 6) asSymbol]
		ifFalse: [name]! !

!MCClassContext methodsFor: 'emulating' stamp: 'cwp 8/3/2003 23:35'!
methodsFor: aMethodCategoryName
	self methodsFor: aMethodCategoryName stamp: String new! !

!MCClassContext methodsFor: 'accessing' stamp: 'cwp 8/3/2003 23:32'!
isMetaClass
	^ self className endsWith: ' class'! !

!MCClassContext methodsFor: 'emulating' stamp: 'ab 8/8/2003 17:30'!
weakSubclass: classNameSymbol instanceVariableNames: ivarNames classVariableNames: cvarNames poolDictionaries: poolDicts category: catName
	self 
		createClass: classNameSymbol 
		instanceVariableNames: ivarNames 
		classVariableNames: cvarNames 
		poolDictionaries: poolDicts 
		category: catName
		type: #weak! !

Object subclass: #MCPatcher
	instanceVariableNames: 'definitions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCPatcher methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:46'!
removeDefinition: aDefinition
	definitions remove: aDefinition! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 14:23'!
modifyDefinition: baseDefinition to: targetDefinition
	self addDefinition: targetDefinition! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:46'!
addDefinition: aDefinition
	definitions add: aDefinition! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 23:49'!
initializeWithSnapshot: aSnapshot
	definitions _ MCDefinitionIndex definitions: aSnapshot definitions! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 23:48'!
patchedSnapshot
	^ MCSnapshot fromDefinitions: definitions definitions! !

!MCPatcher class methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:53'!
apply: aPatch to: aSnapshot
	| loader |
	loader _ self snapshot: aSnapshot.
	aPatch applyTo: loader.
	^ loader patchedSnapshot! !

!MCPatcher class methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 14:22'!
snapshot: aSnapshot
	^ self new initializeWithSnapshot: aSnapshot! !

Object subclass: #MCPackageLoader
	instanceVariableNames: 'requirements unloadableDefinitions additions removals '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!

!MCPackageLoader methodsFor: 'private' stamp: 'ab 5/25/2003 01:19'!
sorterForItems: aCollection
	| sorter |
	sorter _ MCDependencySorter items: aCollection.
	Smalltalk keys do: [:ea | sorter addProvision: ea].
	^ sorter! !

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 12:11'!
updatePackage: aPackage withSnapshot: aSnapshot
	self new
		updatePackage: aPackage withSnapshot: aSnapshot;
		load! !

!MCPackageLoader methodsFor: 'public' stamp: 'ab 7/6/2003 23:30'!
installSnapshot: aSnapshot
	| patch |
	patch _ aSnapshot patchRelativeToBase: MCSnapshot empty.
	patch applyTo: self.
! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 5/25/2003 01:19'!
orderDefinitionsForLoading: aCollection
	^ (self sorterForItems: aCollection) orderedItems! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 5/31/2003 13:19'!
initialize
	additions _ OrderedCollection new.
	removals _ OrderedCollection new.
! !

!MCPackageLoader methodsFor: 'public' stamp: 'ab 8/24/2003 01:03'!
load
	self analyze.
	unloadableDefinitions isEmpty ifFalse: [self warnAboutDependencies].
	self useNewChangeSetDuring: [self basicLoad]! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 7/18/2003 21:32'!
basicLoad
	additions do: [:ea | ea load] displayingProgress: 'Loading Stage 1...'.
	additions do: [:ea | ea postload] displayingProgress: 'Loading Stage 2...'.
	removals do: [:ea | ea unload] displayingProgress: 'Cleaning up...'.! !

!MCPackageLoader methodsFor: 'public' stamp: 'ab 7/7/2003 12:11'!
updatePackage: aPackage withSnapshot: aSnapshot
	|  patch |
	patch _ aSnapshot patchRelativeToBase: aPackage snapshot.
	patch applyTo: self.
! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 5/24/2003 16:52'!
orderedAdditions
	^ additions! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 7/19/2003 18:02'!
analyze
	| sorter |
	sorter _ self sorterForItems: additions.
	additions _ sorter orderedItems.
	requirements _ sorter externalRequirements.
	unloadableDefinitions _ sorter itemsWithMissingRequirements asSortedCollection.
	
	sorter _ self sorterForItems: removals.
	removals _ sorter orderedItems reversed.! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 5/25/2003 01:22'!
warnAboutDependencies 
	self notify: self dependencyWarning! !

!MCPackageLoader methodsFor: 'patch ops' stamp: 'ab 5/24/2003 16:14'!
modifyDefinition: old to: new
	self addDefinition: new! !

!MCPackageLoader methodsFor: 'patch ops' stamp: 'ab 5/24/2003 16:14'!
removeDefinition: aDefinition
	removals add: aDefinition! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 5/25/2003 01:24'!
dependencyWarning
	^ String streamContents:
		[:s |
		s nextPutAll: 'This package depends on the following classes:'; cr.
		requirements do: [:ea | s space; space; nextPutAll: ea; cr].
		s nextPutAll: 'You must resolve these dependencies before you will be able to load these definitions: '; cr.
		unloadableDefinitions do: [:ea | s space; space; nextPutAll: ea summary; cr]] ! !

!MCPackageLoader methodsFor: 'patch ops' stamp: 'ab 5/24/2003 16:13'!
addDefinition: aDefinition
	additions add: aDefinition! !

!MCPackageLoader methodsFor: 'private' stamp: 'ab 8/24/2003 01:03'!
useNewChangeSetDuring: aBlock
	| changeHolder oldChanges newChanges |
	changeHolder _ ChangeSet.
	oldChanges _ [ChangeSet current]
						on: MessageNotUnderstood
						do: [:e |
						"Squeak <= 3.5"
						changeHolder _ Smalltalk.
						Smalltalk changes].
	newChanges _ ChangeSet new name: (ChangeSet uniqueNameLike: 'MC').
	changeHolder newChanges: newChanges.
	aBlock value.
	changeHolder newChanges: oldChanges.! !

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 23:30'!
installSnapshot: aSnapshot
	self new
		installSnapshot: aSnapshot;
		load! !

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 13:18'!
new
	^ super new initialize! !

Object subclass: #MCBootstrapLoader
	instanceVariableNames: 'pass '
	classVariableNames: 'Loader '
	poolDictionaries: ''
	category: 'Monticello-Bootstrap'!

!MCBootstrapLoader methodsFor: 'loading' stamp: 'nk 7/28/2003 16:40'!
packageName: aString
	Smalltalk at: #PackageInfo ifPresent: [ :pi | pi named: aString ]! !

!MCBootstrapLoader methodsFor: 'accessing' stamp: 'nk 7/28/2003 16:13'!
pass: aNumber
	pass _ aNumber! !

!MCBootstrapLoader class methodsFor: 'service' stamp: 'cwp 8/3/2003 02:19'!
loadFile: fileName
	self loadStream: (FileStream readOnlyFileNamed: fileName)! !

!MCBootstrapLoader class methodsFor: 'service' stamp: 'cwp 8/3/2003 02:16'!
fileReaderServicesForFile: fullName suffix: suffix
	^ (#(mc mcv) includes: suffix)
		ifTrue: [self services]
		ifFalse: [Array new: 0]
		! !

!MCBootstrapLoader class methodsFor: 'loading' stamp: 'cwp 7/30/2003 01:51'!
loadStream: aStream pass: anInteger
	aStream reset.
	Loader 
		pass: anInteger; 
		loadStream: aStream displayingProgress: 'Loading: stage ', anInteger asString.! !

!MCBootstrapLoader class methodsFor: 'loading' stamp: 'nk 7/28/2003 16:21'!
loadFile
	(FileList2 modalFileSelectorForSuffixes: #(mc mcv))
		ifNotNilDo: [:file | self loadStream: file]! !

!MCBootstrapLoader class methodsFor: 'service' stamp: 'cwp 8/3/2003 02:15'!
initialize
	FileList registerFileReader: self.! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'cwp 7/30/2003 02:21'!
categories: anArray
	anArray do: [:cat | SystemOrganization addCategory: cat]! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'cwp 7/8/2003 22:31'!
className: classSymbol selector: methodSymbol category: methodCategory timeStamp: timeStamp source: sourceString
	self className: classSymbol classIsMeta: false selector: methodSymbol category: methodCategory timeStamp: timeStamp source: sourceString! !

!MCBootstrapLoader methodsFor: 'initializing' stamp: 'cwp 7/30/2003 01:38'!
initializeClassNamed: className
	Smalltalk 
		at: className 
		ifPresent: [ :cls | (cls class includesSelector: #initialize) ifTrue: [cls  initialize]].
		! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'cwp 7/30/2003 01:57'!
className: classSymbol classIsMeta: isMeta selector: methodSymbol category: methodCategory timeStamp: timeStamp source: sourceString
	| class |
	pass = 2 ifFalse: [ ^self ].
	class _ Smalltalk at: classSymbol.
	isMeta ifTrue: [class _ class class].
	class 
		compile: sourceString withSqueakLineEndings 
		classified: methodCategory 
		withStamp: timeStamp 
		notifying: nil.! !

!MCBootstrapLoader methodsFor: 'accessing' stamp: 'nk 7/28/2003 16:13'!
pass
	^pass! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'cwp 8/10/2003 17:52'!
name: className superclassName: superclassName category: categoryName instVarNames: instVarArray classVarNames: classVarArray poolDictionaryNames: poolVarArray classInstVarNames: classInstVarArray type: kindOfClass comment: commentString commentStamp: stampString
	| class |
	pass = 3 ifTrue: [self initializeClassNamed: className. ^ self].

	class _ ClassBuilder new
				name: className
				inEnvironment: Smalltalk
				subclassOf: (Smalltalk at: superclassName ifAbsent: [Object])
				type: kindOfClass
				instanceVariableNames: (self join: instVarArray) 
				classVariableNames: (self join: classVarArray)
				poolDictionaries: (self join: poolVarArray)
				category: categoryName.
	class class instanceVariableNames: (self join: classInstVarArray).
	class classComment: commentString stamp: stampString.! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'ab 7/7/2003 23:14'!
join: anArray
	^ String streamContents:
		[:s |
		anArray do: [:ea | s nextPutAll: ea; space]]! !

!MCBootstrapLoader class methodsFor: 'loading' stamp: 'nk 7/28/2003 16:34'!
bindingOf: aSymbol
	^ (aSymbol beginsWith: 'MC')
		ifTrue: [aSymbol -> Loader ]
		ifFalse: [ super bindingOf: aSymbol]! !

!MCBootstrapLoader class methodsFor: 'loading' stamp: 'cwp 7/30/2003 01:52'!
loadStream: aStream
	| oldLoader |
	oldLoader _ Loader.
	Loader _ self new.
	1 to: 3 do: [:i | self loadStream: aStream pass: i].
	Loader _ oldLoader
! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'ab 7/10/2003 01:53'!
named: aString! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'ab 7/7/2003 23:18'!
name: className superclassName: superclassName category: categoryName instVarNames: instVarArray comment: commentString
	self name: className superclassName: superclassName category: categoryName instVarNames: instVarArray classVarNames: #() poolDictionaryNames: #() classInstVarNames: #() comment: commentString! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'ab 7/10/2003 01:53'!
fromArray: anArray! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'ab 7/9/2003 00:31'!
name: className superclassName: superclassName category: categoryName instVarNames: instVarArray classVarNames: classVarArray poolDictionaryNames: poolVarArray classInstVarNames: classInstVarArray comment: commentString
	self
		name: className
		superclassName: superclassName
		category: categoryName
		instVarNames: instVarArray
		classVarNames: classVarArray
		poolDictionaryNames: poolVarArray
		classInstVarNames: classInstVarArray
		type: #normal
		comment: commentString! !

!MCBootstrapLoader class methodsFor: 'loading' stamp: 'nk 7/28/2003 22:26'!
scopeHas: varName ifTrue: assocBlock
	^ (varName beginsWith: 'MC')
		ifTrue: [assocBlock value: varName -> Loader. true]
		ifFalse: [super scopeHas: varName ifTrue: assocBlock]
! !

!MCBootstrapLoader methodsFor: 'compiling' stamp: 'nk 7/28/2003 16:19'!
loadChunk: aString
	Compiler evaluate: aString for: self  notifying: nil logged: false! !

!MCBootstrapLoader methodsFor: 'loading' stamp: 'cwp 8/10/2003 17:54'!
name: className superclassName: superclassName category: categoryName instVarNames: instVarArray classVarNames: classVarArray poolDictionaryNames: poolVarArray classInstVarNames: classInstVarArray type: kindOfClass comment: commentString
	^ self 
		name: className 
		superclassName: superclassName 
		category: categoryName 
		instVarNames: instVarArray 
		classVarNames: classVarArray 
		poolDictionaryNames: poolVarArray 
		classInstVarNames: classInstVarArray 
		type: kindOfClass 
		comment: commentString
		commentStamp: ''! !

!MCBootstrapLoader methodsFor: 'compiling' stamp: 'nk 7/28/2003 16:19'!
loadStream: aStream displayingProgress: aString
	aString
		displayProgressAt: Sensor cursorPoint
		from: 0 to: aStream size
		during:
			[:bar |
			[aStream atEnd] whileFalse:
				[bar value: aStream position.
				self loadChunk: aStream nextChunk]].! !

!MCBootstrapLoader class methodsFor: 'service' stamp: 'cwp 8/3/2003 02:19'!
services
	^ Array with: (SimpleServiceEntry
		provider: self
		label: 'load'
		selector: #loadFile:
		description: 'load a monticello package')! !

Object subclass: #MCConflict
	instanceVariableNames: 'operation chooseRemote '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Merging'!

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:45'!
remoteChosen
	^ chooseRemote notNil and: [chooseRemote]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:10'!
remoteDefinition
	^ operation targetDefinition! !

!MCConflict class methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:07'!
operation: anOperation
	^ self new operation: anOperation	! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:02'!
isResolved
	^ chooseRemote notNil! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:48'!
status
	^ self isResolved
		ifFalse: ['']
		ifTrue: [self remoteChosen
					ifFalse: ['L']
					ifTrue: ['R']]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 16:54'!
summary
	| attribute |
	attribute _ 
		self isResolved
			ifTrue: [self remoteChosen ifTrue: [#underlined] ifFalse: [#struckOut]]
			ifFalse: [#bold].
	^ Text string: operation summary attribute: (TextEmphasis perform: attribute)! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:45'!
localChosen
	^ chooseRemote notNil and: [chooseRemote not]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:04'!
applyTo: anObject
	self isResolved ifFalse: [self error: 'Cannot continue until this conflict has been resolved'].
	self remoteChosen ifTrue: [operation applyTo: anObject].! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:07'!
operation: anOperation
	operation _ anOperation! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 16:47'!
source
	^ self localChosen
		ifTrue: [operation fromSource]
		ifFalse: [operation source]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:10'!
localDefinition
	^ operation baseDefinition! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 16:39'!
clearChoice
	chooseRemote _ nil! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:03'!
chooseLocal
	chooseRemote _ false! !

!MCConflict methodsFor: 'as yet unclassified' stamp: 'ab 6/1/2003 13:03'!
chooseRemote
	chooseRemote _ true! !

Object subclass: #MCMockClassD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockClassD methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2003 21:21'!
one
	^ 1! !

Object subclass: #MCPatch
	instanceVariableNames: 'operations '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCPatch methodsFor: 'intializing' stamp: 'ab 6/2/2003 00:44'!
initializeWithBase: baseSnapshot target: targetSnapshot
	| base target |	
	operations _ OrderedCollection new.
	base _ MCDefinitionIndex definitions: baseSnapshot definitions.
	target _ MCDefinitionIndex definitions: targetSnapshot definitions.
	
	target definitions do:
		[:t |
		base
			definitionLike: t
			ifPresent: [:b | (b isSameRevisionAs: t) ifFalse: [operations add: (MCModification of: b to: t)]]
			ifAbsent: [operations add: (MCAddition of: t)]]
		displayingProgress: 'Diffing...'.
		
	base definitions do:
		[:b |
		target
			definitionLike: b
			ifPresent: [:t]
			ifAbsent: [operations add: (MCRemoval of: b)]]		! !

!MCPatch class methodsFor: 'as yet unclassified' stamp: 'ab 11/13/2002 19:17'!
fromBase: baseVersion target: targetVersion
	^ self new initializeWithBase: baseVersion target: targetVersion! !

!MCPatch methodsFor: 'accessing' stamp: 'ab 5/13/2003 12:18'!
operations
	^ operations! !

!MCPatch methodsFor: 'ui' stamp: 'cwp 8/2/2003 13:34'!
browse
	^ (MCPatchBrowser forPatch: self) show! !

!MCPatch methodsFor: 'applying' stamp: 'ab 5/24/2003 16:12'!
applyTo: anObject
	operations do: [:ea | ea applyTo: anObject].
! !

!MCPatch methodsFor: 'querying' stamp: 'cwp 6/9/2003 11:53'!
isEmpty
	^ operations isEmpty! !

Object subclass: #MCTool
	instanceVariableNames: 'morph label modal modalValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:40'!
widgetSpecs
	^ #()! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:22'!
defaultButtonPaneHeight
	"Answer the user's preferred default height for new button panes."

	^ Preferences parameterAt: #defaultButtonPaneHeight ifAbsentPut: [25]! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:52'!
answer: anObject
	modalValue _ anObject.
	self close.! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:36'!
label: aString
	label _ aString! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:46'!
listMorph: listSymbol selection: selectionSymbol menu: menuSymbol
	^ PluggableListMorph
		on: self
		list: listSymbol
		selected: selectionSymbol
		changeSelected: (selectionSymbol, ':') asSymbol
		menu: menuSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:46'!
listMorph: listSymbol selection: selectionSymbol
	^ PluggableListMorph
		on: self
		list: listSymbol
		selected: selectionSymbol
		changeSelected: (selectionSymbol, ':') asSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:38'!
window
	^ morph ifNil: [morph _ self buildWindow]! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 8/24/2003 20:15'!
findTextMorph: aSymbol
	^ morph submorphs detect: [:ea | (ea respondsTo: #getTextSelector) and: [ea getTextSelector = aSymbol]] ifNone: []! !

MCTool subclass: #MCVersionHistoryBrowser
	instanceVariableNames: 'info index repositoryGroup package '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

MCVersionHistoryBrowser subclass: #MCWorkingHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCWorkingHistoryBrowser methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 01:37'!
baseSnapshot
	^ package snapshot! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:24'!
selection
	^ index ifNil: [0]! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:31'!
selection: aNumber
	index _ aNumber.
	self changed: #selection; changed: #summary! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'nk 7/28/2003 18:05'!
widgetSpecs
	^ #(
		((listMorph:selection:menu: list selection getMenu:) (0 0 0.3 1))
		((textMorph: summary) (0.3 0 1 1))
	 	)! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 8/22/2003 01:41'!
index
	"Answer the value of index"

	^ index! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 8/22/2003 01:39'!
selectedSnapshot
	^ self snapshotForInfo: self selectedInfo! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:17'!
list
	^ info withAllAncestors collect: [:ea | ea name]! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'ab 8/22/2003 01:45'!
getMenu: aMenu
	index < 2 ifTrue: [^ aMenu].
	self fillMenu: aMenu fromSpecs: 
		(Array
			with: (Array with: 'view changes -> ', info name with: #viewChanges)
			with: #('spawn history' spawnHistory)).
	^ aMenu! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:15'!
info: aVersionInfo
	info _ aVersionInfo! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'ab 8/22/2003 01:28'!
viewChanges
	| patch |
	patch _ self baseSnapshot patchRelativeToBase: self selectedSnapshot.
	(MCPatchBrowser forPatch: patch) show! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:35'!
selectedInfo
	^ info withAllAncestors at: self selection ifAbsent: [nil]! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'nk 7/28/2003 18:17'!
index: anObject
	"Set the value of index"

	index _ anObject! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:41'!
defaultExtent
	^ 440@169.
	! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'nk 7/28/2003 18:27'!
package: aMCPackage
	package _ aMCPackage! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 8/7/2003 21:27'!
repositoryGroup
	^ MCRepositoryGroup default! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'nk 7/28/2003 18:17'!
info
	"Answer the value of info"

	^ info! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 21:30'!
defaultLabel
	^ info name, ' History'! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'ab 8/22/2003 01:42'!
spawnHistory
	MCVersionHistoryBrowser new
		info: self selectedInfo;
		package: package;
		show! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:34'!
summary
	| selInfo |
	selInfo _ self selectedInfo.
	^ selInfo 
		ifNil: ['']
		ifNotNil: [selInfo summary]! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 8/22/2003 01:39'!
baseSnapshot
	^ self snapshotForInfo: info! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'ab 8/22/2003 01:38'!
snapshotForInfo: aVersionInfo
	^ (self repositoryGroup versionWithInfo: aVersionInfo) snapshot! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:31'!
windowColor 
	^ Color r: 0.71 g: 0.484 b: 1.0! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 18:33'!
buildWindow
	| window |
	window _ SystemWindow labelled: self label.
	window paneColor: self windowColor.
	window model: self.
	self widgetSpecs do:
		[:pair | |send fractions offsets|
		send _ pair first.
		fractions _ pair at: 2 ifAbsent: [#(0 0 1 1)].
		offsets _ pair at: 3 ifAbsent: [#(0 0 0 0)].
		window
			addMorph: (self perform: send first withArguments: send allButFirst )
			fullFrame:
				(LayoutFrame
					fractions: 
					((fractions first)@(fractions second) corner: 
						(fractions third)@(fractions fourth))
					offsets:
						((offsets first)@(offsets second)  corner:
							(offsets third)@(offsets fourth)))].
	^ window! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:10'!
defaultExtent
	^ 500@500! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:42'!
close
	self window delete! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 22:33'!
fillMenu: aMenu fromSpecs: anArray
	anArray do:
		[:pair |
		aMenu add: pair first target: self selector: pair second].
	^ aMenu! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:11'!
defaultLabel
	^ self class name! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:41'!
show
	modal _ false.
	^self window openInWorldExtent: self defaultExtent; yourself! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 22:26'!
listMorph: listSymbol
	^ self
		listMorph: (listSymbol, 'List') asSymbol
		selection: (listSymbol, 'Selection') asSymbol
		menu: (listSymbol, 'ListMenu:') asSymbol! !

MCTool subclass: #MCSaveVersionDialog
	instanceVariableNames: 'name message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:07'!
defaultExtent 
	^ 400@300! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:41'!
cancel
	self answer: nil! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:28'!
accept
	self answer:
		(Array
			with: (self findTextMorph: #versionName) text asString
			with: (self findTextMorph: #logMessage) text asString)
	! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:41'!
logMessage
	^ message ifNil: ['empty log message']! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:43'!
defaultLabel
	^ 'Edit Version Name and Message:'! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:17'!
widgetSpecs
	^ #(	
		((textMorph: versionName) (0 0 1 0) (0 0 0 30))
		((textMorph: logMessage) (0 0 1 1) (0 30 0 -30))
		((buttonRow) (0 1 1 1) (0 -30 0 0))
		)! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:10'!
buttonSpecs
	^ #((Accept accept 'accept version name and log message')
		(Cancel cancel 'cancel saving version')
		) ! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:42'!
logMessage: aString
	message _ aString.
	self changed: #logMessage! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:37'!
versionName
	^ name! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:37'!
versionName: aString
	name _ aString.
	self changed: #versionName! !

MCTool subclass: #MCSnapshotBrowser
	instanceVariableNames: 'items categorySelection classSelection protocolSelection methodSelection switch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCSnapshotBrowser methodsFor: 'text' stamp: 'nk 7/24/2003 13:40'!
annotations
	methodSelection ifNotNil: [^ methodSelection annotations ].
	^ ''! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'ab 7/18/2003 15:48'!
visibleProtocols
	| methods protocols |
	self switchIsComment ifTrue: [^ Array new].
	methods _ self methodsForSelectedClass.
	protocols _ (methods collect: [:ea | ea category]) asSet asSortedCollection.
	(protocols size > 1) ifTrue: [protocols add: '-- all --'].
	^ protocols ! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:05'!
switchIsClass
	^ switch = #class! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'cwp 7/10/2003 19:35'!
protocolSelection
	^ protocolSelection 
		ifNil: [0]
		ifNotNil: [self visibleProtocols indexOf: protocolSelection]! !

!MCSnapshotBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:03'!
forSnapshot: aSnapshot
	^ self new snapshot: aSnapshot! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'nk 7/24/2003 13:43'!
protocolSelection: anInteger
	protocolSelection _ (anInteger = 0 ifFalse: [self visibleProtocols at: anInteger]).
	self methodSelection: 0.
	self changed: #protocolSelection;
		changed: #methodList;	
		changed: #annotations! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 15:46'!
show
	self buildWindow openInWorldExtent: 650@400.! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 21:31'!
defaultLabel
	^ 'Snapshot Browser'! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/19/2003 18:03'!
snapshot: aSnapshot
	items _ aSnapshot definitions asSortedCollection.
	self categorySelection: 0.! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'cwp 7/10/2003 20:20'!
classList
	^ self visibleClasses! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 18:52'!
instanceButton
	^ self buttonWithState: #switchIsInstance action: #switchBeInstance label: 'instance'
		
		
		! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: 'nk 6/17/2003 11:34'!
perform: selector orSendTo: otherTarget 

	"Selector was just chosen from a menu by a user. If can respond, then  
	perform it on myself. If not, send it to otherTarget, presumably the  
	editPane from which the menu was invoked."

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ super perform: selector orSendTo: otherTarget]! !

!MCSnapshotBrowser methodsFor: 'text' stamp: 'nk 7/24/2003 13:41'!
annotations: stuff
	self changed: #annotations! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:03'!
switchIsInstance
	switch ifNil: [switch _ #instance].
	^ switch = #instance.! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'nk 7/24/2003 13:42'!
categorySelection: aNumber
	categorySelection _ aNumber = 0 ifFalse: [self visibleCategories at: aNumber].
	self classSelection: 0.
	self changed: #categorySelection;
		changed: #annotations;
		changed: #classList.
! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: 'cwp 7/10/2003 18:03'!
inspectSelection
	^ self methodSelection inspect! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'cwp 7/26/2003 03:07'!
separator
	^ BorderedSubpaneDividerMorph vertical 
		borderWidth: 2;
		color: Color lightGray;
		borderRaised.! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: 'cwp 7/10/2003 19:09'!
protocolListMenu: aMenu
	^aMenu! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'cwp 7/26/2003 03:06'!
widgetSpecs

	| |
	Preferences annotationPanes ifFalse: [ ^#(
		((listMorph: category) (0 0 0.25 0.4))
		((listMorph: class) (0.25 0 0.50 0.4) (0 0 0 -30))
		((listMorph: protocol) (0.50 0 0.75 0.4))
		((listMorph: method) (0.75 0 1 0.4))
		((buttons) (0.25 0.4 0.5 0.4) (0 -30 0 0))
		((textMorph: text) (0 0.4 1 1))
		) ].

	^#(
		((listMorph: category) (0 0 0.25 0.4))
		((listMorph: class) (0.25 0 0.50 0.4) (0 0 0 -30))
		((listMorph: protocol) (0.50 0 0.75 0.4))
		((listMorph: method) (0.75 0 1 0.4))

		((buttons) (0.25 0.4 0.5 0.4) (0 -30 0 0))

		((textMorph: annotations) (0 0.4 1 0.4) (0 0 0 30))
		((textMorph: text) (0 0.4 1 1) (0 30 0 0))
		)! !

!MCSnapshotBrowser methodsFor: 'text' stamp: 'ab 7/18/2003 15:48'!
classDefinitionString
	^ (items 
		detect: [:ea | ea isClassDefinition and: [ea className = classSelection]]
		ifNone: [^ 'This class is defined elsewhere.']) definitionString.! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'cwp 7/26/2003 03:02'!
buttonWithState: getState action: action label: buttonLabel
	^ (PluggableButtonMorph on: self getState: getState action: action)
			label: buttonLabel;
			onColor: Color white darker darker
			offColor: Color white;
			borderWidth: 0;
			borderRaised;
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 18:52'!
commentButton
	^ self buttonWithState: #switchIsComment action: #switchBeComment label: '?'
		
		! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'nk 7/24/2003 13:42'!
classSelection: aNumber
	classSelection _ aNumber = 0 ifFalse: [self visibleClasses at: aNumber].
	self protocolSelection: 0.
	self changed: #classSelection; 
		changed: #protocolList;
		changed: #annotations;
		changed: #methodList.
! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'cwp 7/10/2003 19:46'!
visibleMethods
	^ classSelection 
		ifNil: [#()]
		ifNotNil: [self methodsForSelectedProtocol]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/18/2003 15:48'!
methodsForSelectedProtocol
	| methods |
	protocolSelection ifNil: [^ Array new].
	methods _ self methodsForSelectedClass asOrderedCollection.
	(protocolSelection = '-- all --') 
		ifFalse: [methods removeAllSuchThat: [:ea | ea category ~= protocolSelection]].
	^ methods 
	
								! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:11'!
switchBeClass
	switch _ #class.
	self signalSwitchChanged.! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'ab 7/18/2003 15:48'!
visibleCategories
	^ (self packageClasses collect: [:ea | ea category]) 
			asSet asSortedCollection add: self extensionsCategory; yourself.! !

!MCSnapshotBrowser methodsFor: 'text' stamp: 'ab 7/18/2003 15:48'!
classCommentString
	^ (items 
		detect: [:ea | ea isClassDefinition and: [ea className = classSelection]]
		ifNone: [^ '']) comment.! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'cwp 7/10/2003 18:33'!
categorySelection
	^ categorySelection ifNil: [0] ifNotNil: [self visibleCategories indexOf: categorySelection]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'cwp 7/13/2003 02:11'!
methodList
	^ self visibleMethods collect: [:ea | ea selector]! !

!MCSnapshotBrowser methodsFor: 'text' stamp: 'cwp 7/11/2003 00:30'!
text: aTextOrString
	self changed: #text! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'ab 7/18/2003 15:48'!
visibleClasses
	^ categorySelection = self extensionsCategory
		ifTrue: [self extensionClassNames]
		ifFalse: [self packageClasses
					select: [:ea | ea category = categorySelection]
					thenCollect: [:ea | ea className]].! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'cwp 7/10/2003 19:07'!
protocolList
	^ self visibleProtocols! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'cwp 7/26/2003 03:07'!
buttons
	| row |
	row _ AlignmentMorph newRow.
	row
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		addMorph: self classButton;
		addMorph: self separator;
		addMorph: self commentButton;
		addMorph: self separator;
		addMorph: self instanceButton.
	^ row! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: 'nk 6/17/2003 11:30'!
classListMenu: aMenu
	^aMenu! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'cwp 7/10/2003 18:28'!
classSelection
	^ classSelection ifNil: [0] ifNotNil: [self visibleClasses indexOf: classSelection]! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:12'!
switchBeComment
	switch _ #comment.
	self signalSwitchChanged.! !

!MCSnapshotBrowser methodsFor: 'text' stamp: 'cwp 7/13/2003 08:55'!
text
	self switchIsComment ifTrue: [^ self classCommentString].
	methodSelection ifNotNil: [^ methodSelection source].
	protocolSelection ifNotNil: [^ ''].
	classSelection ifNotNil: [^ self classDefinitionString].
	^ ''! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/18/2003 15:48'!
packageClasses
	^ items select: [:ea | ea isClassDefinition]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'cwp 7/10/2003 18:33'!
categoryList
	^ self visibleCategories! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:57'!
signalSwitchChanged
	self protocolSelection: 0.
	self 
		changed: #switchIsInstance;
		changed: #switchIsComment;
		changed: #switchIsClass;
		changed: #protocolList;
		changed: #methodList;
		changed: #text.! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: 'ab 7/5/2003 23:30'!
categoryListMenu: aMenu
	^aMenu! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'cwp 7/10/2003 20:26'!
methodSelection
	^ methodSelection
			ifNil: [0] 
			ifNotNil: [self visibleMethods indexOf: methodSelection]! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 18:52'!
classButton
	^ self buttonWithState: #switchIsClass action: #switchBeClass label: 'class'
		! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:29'!
defaultExtent
	^ 650@400.! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:04'!
switchIsComment
	^ switch = #comment.! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: 'cwp 7/12/2003 18:12'!
switchBeInstance
	switch _ #instance.
	self signalSwitchChanged.! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'cwp 7/10/2003 20:23'!
extensionClassNames
	^ (self allClassNames difference: self packageClassNames) asSortedCollection! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'nk 7/24/2003 13:42'!
methodSelection: aNumber
	methodSelection _ aNumber = 0 ifFalse: [self visibleMethods at: aNumber].
	self changed: #methodSelection; changed: #text; changed: #annotations! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/18/2003 15:48'!
methodsForSelectedClass
	^ items select: [:ea | (ea className = classSelection) 
									and: [ea isMethodDefinition]
									and: [ea classIsMeta = self switchIsClass]].! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: 'ab 7/18/2003 15:30'!
methodListMenu: aMenu
	^aMenu! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/18/2003 15:48'!
packageClassNames
	^ self packageClasses collect: [:ea | ea className]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/5/2003 23:41'!
extensionsCategory
	^ '*Extensions'! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'ab 7/18/2003 15:47'!
allClassNames
	^ (items 
		select: [:ea | ea isOrganizationDefinition not] 
		thenCollect: [:ea | ea className]) asSet.
! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 00:45'!
buttonState
	^ true! !

MCTool subclass: #MCWorkingCopyBrowser
	instanceVariableNames: 'workingCopy repository '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 22:05'!
workingCopySelection
	^ self workingCopies indexOf: workingCopy! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 00:46'!
hasWorkingCopy
	^ workingCopy notNil! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 23:13'!
workingCopyList
	^ self workingCopies collect: [:ea | ea description]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 8/7/2003 21:32'!
repositories
	^ self repositoryGroup repositories! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/21/2003 00:30'!
newRepository
	| types index |
	types _ MCRepository allConcreteSubclasses asArray.
	index _ (PopUpMenu labelArray: (types collect: [:ea | ea description]))
				startUpWithCaption: 'Repository type:'.
	^ index = 0 ifFalse: [(types at: index) morphicConfigure]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'avi 8/31/2003 00:22'!
pickWorkingCopy
	| index |
	index _ (PopUpMenu labelArray: (self workingCopies collect: [:ea | ea packageName]))
				startUpWithCaption: 'Package:'.
	^ index = 0 ifFalse: [self workingCopies at: index]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'dvf 7/23/2003 15:18'!
browseCodeFileDifferences
	self browseDifferenceAgainstCodeFile: FileList2 modalFileSelector startingFrom: 0 ! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 23:38'!
defaultLabel
	^ 'Monticello Browser'! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'dvf 7/23/2003 15:18'!
browseChangesFileDifferences
	| targetFile startPosition |
	targetFile := SourceFiles at: 2.
	startPosition := Smalltalk lastQuitLogPosition.
	self browseDifferenceAgainstCodeFile: targetFile
		startingFrom: startPosition! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 23:27'!
initialize
	MCWorkingCopy addDependent: self.
	self workingCopies do: [:ea | ea addDependent: self].! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'dvf 7/23/2003 15:13'!
browseSomeChangesFileDifferences
	|full block filteredChanges |
	full _ (ChangeList recentLogOn: FileList2 modalFileSelector startingFrom: 0).
	block _ [:cat :cl | workingCopy packageInfo includesMethodCategory: cat ofClassNamed: cl].
	filteredChanges _ (full changeList select: [:e | e type = #method]) select: [:e | block value: e category value: e methodClassName].
	full changeTo: filteredChanges.
	full removeOlderMethodVersions; removeExistingMethodVersions.
	ChangeList open: full name: 'ba' multiSelect: true! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 7/22/2003 02:08'!
addWorkingCopy
	|name|
	name _ FillInTheBlankMorph request: 'Name of package:'.
	name isEmptyOrNil ifFalse:
		[PackageInfo registerPackageName: name.
		workingCopy _ MCWorkingCopy forPackage: (MCPackage new name: name).
		self repositorySelection: 0].
	self changed: #workingCopyList; changed: #workingCopySelection; changed: #repositoryList! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 02:22'!
workingCopySelection: aNumber
	aNumber = 0
		ifTrue: [workingCopy _ nil]
		ifFalse:
			[workingCopy _ self workingCopies at: aNumber].
	self changed: #workingCopySelection; changed: #repositoryList.
	! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 02:21'!
repositorySelection: aNumber
	aNumber = 0
		ifTrue: [self repository: nil]
		ifFalse: [self repository: (self repositories at: aNumber)].
	self changed: #repositorySelection! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'dvf 7/23/2003 15:33'!
filterChangesList: changesList 
	| filteredChanges |
	changesList
		removeOlderMethodVersions;
		removeExistingMethodVersions.
	filteredChanges := changesList changeList select: 
					[:e | 
					e type = #method and: 
							[workingCopy packageInfo includesMethodCategory: e category
								ofClassNamed: e methodClassName]].
	changesList changeTo: filteredChanges! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/22/2003 01:37'!
viewHistory
	workingCopy ifNotNil:
		[(MCWorkingHistoryBrowser new
				info: workingCopy versionInfo;
				package: workingCopy package)
			label:  'Version History: ',  workingCopy packageName;
			show]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 8/22/2003 01:45'!
buttonSpecs
	^ #(
		('+Package' addWorkingCopy 'add working copy')
		(Browse browseWorkingCopy 'browse working copy' hasWorkingCopy)
		(History viewHistory 'view working copy history' hasWorkingCopy)
		(Changes viewChanges 'view working copy changes relative to the repository' canSave)
		(Save saveVersion 'save the working copy to the repository' canSave)
		('+Repository' addRepository 'add a repository')
		(Open openRepository 'open a version from the repository' hasRepository)
		)! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/7/2003 21:33'!
addRepository
	self newRepository ifNotNilDo:
		[:repos |
		self repositoryGroup addRepository: repos.
		self repository: repos].
	self changed: #repositoryList; changed: #repositorySelection! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/7/2003 21:22'!
repository: aRepository
	repository _ aRepository.
	workingCopy ifNotNil: [workingCopy defaultRepository: repository]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'dvf 7/23/2003 15:33'!
browseDifferenceAgainstCodeFile: targetFile startingFrom: startPosition 
	| changesList |
	changesList := ChangeList recentLogOn: targetFile
				startingFrom: startPosition.
	self filterChangesList: changesList.
	ChangeList 
		open: changesList
		name: 'Changes between ' , workingCopy packageName , ' and ' 
				, targetFile name
		multiSelect: true! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'avi 8/31/2003 00:19'!
repositoryListMenu: aMenu
	self repository ifNil: [^ aMenu].
	^ self fillMenu: aMenu fromSpecs:
		#(
		('open repository' #openRepository)
		('save to repository' #saveVersion)
		('remove repository' #removeRepository)
		('add to package...' #addRepositoryToPackage))! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 23:27'!
update: aSymbol
	self workingCopies do: [:ea | ea addDependent: self].
	self changed: #workingCopyList.! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 02:22'!
repositorySelection
	^ self repositories indexOf: self repository! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 7/19/2003 22:59'!
deleteWorkingCopy
	workingCopy unregister.
	self workingCopySelection: 0.
	self changed: #workingCopyList! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/7/2003 21:33'!
removeRepository
	self repository ifNotNilDo:
		[:repos |
		self repositoryGroup removeRepository: repos.
		self repositorySelection: (1 min: self repositories size)].
	self changed: #repositoryList! !

!MCWorkingCopyBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 23:38'!
initialize
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
         ifTrue: [TheWorldMenu registerOpenCommand: {'Monticello Browser'. {self. #open}}]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 7/19/2003 22:58'!
browseWorkingCopy
	workingCopy ifNotNil:
		[(MCSnapshotBrowser forSnapshot: workingCopy package snapshot)
			label: 'Snapshot Browser: ', workingCopy packageName;
			show]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/7/2003 21:21'!
repository
	workingCopy ifNotNil: [repository _ workingCopy defaultRepository].
	^ repository! !

!MCWorkingCopyBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 22:00'!
new
	^ super new initialize! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 8/7/2003 21:22'!
canSave
	^ self hasWorkingCopy and: [self hasRepository]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 8/7/2003 21:32'!
repositoryGroup
	^ workingCopy
		ifNil: [MCRepositoryGroup default]
		ifNotNil: [workingCopy repositoryGroup]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 7/24/2003 20:54'!
openRepository
	self repository ifNotNilDo: [:repos | repos morphicOpen]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 22:04'!
workingCopies
	^ MCWorkingCopy allManagers! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 23:34'!
defaultExtent
	^ 450@200! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'avi 8/31/2003 00:28'!
addRepositoryToPackage
	self repository ifNotNilDo:
		[:repos |
		self pickWorkingCopy ifNotNilDo:
			[:wc |
			workingCopy _ wc.
			workingCopy repositoryGroup addRepository: repos.
			repository _ repos.	
			self
				changed: #workingCopySelection;
				changed: #repositoryList;
				changed: #repositorySelection]]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'nk 7/28/2003 17:37'!
workingCopyListMenu: aMenu
	workingCopy ifNil: [^ aMenu].
	self fillMenu: aMenu fromSpecs:
		#(
		  ('browse package' #browseWorkingCopy)
		  ('view changes' #viewChanges)
		  ('view history' #viewHistory)
		  ('export package' #exportPackage)
		  ('delete working copy' #deleteWorkingCopy)
		  ('browse changes file differences' #browseChangesFileDifferences)
		  ('browse code file differences' browseCodeFileDifferences)).
	(Smalltalk includesKey: #SARMCPackageDumper) ifTrue: [
		aMenu add: 'make SAR' target: self selector: #fileOutAsSAR
	].
	^aMenu! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ab 8/21/2003 19:41'!
viewChanges
	| patch |
	self canSave ifTrue:
		[patch _ workingCopy changesRelativeToRepository: repository.
		patch isNil ifTrue: [^ self].
		patch isEmpty
			ifTrue: [self inform: 'No changes']
			ifFalse:
				[(MCPatchBrowser forPatch: patch)
					label: 'Patch Browser: ', workingCopy ancestorName;
					show]]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 22:04'!
repositoryList
	^ self repositories collect: [:ea | ea description]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 23:11'!
workingCopyListMorph
	^ PluggableMultiColumnListMorph
		on: self
		list: #workingCopyList
		selected: #workingCopySelection
		changeSelected: #workingCopySelection:
		menu: #workingCopyListMenu:! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 00:23'!
widgetSpecs
	^ #(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((listMorph: workingCopy) (0 0 0.5 1) (0 30 0 0))
		((listMorph: repository) (0.5 0 1 1) (0 30 0 0))
		)! !

!MCWorkingCopyBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 23:27'!
open
	self new show! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'avi 8/31/2003 00:41'!
saveVersion
	self canSave ifTrue:
		[workingCopy newVersion ifNotNilDo:
			[:v |
			(MCVersionInspector new version: v) show.
			repository storeVersion: v.
			]]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 02:21'!
hasRepository
	^ self repository notNil! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ab 7/24/2003 21:35'!
exportPackage
	workingCopy ifNotNil:
		[workingCopy package packageInfo fileOut]! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:36'!
textMorph: aSymbol
	^ PluggableTextMorph on: self text: aSymbol accept: (aSymbol, ':') asSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/22/2003 00:53'!
buttonRow: specArray
	| aRow aButton |
	aRow _ AlignmentMorph newRow.
	aRow 
		color: (Display depth <= 8 ifTrue: [Color transparent] ifFalse: [Color gray alpha: 0.2]);
		borderWidth: 0.

	aRow hResizing: #spaceFill; vResizing: #spaceFill; rubberBandCells: true.
	aRow clipSubmorphs: true.
	aRow layoutInset: 5@2; cellInset: 3.
	aRow wrapCentering: #center; cellPositioning: #leftCenter.
	specArray do:
		[:triplet |
			aButton _ PluggableButtonMorph
				on: self
				getState: (triplet at: 4 ifAbsent: [#buttonState])
				action: triplet second.
			aButton
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				useRoundedCorners;
				label: triplet first asString;
				onColor: Color transparent offColor: Color white.
			aRow addMorphBack: aButton.
			aButton setBalloonText: triplet third].
		
	Preferences alternativeWindowLook ifTrue:[
		aRow color: Color transparent.
		aRow submorphsDo:[:m| m borderWidth: 2; borderColor: #raised].
	].

	^ aRow! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:23'!
getMenu: aMenu
	^aMenu! !

!MCTool methodsFor: 'morphic ui' stamp: 'nk 7/24/2003 13:31'!
defaultAnnotationPaneHeight 
	"Answer the receiver's preferred default height for new annotation panes."
	^ Preferences parameterAt: #defaultAnnotationPaneHeight ifAbsentPut: [25]! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 18:34'!
buttonRow
	^ self buttonRow: self buttonSpecs! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:51'!
showModally
	modal _ true.
	self window openInWorldExtent: (400@400).
	[self window world notNil] whileTrue: [
		self window outermostWorldMorph doOneCycle.
	].
	morph _ nil.
	^ modalValue! !

MCTool subclass: #MCPatchBrowser
	instanceVariableNames: 'items selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCPatchBrowser methodsFor: 'selecting' stamp: 'ab 7/16/2003 14:40'!
selection: aNumber
	selection _ aNumber = 0 ifFalse: [self items at: aNumber].
	self changed: #selection; changed: #text! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: 'ab 8/22/2003 02:29'!
widgetSpecs
	^ #(
		((listMorph:selection:menu: list selection getMenu:) (0 0 1 0.4) (0 0 0 0))
		((textMorph: text) (0 0.4 1 1))
		)! !

!MCPatchBrowser methodsFor: 'accessing' stamp: 'ab 8/22/2003 02:25'!
patch: aPatch
	items _ aPatch operations asSortedCollection! !

!MCPatchBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 7/16/2003 14:35'!
forPatch: aPatch
	^ self new patch: aPatch! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 21:31'!
defaultLabel
	^ 'Patch Browser'! !

!MCPatchBrowser methodsFor: 'accessing' stamp: 'ab 7/16/2003 14:39'!
list
	^ self items collect: [:ea | ea summary]! !

MCPatchBrowser subclass: #MCMergeBrowser
	instanceVariableNames: 'conflicts merger ok '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:41'!
chooseRemote
	self conflictSelectionDo:
		[selection chooseRemote.
		self changed: #text; changed: #list]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:39'!
widgetSpecs
	^ #(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((listMorph:selection:menu: list selection getMenu:) (0 0 1 0.4) (0 30 0 0))
		((innerButtonRow) (0 0.4 1 0.4) (0 0 0 30))
		((textMorph: text) (0 0.4 1 1) (0 30 0 0))
		)! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 17:52'!
cancel
	self answer: false! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 00:51'!
buttonSpecs
	^ #((Merge merge 'Proceed with the merge' canMerge)
		 (Cancel cancel 'Cancel the merge'))! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 17:52'!
merge
	merger isMerged
		ifFalse: [self inform: 'You must resolve all the conflicts first']
		ifTrue: [self answer: true] ! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:07'!
selectionIsConflicted
	^ selection isKindOf: MCConflict! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:41'!
chooseLocal
	self conflictSelectionDo:
		[selection chooseLocal.
		self changed: #text; changed: #list]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:41'!
clearChoice
	self conflictSelectionDo:
		[selection clearChoice.
		self changed: #text; changed: #list]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 16:32'!
items
	^ conflicts, items! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:07'!
getMenu: aMenu
	selection ifNil: [^ aMenu].
	^ self selectionIsConflicted
		ifTrue: [self getConflictMenu: aMenu]
		ifFalse: [self getOperationMenu: aMenu]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 00:49'!
innerButtonRow
	^ self buttonRow:
		#((Keep chooseRemote 'keep the selected change' selectionIsConflicted)
		  (Reject chooseLocal 'reject the selected change' selectionIsConflicted))! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:04'!
getConflictMenu: aMenu
	selection remoteChosen
		ifTrue: [aMenu add: 'undo keep change' target: self selector: #clearChoice]
		ifFalse: [aMenu add: 'keep change' target: self selector: #chooseRemote].
	selection localChosen
		ifTrue: [aMenu add: 'undo reject change' target: self selector: #clearChoice]	
		ifFalse: [aMenu add: 'reject change' target: self selector: #chooseLocal].
	^ aMenu! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 16:37'!
getOperationMenu: aMenu
	^ aMenu! !

!MCMergeBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 17:52'!
resolveConflictsInMerger: aMerger
	| inst |
	inst _ self new merger: aMerger.
	^ inst showModally ifNil: [false]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 21:31'!
defaultLabel
	^ 'Merge Browser'! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:42'!
conflictSelectionDo: aBlock
	self selectionIsConflicted
		ifTrue: aBlock
		ifFalse: [self inform: 'You must have a conflict selected']! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 17:47'!
merger: aMerger
	merger _ aMerger.
	items _ aMerger operations.
	conflicts _ aMerger conflicts.! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 00:51'!
canMerge
	^ merger isMerged! !

!MCPatchBrowser methodsFor: 'text' stamp: 'ab 7/16/2003 14:27'!
text: aTextOrString
	self changed: #text! !

!MCPatchBrowser methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 02:27'!
invert
	items _ items collect: [:ea | ea inverse].
	self changed: #list; changed: #text; changed: #selection! !

!MCPatchBrowser methodsFor: 'accessing' stamp: 'ab 7/16/2003 14:36'!
items
	^ items! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: 'ab 8/22/2003 02:21'!
buttonSpecs
	^ #((Invert invert 'Show the reverse set of changes')
		 (Export export 'Export the changes as a change set'))! !

!MCPatchBrowser methodsFor: 'text' stamp: 'ab 7/16/2003 14:40'!
text
	^ selection ifNil: [''] ifNotNil: [selection source]! !

!MCPatchBrowser methodsFor: 'selecting' stamp: 'ab 7/16/2003 14:30'!
selection
	^ selection 
		ifNil: [0]
		ifNotNil: [self items indexOf: selection]! !

MCTool subclass: #MCVersionInspector
	instanceVariableNames: 'version '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'avi 8/31/2003 00:44'!
repositories
	^ MCRepositoryGroup default repositories! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:34'!
load
	version load! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:18'!
summary
	^ version info summary! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 00:09'!
changes
	(MCPatchBrowser forPatch: version changes) show! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 18:43'!
widgetSpecs
	^ #(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((textMorph: summary) (0 0 1 1) (0 30 0 0))
		)! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'ab 7/19/2003 21:39'!
defaultLabel
	^ 'Version: ', version info name! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 00:44'!
save
	self pickRepository ifNotNilDo:
		[:ea |
		ea storeVersion: version]! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'avi 8/31/2003 00:42'!
buttonSpecs
	^ #((Browse browse 'Browse this version')
		(History history 'Browse the history of this version')
		(Changes changes 'Browse the changes this version would make to the image')
		(Load load 'Load this version into the image')
		(Merge merge 'Merge this version into the image')
		(Adopt adopt 'Adopt this version as an ancestor of your working copy')
		(Save save 'Save this version to a repository'))! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:32'!
history
	(MCVersionHistoryBrowser new info: version info) show! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 13:04'!
browse
	(MCSnapshotBrowser forSnapshot: version snapshot) show! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'avi 8/31/2003 00:43'!
pickRepository
	| index |
	index _ (PopUpMenu labelArray: (self repositories collect: [:ea | ea description]))
				startUpWithCaption: 'Repository:'.
	^ index = 0 ifFalse: [self repositories at: index]! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'avi 8/31/2003 00:45'!
defaultExtent
	^ 400@200! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:34'!
merge
	version merge! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 11:10'!
adopt
	(self confirm:
'Modifying ancestry can be dangerous unless you know
what you are doing.  Are you sure you want to adopt
',version info name, ' as an ancestor of your working copy?')
		ifTrue: [version adopt]! !

!MCVersionInspector methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:13'!
version: aVersion
	version _ aVersion! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:18'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then
perform it on myself. If not, send it to otherTarget, presumably the
editPane from which the menu was invoked."

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/18/2003 17:36'!
label
	^ label ifNil: [self defaultLabel]! !

!MCTool methodsFor: 'morphic ui' stamp: 'ab 7/17/2003 15:23'!
buttonSpecs
	^ #()! !

Object subclass: #MCVersion
	instanceVariableNames: 'package info snapshot '
	classVariableNames: 'Cache '
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:47'!
load
	(MCWorkingCopy forPackage: package) load: self! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:28'!
info
	^ info! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:47'!
merge
	(MCWorkingCopy forPackage: package) merge: self! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 00:10'!
changes
	^ snapshot patchRelativeToBase: package snapshot! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:19'!
open
	(MCVersionInspector new version: self) show! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:19'!
package
	^ package! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:10'!
snapshot
	^ snapshot! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:39'!
accept: aVisitor
	aVisitor visitVersion: self.! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 11:00'!
adopt
	(MCWorkingCopy forPackage: package) adopt: self! !

!MCVersion class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 16:12'!
package: aPackage info: aVersionInfo snapshot: aSnapshot
	^ self new initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:27'!
initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot
	package _ aPackage.
	info _ aVersionInfo.
	snapshot _ aSnapshot.
	self addToCache.! !

!MCVersion methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:27'!
addToCache
	Cache at: info put: self! !

!MCVersion class methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:28'!
withInfo: aVersionInfo ifAbsent: errorBlock
	^ Cache at: aVersionInfo ifAbsent: errorBlock! !

!MCVersion class methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:30'!
clearCache
	Cache _ Dictionary new! !

!MCVersion class methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 16:30'!
initialize
	self clearCache! !

!MCVersion class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 16:13'!
package: aPackage info: aVersionInfo
	^ self package: aPackage info: aVersionInfo snapshot: aPackage snapshot! !

!MCVersion class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 16:13'!
package: aPackage
	^ self package: aPackage info: MCVersionInfo new! !

Object subclass: #MCMerger
	instanceVariableNames: 'conflicts '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Merging'!

!MCMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:01'!
applyTo: anObject
	self isMerged ifFalse: [self error: 'You must resolve all the conflicts first'].
	conflicts do: [:ea | ea applyTo: anObject]! !

!MCMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:10'!
addConflictWithOperation: anOperation
	self conflicts add: (MCConflict operation: anOperation)! !

MCMerger subclass: #MCThreeWayMerger
	instanceVariableNames: 'base index operations '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Merging'!

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:31'!
removeDefinition: aDefinition
	index
		definitionLike: aDefinition
		ifPresent: [:other | other = aDefinition
								ifTrue: [self addOperation: (MCRemoval of: aDefinition)]
								ifFalse: [self addConflictWithOperation: (MCRemoval of: other)]]
		ifAbsent: []! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:30'!
operations
	^ operations ifNil: [operations _ OrderedCollection new]! !

!MCThreeWayMerger class methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 19:51'!
base: aSnapshot patch: aPatch
	aPatch isEmpty ifTrue: [MCNoChangesException signal].
	^ self new initializeWithBase: aSnapshot patch: aPatch! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:30'!
addOperation: anOperation
	self operations add: anOperation! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:31'!
addDefinition: aDefinition
	index
		definitionLike: aDefinition
		ifPresent: [:other | other = aDefinition
								ifFalse: [self addConflictWithOperation: (MCModification of: other to: aDefinition)]]
		ifAbsent: [self addOperation: (MCAddition of: aDefinition)]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:34'!
modifyDefinition: baseDefinition to: targetDefinition
	index
		definitionLike: baseDefinition
		ifPresent: [:other | other = baseDefinition
								ifTrue: [self addOperation: (MCModification of:  baseDefinition to: targetDefinition)]
								ifFalse: [other = targetDefinition
											ifFalse: [self addConflictWithOperation:
														(MCModification of: other to: targetDefinition)]]]
		ifAbsent: [self addConflictWithOperation: (MCAddition of: targetDefinition)]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:22'!
baseSnapshot
	^ base! !

!MCThreeWayMerger class methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:09'!
base: aSnapshot target: targetSnapshot ancestor: ancestorSnapshot
	^ self base: aSnapshot patch: (targetSnapshot patchRelativeToBase: ancestorSnapshot)! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:17'!
initializeWithBase: aSnapshot patch: aPatch
	base _ aSnapshot.
	index _ MCDefinitionIndex definitions: base definitions.
	aPatch applyTo: self.! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:32'!
applyTo: anObject
	super applyTo: anObject.
	self operations do: [:ea | ea applyTo: anObject]! !

!MCMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:11'!
mergedSnapshot
	^ MCPatcher apply: self to: self baseSnapshot! !

!MCMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/5/2003 19:09'!
isMerged
	^ self conflicts allSatisfy: [:ea | ea isResolved]! !

!MCMerger methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 16:34'!
operations
	^ #()! !

!MCMerger methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:02'!
conflicts
	^ conflicts ifNil: [conflicts _ OrderedCollection new]! !

Object subclass: #MCPatchOperation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

MCPatchOperation subclass: #MCModification
	instanceVariableNames: 'obsoletion modification '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCModification methodsFor: 'accessing' stamp: 'ab 7/18/2003 16:44'!
toSource
	^ modification source! !

!MCModification methodsFor: 'accessing' stamp: 'ab 5/24/2003 16:12'!
applyTo: anObject
	anObject modifyDefinition: obsoletion to: modification! !

!MCModification methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 02:27'!
inverse
	^ MCModification of: modification to: obsoletion! !

!MCModification methodsFor: 'accessing' stamp: 'cwp 11/28/2002 06:55'!
definition
	^ modification! !

!MCModification methodsFor: 'testing' stamp: 'cwp 11/28/2002 07:23'!
isModification
	^ true! !

!MCModification methodsFor: 'accessing' stamp: 'cwp 11/27/2002 09:48'!
obsoletion
	^ obsoletion! !

!MCModification methodsFor: 'accessing' stamp: 'ab 7/18/2003 16:44'!
fromSource
	^ obsoletion source! !

!MCModification methodsFor: 'accessing' stamp: 'ab 7/6/2003 00:05'!
summarySuffix
	^ ' (changed)'! !

!MCModification methodsFor: 'accessing' stamp: 'ab 6/1/2003 13:10'!
baseDefinition
	^ obsoletion! !

!MCModification methodsFor: 'accessing' stamp: 'ab 6/1/2003 13:10'!
targetDefinition
	^ modification! !

!MCModification methodsFor: 'accessing' stamp: 'cwp 11/27/2002 09:46'!
modification
	^ modification! !

!MCModification class methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2002 07:19'!
of: base to: target
	^ self new initializeWithBase: base target: target! !

!MCModification methodsFor: 'initializing' stamp: 'cwp 11/28/2002 07:18'!
initializeWithBase: base target: target
	obsoletion _ base.
	modification _ target.! !

!MCPatchOperation methodsFor: 'comparing' stamp: 'ab 7/19/2003 18:11'!
<= other
	^ self definition <= other definition! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'ab 7/6/2003 00:06'!
summary
	^ self definition summary, self summarySuffix! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'avi 8/31/2003 17:53'!
sourceString
	| patchSeq |
	patchSeq _ (TextDiffBuilder from: self fromSource to: self toSource) buildPatchSequence.
	^ String streamContents:
		[:s |
		patchSeq do:
			[:assoc |
			s nextPutAll: (self prefixForOperation: assoc key).
			s nextPutAll: assoc value.
			s cr]]! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'avi 8/31/2003 17:55'!
source
	^ self sourceText! !

MCPatchOperation subclass: #MCRemoval
	instanceVariableNames: 'definition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCRemoval methodsFor: 'accessing' stamp: 'ab 7/6/2003 00:05'!
summarySuffix
	^ ' (removed)'! !

!MCRemoval methodsFor: 'initializing' stamp: 'cwp 11/27/2002 10:02'!
intializeWithDefinition: aDefinition
	definition _ aDefinition! !

!MCRemoval methodsFor: 'accessing' stamp: 'ab 5/13/2003 12:22'!
summary
	^ definition summary, ' (removed)'! !

!MCRemoval methodsFor: 'testing' stamp: 'cwp 11/28/2002 07:24'!
isRemoval
	^ true! !

!MCRemoval methodsFor: 'accessing' stamp: 'cwp 11/27/2002 10:02'!
definition
	^ definition! !

!MCRemoval methodsFor: 'accessing' stamp: 'ab 7/18/2003 16:44'!
toSource
	^ ''! !

!MCRemoval methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 02:26'!
inverse
	^ MCAddition of: definition! !

!MCRemoval methodsFor: 'accessing' stamp: 'ab 6/1/2003 13:10'!
baseDefinition
	^ definition! !

!MCRemoval methodsFor: 'accessing' stamp: 'ab 5/24/2003 16:11'!
applyTo: anObject
	anObject removeDefinition: definition! !

!MCRemoval methodsFor: 'accessing' stamp: 'ab 7/18/2003 16:44'!
fromSource
	^ definition source! !

!MCRemoval methodsFor: 'accessing' stamp: 'ab 6/1/2003 13:10'!
targetDefinition
	^ nil! !

!MCRemoval class methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2002 10:03'!
of: aDefinition
	^ self new intializeWithDefinition: aDefinition! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'cwp 11/27/2002 09:26'!
inverse
	self subclassResponsibility! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'avi 8/31/2003 17:50'!
sourceText
	^ TextDiffBuilder buildDisplayPatchFrom: self fromSource to: self toSource! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'ab 7/6/2003 00:06'!
summarySuffix
	^ ''! !

!MCPatchOperation methodsFor: 'testing' stamp: 'cwp 11/27/2002 09:30'!
isAddition
	^ false! !

MCPatchOperation subclass: #MCAddition
	instanceVariableNames: 'definition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCAddition methodsFor: 'accessing' stamp: 'ab 5/24/2003 16:11'!
applyTo: anObject
	anObject addDefinition: definition! !

!MCAddition methodsFor: 'accessing' stamp: 'ab 6/1/2003 13:09'!
targetDefinition
	^ definition! !

!MCAddition methodsFor: 'as yet unclassified' stamp: 'ab 8/22/2003 02:26'!
inverse
	^ MCRemoval of: definition! !

!MCAddition methodsFor: 'accessing' stamp: 'ab 6/1/2003 13:09'!
baseDefinition
	^ nil! !

!MCAddition class methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2002 10:03'!
of: aDefinition
	^ self new intializeWithDefinition: aDefinition! !

!MCAddition methodsFor: 'accessing' stamp: 'ab 5/13/2003 12:18'!
summary
	^ definition summary! !

!MCAddition methodsFor: 'testing' stamp: 'cwp 11/28/2002 07:22'!
isAddition
	^ true! !

!MCAddition methodsFor: 'accessing' stamp: 'ab 7/18/2003 16:45'!
fromSource
	^ ''! !

!MCAddition methodsFor: 'initializing' stamp: 'cwp 11/27/2002 10:01'!
intializeWithDefinition: aDefinition
	definition _ aDefinition! !

!MCAddition methodsFor: 'accessing' stamp: 'ab 7/18/2003 16:45'!
toSource
	^ definition source! !

!MCAddition methodsFor: 'accessing' stamp: 'cwp 11/27/2002 09:32'!
definition
	^ definition! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'avi 8/31/2003 17:53'!
prefixForOperation: aSymbol
	aSymbol == #insert ifTrue: [^ '+'].
	aSymbol == #remove ifTrue: [^ '-'].
	^ ' '! !

!MCPatchOperation methodsFor: 'testing' stamp: 'cwp 11/27/2002 09:30'!
isModification
	^ false! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'cwp 11/28/2002 06:59'!
definition
	^ self subclassResponsibility ! !

!MCPatchOperation methodsFor: 'testing' stamp: 'cwp 11/27/2002 09:30'!
isRemoval
	^ false! !

Object subclass: #MCMessageSend
	instanceVariableNames: 'receiver selector arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMessageSend class methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:05'!
receiver: anObject selector: aSymbol argument: anotherObject
	^ self receiver: anObject selector: aSymbol arguments: (Array with: anotherObject)! !

!MCMessageSend class methodsFor: 'as yet unclassified' stamp: 'cwp 8/8/2003 23:51'!
receiver: anObject selector: aSymbol arguments: anArray
	^ self new initializeWithReceiver: anObject selector: aSymbol arguments: anArray! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:55'!
selector
	^ selector! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/8/2003 23:47'!
resolveReceiverIn: scope
	receiver _ scope resolve: receiver! !

!MCMessageSend class methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:52'!
receiver: anObject selector: aSymbol 
	^ self receiver: anObject selector: aSymbol arguments: Array new! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:55'!
receiver
	^ receiver
! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/8/2003 23:45'!
initializeWithReceiver: anObject selector: aSymbol arguments: anArray
	receiver _ anObject.
	selector _ aSymbol.
	arguments _ anArray! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:55'!
= other
	^ (self species = other species)
		and: [receiver = other receiver]
		and: [selector = other selector]
		and: [arguments = other arguments]! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/8/2003 23:42'!
value
	^ receiver perform: selector withArguments: arguments! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/8/2003 23:54'!
workAroundBugs
	"Monticello 1.159 had a bug that caused class comments to be captured
	as Text instead of strings. We need to convert them to strings here."

	| comment |
	receiver = MCClassDefinition ifFalse: [^ self].
	(selector endsWith: 'comment:') ifFalse: [^ self].
	arguments last isString ifTrue: [^ self].
	comment _ arguments at: (arguments size).
	arguments at: (arguments size) put: (comment at: 3)! !

!MCMessageSend methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:55'!
arguments
	^ arguments! !

Object variableSubclass: #MCMockClassE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockClassE class methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2003 21:22'!
two
	^ 2! !

Object subclass: #MCPackageManager
	instanceVariableNames: 'package modified '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

MCPackageManager class
	instanceVariableNames: 'registry '!

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 3/31/2003 20:45'!
initialize
	modified _ false.
	Utilities addDependent: self.! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 12:18'!
packageName
	^ package name! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 13:33'!
packageInfo
	^ package packageInfo! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:25'!
modified: aBoolean
	modified _ aBoolean.
	modified ifFalse: [Smalltalk logChange: '"', self packageName, '"'].
	self changed: #modified.
! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 13:35'!
update: aSymbol
	[((aSymbol = #recentMethodSubmissions)
		and: [self packageInfo
				includesMethodReference: Utilities recentMethodSubmissions last])
					ifTrue: [self modified: true]]
		on: Error do: []
! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/5/2003 23:18'!
packageNameWithStar
	^ modified
		ifTrue: ['* ', self packageName]
		ifFalse: [self packageName]! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 23:30'!
unregister
	self class registry removeKey: package.
	self class changed: #allManagers! !

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 16:28'!
forPackage: aPackage
	^ self registry at: aPackage ifAbsent:
		[|mgr|
		mgr _ self new initializeWithPackage: aPackage.
		self registry at: aPackage put: mgr.
		self changed: #allManagers.
		mgr]! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 16:47'!
package
	^ package! !

!MCPackageManager methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 16:27'!
initializeWithPackage: aPackage
	package _ aPackage.
	self initialize.! !

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: 'ab 5/9/2003 12:59'!
registry
	^ registry ifNil: [registry _ Dictionary new]! !

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: 'ab 3/31/2003 20:45'!
allManagers
	^ self registry values! !

MCPackageManager subclass: #MCWorkingCopy
	instanceVariableNames: 'versionInfo counter repositoryGroup defaultRepository '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCWorkingCopy methodsFor: 'repositories' stamp: 'ab 7/22/2003 00:28'!
defaultRepository: aRepository
	defaultRepository _ aRepository! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'ab 7/19/2003 23:14'!
description
	^ self packageNameWithStar, ' (', versionInfo ancestorString, ')'! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'avi 8/31/2003 01:31'!
merge: targetVersion
	| ancestorInfo merger ancestorSnapshot packageSnapshot |
	ancestorInfo _ targetVersion info commonAncestorWith: versionInfo.
	
	ancestorInfo = targetVersion info ifTrue: [^ MCNoChangesException signal].
	
	packageSnapshot _ package snapshot.
	ancestorSnapshot _ ancestorInfo
							ifNotNil: [(repositoryGroup versionWithInfo: ancestorInfo) snapshot]
							ifNil: [self notifyNoCommonAncestorWith: targetVersion.  MCSnapshot empty].
	
	(versionInfo ancestors size = 1
		and: [versionInfo ancestors first = ancestorInfo]
		and: [(packageSnapshot patchRelativeToBase: ancestorSnapshot) isEmpty])
				ifTrue: [^ self load: targetVersion].
	
	merger _ MCThreeWayMerger 
				base: packageSnapshot
				target: targetVersion snapshot
				ancestor: ancestorSnapshot.
	(MCMergeResolutionRequest new merger: merger)
		signal = true ifTrue:
			[merger mergedSnapshot updatePackage: package.
			versionInfo addAncestor: targetVersion info].
	self changed! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2003 22:57'!
initialize
	Smalltalk 
		at: #MczInstaller
		ifPresent: [:installer | 
			installer versionInfo keysAndValuesDo: [:packageName :info |
				self 
					forPackage: (MCPackage named: packageName)
					withInfo: info]]! !

!MCWorkingCopy methodsFor: 'private' stamp: 'ab 8/28/2003 20:07'!
updateCounterWithName: aString
	| num |
	num _ [(aString copyAfterLast: $.) asNumber] on: Error do: [0].
	counter _ counter max: num.! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'ab 8/21/2003 19:45'!
changesRelativeToRepository: aRepository
	| ancestorVersion ancestorSnapshot |
	ancestorVersion _ aRepository closestAncestorVersionFor: versionInfo ifNone: [].
	ancestorSnapshot _ ancestorVersion ifNil: [MCSnapshot empty] ifNotNil: [ancestorVersion snapshot].
	^ package snapshot patchRelativeToBase: ancestorSnapshot! !

!MCWorkingCopy methodsFor: 'private' stamp: 'ab 8/24/2003 20:38'!
requestVersionNameAndMessageWithSuggestion: aString
	^ (MCVersionNameAndMessageRequest new suggestedName: aString) signal! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2003 23:52'!
ancestorsFromArray: anArray
	^ anArray ifNotNil: [anArray collect: [:dict | self infoFromDictionary: dict]]! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'ab 8/17/2003 16:00'!
load: aVersion
	modified ifTrue: [self notifyAboutToLoseChanges].
	aVersion snapshot updatePackage: package.
	versionInfo _ MCVersionInfo new addAncestor: aVersion info.
	self updateCounterWithName: aVersion info name.
	self modified: false.
	self changed! !

!MCWorkingCopy methodsFor: 'repositories' stamp: 'avi 8/31/2003 00:14'!
repositoryGroup
	^ repositoryGroup ifNil: [repositoryGroup _ MCRepositoryGroup new]! !

!MCWorkingCopy methodsFor: 'repositories' stamp: 'ab 7/22/2003 02:19'!
defaultRepository
	^ (self repositories includes: defaultRepository)
		ifTrue: [defaultRepository]
		ifFalse: [defaultRepository _ nil]! !

!MCWorkingCopy methodsFor: 'private' stamp: 'ab 7/22/2003 00:13'!
initialize
	super initialize.
	versionInfo _ MCVersionInfo new.
	counter _ 0! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2003 02:08'!
forPackage: aPackage withInfo: aDictionary
	^ (self forPackage: aPackage) ancestorVersion: (self infoFromDictionary: aDictionary)! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2003 23:37'!
infoFromDictionary: aDictionary
	^ MCVersionInfo
		name: (aDictionary at: #name)
		id: (aDictionary at: #id)
		message: (aDictionary at: #message)
		date: (aDictionary at: #date)
		time: (aDictionary at: #time)
		author: (aDictionary at: #author)
		ancestors: (self ancestorsFromArray: (aDictionary at: #ancestors))! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'ab 8/17/2003 16:02'!
notifyAboutToLoseChanges
	self notify: 'You are about to load a new version of a package that is modified in the image.  If you proceed with this load, you will lose your changes.  You may wish to merge instead.'! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'ab 7/19/2003 23:01'!
ancestorName
	| version |
	version _  self ancestorVersion.
	^ version
		ifNil: ['<new>']
		ifNotNil: [version info name]! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'ab 8/24/2003 20:38'!
newVersion
	|suggestion|
	[suggestion _ self nextVersionName.
	self repositories anySatisfy: [:ea | ea includesVersionNamed: suggestion]] whileTrue.
	^ (self requestVersionNameAndMessageWithSuggestion: suggestion) ifNotNilDo:
		[:pair |
		self newVersionWithName: pair first message: pair last].
! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'nk 7/28/2003 18:52'!
ancestorVersion
	^ repositoryGroup versionWithInfoOrNil: (versionInfo ancestors at: 1 ifAbsent: [^ nil])! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'jf 8/21/2003 11:03'!
adopt: aVersion
	versionInfo addAncestor: aVersion info.
	self changed.! !

!MCWorkingCopy methodsFor: 'repositories' stamp: 'ab 7/22/2003 00:20'!
repositoryGroup: aRepositoryGroup
	repositoryGroup _ aRepositoryGroup! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'ab 7/22/2003 01:10'!
notifyNoCommonAncestorWith: aVersion
	self notify:
'Could not find a common ancestor between (',
aVersion info name,
') and (',
versionInfo ancestorString, ').
Proceeding with this merge may cause spurious conflicts.'! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'ab 7/19/2003 18:56'!
revert
	self ancestorVersion ifNotNilDo: [:version | self load: version]! !

!MCWorkingCopy methodsFor: 'private' stamp: 'ab 7/20/2003 00:22'!
nextVersionName
	counter _ counter + 1.
	^ package name, '-', Utilities authorInitials, '.', counter asString.! !

!MCWorkingCopy methodsFor: 'repositories' stamp: 'ab 7/22/2003 00:20'!
repositories
	^ self repositoryGroup repositories! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'ab 7/7/2003 16:15'!
versionInfo
	^ versionInfo! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'cwp 8/12/2003 02:08'!
ancestorVersion: aVersionInfo
	versionInfo addAncestor: aVersionInfo! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'avi 8/31/2003 00:52'!
newVersionWithName: nameString message: messageString
	| info|
	info _ versionInfo.
	info setName: nameString message: messageString.
	versionInfo _ MCVersionInfo new addAncestor: info.
	self modified: false.
	self updateCounterWithName: nameString.
	
	^ MCVersion
		package: package
		info: info! !

Object subclass: #MCVersionSorter
	instanceVariableNames: 'layers depthIndex depths '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 15:33'!
popLayer
	depthIndex _ depthIndex - 1! !

!MCVersionSorter class methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 15:48'!
new
	^ super new initialize! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 21:30'!
addAllVersionInfos: aCollection
	aCollection do: [:ea | self addVersionInfo: ea]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 15:53'!
layers
	^ layers! !

MCVersionSorter subclass: #MCFilteredVersionSorter
	instanceVariableNames: 'target '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCFilteredVersionSorter methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 21:27'!
target: aVersionInfo
	target _ aVersionInfo! !

!MCFilteredVersionSorter methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 21:34'!
addVersionInfo: aVersionInfo
	| success |
	aVersionInfo = target ifTrue: [^ true].
	self pushLayer.
	success _ aVersionInfo ancestors anySatisfy: [:ea | self addVersionInfo: ea].
	self popLayer.
	success ifTrue: [self addToCurrentLayer: aVersionInfo].
	^ success	! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 15:36'!
sortedVersionInfos
	^ layers gather: [:ea | ea]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 15:52'!
addToCurrentLayer: aVersionInfo
	| layer |
	layer _ layers at: depthIndex.
	(layer includes: aVersionInfo) ifFalse:
		[depths at: aVersionInfo ifPresent:
			[:i |
			i < depthIndex
				ifTrue: [(layers at: i) remove: aVersionInfo]
				ifFalse: [^ self]].
		layer add: aVersionInfo.
		depths at: aVersionInfo put: depthIndex]. ! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 21:34'!
pushLayer
	depthIndex _ depthIndex + 1.
	depthIndex > layers size ifTrue: [layers add: OrderedCollection new].
	! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 15:48'!
initialize
	layers _ OrderedCollection with: OrderedCollection new.
	depthIndex _ 1.
	depths _ Dictionary new.
	! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 21:26'!
addVersionInfo: aVersionInfo
	self addToCurrentLayer: aVersionInfo.
	self pushLayer.
	aVersionInfo ancestors do: [:ea | self addVersionInfo: ea].
	self popLayer.
! !

Object variableByteSubclass: #MCMockClassH
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

Object subclass: #MCSystemContext
	instanceVariableNames: 'categories '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCSystemContext methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 22:01'!
addDefinitionsTo: aCollection
	aCollection add: (MCOrganizationDefinition categories: categories asArray)! !

!MCSystemContext methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 19:04'!
initialize
	categories _ OrderedCollection new.! !

!MCSystemContext methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 19:05'!
addCategory: name
	categories add: name.! !

!MCSystemContext class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2003 19:05'!
new
	^ self basicNew initialize! !

Object subclass: #MCMessageStream
	instanceVariableNames: 'stream '
	classVariableNames: 'Keywords '
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:27'!
nextChunk
	^ stream nextChunk! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:49'!
stream: aStream
	stream _ aStream! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:11'!
resolveLiterals: tokens
	^ tokens collect: [:token | Keywords at: token ifAbsent: [token]]
! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 03:04'!
scan: aString
	| tokens tmp |
	tokens _ self scanner scanTokens: aString.
	(tokens at: 2) = 'class' 
		ifTrue: [tmp _ Array new: tokens size - 1.
				tmp at: 1 put: (tokens first, ' class').
				tmp replaceFrom: 2 to: tmp size with: tokens startingAt: 3]
		ifFalse: [tmp _ tokens].
	^ self resolveLiterals: (tmp).! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'ab 8/20/2003 20:18'!
reset
	stream reset! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:22'!
parse: aString
	| tokens selector arguments |
	tokens _ self scan: aString.
	selector _ String streamContents: [:s | 
		2 to: tokens size by: 2 do: [:i | s nextPutAll: (tokens at: i)]].
	arguments _ Array new: ((tokens size - 1) // 2).
	3 to: tokens size by: 2 do: [:i | arguments at: (i-1)/2 put: (tokens at: i)].
	^ MCMessageSend
		receiver: tokens first asSymbol
		selector: selector asSymbol
		arguments: arguments! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 12:01'!
isMessageStream
	^ true! !

!MCMessageStream class methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 17:13'!
initialize
	Keywords _ IdentityDictionary new.
	Keywords 
		at: #nil put: nil;
		at: #true put: true;
		at: #false put: false.! !

!MCMessageStream class methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:49'!
on: aStream
	^ self new stream: aStream! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:25'!
untilEnd: aBlock displayingProgress: aString
	^ stream untilEnd: aBlock displayingProgress: aString! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:20'!
scanner
	^ Scanner new! !

!MCMessageStream methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 16:55'!
next
	| chunk |
	chunk _ stream nextChunk.
	^ (chunk isAllSeparators or: [	chunk beginsWith: ']style['])
		ifFalse: [self parse: chunk]
	! !

Object subclass: #MCVariableDefinition
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCVariableDefinition methodsFor: 'accessing' stamp: 'cwp 11/25/2002 05:57'!
name
	^ name! !

!MCVariableDefinition methodsFor: 'comparing' stamp: 'cwp 7/7/2003 23:02'!
= other
	^ (self species = other species)
		and: [self name = other name]! !

!MCVariableDefinition methodsFor: 'comparing' stamp: 'cwp 7/7/2003 23:02'!
hash
	^ name hash! !

!MCVariableDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:31'!
isClassInstanceVariable
	^ false! !

!MCVariableDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 23:18'!
name: aString
	^ self new name: aString
	! !

!MCVariableDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:31'!
isInstanceVariable
	^ false! !

MCVariableDefinition subclass: #MCInstanceVariableDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCInstanceVariableDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 22:59'!
type
	^ #instance! !

!MCInstanceVariableDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 23:32'!
isInstanceVariable
	^ true! !

!MCVariableDefinition methodsFor: 'as yet unclassified' stamp: 'nk 7/24/2003 14:56'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: self name; nextPut: $)! !

MCVariableDefinition subclass: #MCPoolImportDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCPoolImportDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:51'!
isPoolImport
	^ true! !

!MCPoolImportDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 22:59'!
type
	^ #pool! !

!MCVariableDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:10'!
isInstanceVariableDefinition
	^ false! !

MCVariableDefinition subclass: #MCClassInstanceVariableDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassInstanceVariableDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 23:31'!
isClassInstanceVariable
	^ true! !

!MCClassInstanceVariableDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 22:59'!
type
	^ #classInstance! !

!MCVariableDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:30'!
isClassVariable
	^ false! !

!MCVariableDefinition methodsFor: 'accessing' stamp: 'cwp 11/25/2002 06:00'!
name: aString
	name _ aString! !

!MCVariableDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:08'!
isClassInstanceVariableDefinition
	^ false! !

!MCVariableDefinition methodsFor: 'testing' stamp: 'cwp 7/7/2003 23:51'!
isPoolImport
	^ false! !

MCVariableDefinition subclass: #MCClassVariableDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassVariableDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 23:32'!
isClassVariable
	^ true! !

!MCClassVariableDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2003 22:58'!
type
	^ #class! !

Object subclass: #MCVersionInfo
	instanceVariableNames: 'ancestors id name message date time author '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionInfo methodsFor: 'accessing' stamp: 'ab 8/16/2003 16:05'!
setName: nameString message: messageString
	name _ nameString.
	message _ messageString.
	date _ Date today.
	time _ Time now.
	author _ Utilities authorInitials.
	id _ UUID new.! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'ab 7/5/2003 13:24'!
ancestors
	^ ancestors ifNil: [ancestors _ OrderedCollection new]! !

!MCVersionInfo methodsFor: 'comparing' stamp: 'ab 7/5/2003 14:23'!
= other
	^ other species = self species
		and: [other hasID: id]! !

!MCVersionInfo methodsFor: 'pillaging' stamp: 'cwp 8/1/2003 00:26'!
date
	^ date! !

!MCVersionInfo methodsFor: 'printing' stamp: 'ab 7/5/2003 18:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: self name; nextPut: $)
	! !

!MCVersionInfo methodsFor: 'pillaging' stamp: 'cwp 8/1/2003 00:24'!
id
	^ id ! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'avi 8/31/2003 21:30'!
allAncestorsOnPathTo: aVersionInfo
	^ MCFilteredVersionSorter new
		target: aVersionInfo;
		addAllVersionInfos: self ancestors;
		sortedVersionInfos! !

!MCVersionInfo methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 16:05'!
initialize
! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'ab 7/12/2003 00:04'!
message
	^ message ifNil: ['']! !

!MCVersionInfo class methodsFor: 'as yet unclassified' stamp: 'ab 7/5/2003 14:08'!
new
	^ super new initialize! !

!MCVersionInfo methodsFor: 'converting' stamp: 'cwp 9/14/2003 18:40'!
asDictionary
	^ Dictionary new
		at: #name put: name;
		at: #id put: id;
		at: #message put: message;
		at: #date put: date;
		at: #time put: time;
		at: #author put: author;
		at: #ancestors put: (ancestors ifNotNil: [ancestors collect: [:a | a asDictionary]]);
		yourself! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'ab 7/5/2003 12:56'!
addAncestor: aNode
	self ancestors add: aNode! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'ab 7/11/2003 23:33'!
name
	^ name ifNil: ['<working copy>']! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'ab 8/22/2003 01:17'!
summary
	^ String streamContents:
		[:s |
		s
			nextPutAll: 'Name: '; nextPutAll: self name; cr.
		date ifNotNil:
			[s
				nextPutAll: 'Author: '; nextPutAll: author; cr;
				nextPutAll: 'Time: '; nextPutAll:  date asString, ', ', time asString; cr].
		id ifNotNil:
			[s nextPutAll: 'UUID: '; nextPutAll: id asString; cr].
		s
			nextPutAll: 'Ancestors: '; nextPutAll: self ancestorString; cr;
			cr; nextPutAll: self message.
		]! !

!MCVersionInfo methodsFor: 'private' stamp: 'ab 7/5/2003 14:10'!
hasID: aUUID
	^ id = aUUID! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'avi 8/31/2003 20:53'!
commonAncestorsWith: aVersionInfo

	| sharedAncestors mergedOrder |
	sharedAncestors _ self withAllAncestors intersection: aVersionInfo withAllAncestors.
	mergedOrder _ MCVersionSorter new
						addVersionInfo: self;
						addVersionInfo: aVersionInfo;
						sortedVersionInfos.
	^ mergedOrder select: [:ea | sharedAncestors includes: ea]! !

!MCVersionInfo methodsFor: 'pillaging' stamp: 'cwp 8/1/2003 00:26'!
time
	^ time! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'jf 8/16/2003 22:28'!
withAllAncestors
	^ (Array with: self), self allAncestors! !

!MCVersionInfo methodsFor: 'private' stamp: 'ab 7/19/2003 17:16'!
initializeFromArray: anArray
	name _ anArray first.
	id _ UUID fromString: anArray second.
	message _ anArray third.
	anArray size > 3 ifTrue: [ancestors _ anArray last collect: [:ea | self class fromArray: ea]].
	anArray size > 4 ifTrue:
		[date _ Date fromString: (anArray at: 4).
		time _ Time fromString: (anArray at: 5).
		author _ anArray at: 6].
! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'ab 7/19/2003 17:19'!
ancestorString
	^ String streamContents:
		[:s | self ancestors do: [:ea | s nextPutAll: ea name] separatedBy: [s nextPutAll: ', ']]! !

!MCVersionInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 14:14'!
name: vName id: id message: message date: date time: time author: author ancestors: ancestors
	^ self new
		initializeWithName: vName
		id: id
		message: message
		date: date
		time: time
		author: author
		ancestors: ancestors! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'ab 7/22/2003 01:03'!
commonAncestorWith: aNode
	| commonAncestors |
	commonAncestors _ self commonAncestorsWith: aNode.
	^ commonAncestors at: 1 ifAbsent: [nil]! !

!MCVersionInfo class methodsFor: 'as yet unclassified' stamp: 'ab 7/12/2003 00:02'!
fromArray: anArray
	^ self new initializeFromArray: anArray
	! !

!MCVersionInfo methodsFor: 'pillaging' stamp: 'cwp 8/1/2003 00:26'!
author
	^ author! !

!MCVersionInfo methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:51'!
accept: aVisitor
	aVisitor visitVersionInfo: self! !

!MCVersionInfo methodsFor: 'ancestry' stamp: 'avi 8/31/2003 21:29'!
allAncestors
	^ MCVersionSorter new
		addAllVersionInfos: self ancestors;
		sortedVersionInfos! !

!MCVersionInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 14:16'!
initializeWithName: vName id: aUUID message: aString date: aDate time: aTime author: initials ancestors: aCollection
	name _ vName.
	id _ aUUID.
	message _ aString.
	date _ aDate.
	time _ aTime.
	author _ initials.
	ancestors _ aCollection! !

!MCVersionInfo methodsFor: 'comparing' stamp: 'ab 7/5/2003 14:09'!
hash
	^ id hash! !

Object subclass: #MCMockClassF
	instanceVariableNames: ''
	classVariableNames: 'Foo '
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

Object subclass: #MCPackage
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Base'!

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:42'!
= other
	^ other species = self species and: [other name = name]! !

!MCPackage class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 01:17'!
named: aString
	^ self new name: aString! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 18:11'!
snapshot
	| packageInfo definitions |
	packageInfo _ self packageInfo.
	definitions _ OrderedCollection new.
	definitions add: (MCOrganizationDefinition categories: (packageInfo systemCategories)).
	packageInfo methods do: [:ea | definitions add: ea asMethodDefinition] displayingProgress: 'Snapshotting...'.
	definitions addAll: (packageInfo classes collect: [:ea | ea asClassDefinition]).
	^ MCSnapshot fromDefinitions: definitions! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 00:57'!
name
	^ name! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'nk 7/28/2003 13:30'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: name;
		nextPut: $)! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 13:33'!
packageInfo
	^ PackageInfo named: name! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 23:44'!
unload
	^ self packageInfo unload! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 00:57'!
name: aString
	name _ aString! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 01:13'!
storeOn: aStream
	aStream
		nextPutAll: 'MCPackage';
		space; nextPutAll: 'named: '; store: name.! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:42'!
hash
	^ name hash! !

!MCPackage methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:51'!
accept: aVisitor
	aVisitor visitPackage: self! !

Object subclass: #MCRepositoryGroup
	instanceVariableNames: 'repositories '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

MCRepositoryGroup class
	instanceVariableNames: 'default '!

!MCRepositoryGroup methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 02:09'!
repositories
	^ repositories! !

!MCRepositoryGroup methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 00:14'!
initialize
	repositories _ OrderedCollection new! !

!MCRepositoryGroup methodsFor: 'as yet unclassified' stamp: 'nk 7/28/2003 18:30'!
versionWithInfoOrNil: aVersionInfo
	self repositories do: [:ea | (ea versionWithInfo: aVersionInfo) ifNotNilDo: [:v | ^ v]].
	^nil! !

!MCRepositoryGroup class methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 00:17'!
default
	^ default ifNil: [default _ self new]! !

!MCRepositoryGroup class methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 00:17'!
new
	^ super new initialize! !

!MCRepositoryGroup methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 00:17'!
addRepository: aRepository
	(repositories includes: aRepository) ifFalse:
		[repositories add: aRepository.
		self class default addRepository: aRepository].
	self changed: #repositories! !

!MCRepositoryGroup methodsFor: 'as yet unclassified' stamp: 'ab 7/22/2003 00:11'!
removeRepository: aRepository
	repositories remove: aRepository ifAbsent: [].
	self changed: #repositories! !

!MCRepositoryGroup methodsFor: 'as yet unclassified' stamp: 'nk 7/28/2003 18:24'!
versionWithInfo: aVersionInfo
	(self versionWithInfoOrNil: aVersionInfo) ifNotNilDo: [ :v | ^v ].
	self error: 'Could not find version ', aVersionInfo name printString! !

Object subclass: #MCDefinitionIndex
	instanceVariableNames: 'definitions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:38'!
add: aDefinition
	definitions at: aDefinition description put: aDefinition! !

!MCDefinitionIndex class methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:29'!
definitions: aCollection
	^ self new addAll: aCollection! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:34'!
initialize
	definitions _ Dictionary new! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:45'!
definitionLike: aDefinition ifPresent: foundBlock ifAbsent: errorBlock
	| definition |
	definition _ definitions at: aDefinition description ifAbsent: [].
	^ definition
		ifNil: errorBlock
		ifNotNil: [foundBlock value: definition]! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:38'!
addAll: aCollection
	aCollection do: [:ea | self add: ea]! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:40'!
remove: aDefinition
	definitions removeKey: aDefinition description ifAbsent: []! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 00:42'!
definitions
	^ definitions values! !

!MCDefinitionIndex class methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:30'!
new
	^ super new initialize! !

Object subclass: #MCSnapshot
	instanceVariableNames: 'definitions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Base'!

!MCSnapshot class methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 23:48'!
fromDefinitions: aCollection
	^ self new initializeWithDefinitions: aCollection! !

!MCSnapshot methodsFor: 'initializing' stamp: 'ab 7/6/2003 23:48'!
initializeWithDefinitions: aCollection
	definitions _ aCollection.! !

!MCSnapshot methodsFor: 'accessing' stamp: 'ab 12/4/2002 18:09'!
definitions
	^ definitions! !

!MCSnapshot methodsFor: 'patching' stamp: 'ab 7/7/2003 00:37'!
patchRelativeToBase: aSnapshot
	^ MCPatch fromBase: aSnapshot target: self! !

!MCSnapshot methodsFor: 'loading' stamp: 'ab 7/7/2003 12:11'!
updatePackage: aPackage
	MCPackageLoader updatePackage: aPackage withSnapshot: self! !

!MCSnapshot methodsFor: 'loading' stamp: 'ab 7/6/2003 23:31'!
install
	MCPackageLoader installSnapshot: self! !

!MCSnapshot methodsFor: 'visiting' stamp: 'ab 7/18/2003 21:58'!
accept: aVisitor
	aVisitor visitSnapshot: self! !

!MCSnapshot methodsFor: 'accessing' stamp: 'ab 7/10/2003 01:05'!
= other
	^ definitions asArray = other definitions asArray! !

!MCSnapshot class methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 23:48'!
empty
	^ self fromDefinitions: #()! !

!MCSnapshot methodsFor: 'accessing' stamp: 'ab 7/10/2003 01:05'!
hash
	^ definitions asArray hash! !

!CrLfFileStream methodsFor: '*monticello' stamp: 'ab 6/26/2003 13:33'!
lineEndingConvention: aSymbol	
	lineEndConvention _ aSymbol! !

!FileList2 class methodsFor: '*monticello' stamp: 'ab 7/5/2003 19:31'!
morphicViewFileSelectorForSuffixes: aList directory: dir
	"Answer a morphic file-selector tool for the given suffix list"

	| aFileList window fixedSize midLine gap |
	aFileList _ self new directory: dir.
	aFileList optionalButtonSpecs: aFileList okayAndCancelServices.
	aList ifNotNil:
		[aFileList fileSelectionBlock: [:entry :myPattern |
			entry isDirectory
				ifTrue:
					[false]
				ifFalse:
					[aList includes: (FileDirectory extensionFor: entry name asLowercase)]] fixTemps].
	window _ BorderedMorph new
		layoutPolicy: ProportionalLayout new;
		color: Color lightBlue;
		borderColor: Color blue;
		borderWidth: 4;
		layoutInset: 4;
		extent: 600@400;
		useRoundedCorners.
	window setProperty: #fileListModel toValue: aFileList.
	aFileList modalView: window.
	midLine _ 0.4.
	fixedSize _ 25.
	gap _ 5.
	self addFullPanesTo: window from: {
		{self textRow: 'Please select a file'. 0 @ 0 corner: 1 @ 0. 0@0 corner: 0@fixedSize}.
		{aFileList optionalButtonRow. 0 @ 0 corner: 1 @ 0. 0@fixedSize corner: 0@(fixedSize * 2)}.
		{aFileList morphicDirectoryTreePane. 0@0 corner: midLine@1. 
					gap @(fixedSize * 2) corner: gap negated@0}.
		{aFileList morphicFileListPane. midLine @ 0 corner: 1@1. 
					gap@(fixedSize * 2) corner: gap negated@0}.
	}.

	aFileList postOpen.

	^ window ! !

!FileList2 class methodsFor: '*monticello' stamp: 'ab 7/5/2003 19:32'!
modalFileSelectorForSuffixes: aList directory: aDirectory

	| window aFileList |

	window _ self morphicViewFileSelectorForSuffixes: aList directory: aDirectory.
	aFileList _ window valueOfProperty: #fileListModel.
	window openCenteredInWorld.
	[window world notNil] whileTrue: [
		window outermostWorldMorph doOneCycleNow.
	].
	^aFileList getSelectedFile! !

Exception subclass: #MCNoChangesException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCNoChangesException methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 19:49'!
defaultAction
	self inform: 'No changes'! !

TestResource subclass: #MCSnapshotResource
	instanceVariableNames: 'snapshot '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCSnapshotResource methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 14:51'!
snapshot
	^ snapshot! !

!MCSnapshotResource methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 14:50'!
definitions
	^ snapshot definitions! !

!MCSnapshotResource methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:20'!
setUp
	snapshot _ self class takeSnapshot.! !

!MCSnapshotResource class methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:19'!
takeSnapshot
	^ self mockPackage snapshot! !

!MCSnapshotResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 20:18'!
mockPackage
	^ (MCPackage new name: self mockPackageName)! !

!MCSnapshotResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 20:18'!
mockPackageName
	^ MCMockPackageInfo default packageName! !

!HTTPSocket class methodsFor: '*monticello' stamp: 'lr 7/30/2003 22:30'!
httpGet: url user: user passwd: passwd
	| authorization |
	authorization _ (Base64MimeConverter mimeEncode: (user , ':' , passwd) readStream) contents.
	^self 
		httpGet: url args: nil accept: '*/*' 
		request: 'Authorization: Basic ' , authorization , CrLf! !

!HTTPSocket class methodsFor: '*monticello' stamp: 'lr 7/30/2003 22:27'!
httpGetDocument: url args: args accept: mimeType request: requestString
	"Return the exact contents of a web object. Asks for the given MIME 
type. If mimeType is nil, use 'text/html'. An extra requestString may be 
submitted and must end with crlf.  The parsed header is saved. Use a 
proxy server if one has been registered.  tk 7/23/97 17:12"
	"Note: To fetch raw data, you can use the MIME type 
'application/octet-stream'."

	| serverName serverAddr port sock header length bare page list firstData 
aStream index connectToHost connectToPort type newUrl |
	Socket initializeNetwork.
	bare _ (url asLowercase beginsWith: 'http://') 
		ifTrue: [url copyFrom: 8 to: url size]
		ifFalse: [url].
	bare _ bare copyUpTo: $#.  "remove fragment, if specified"
	serverName _ bare copyUpTo: $/.
	page _ bare copyFrom: serverName size + 1 to: bare size.
	(serverName includes: $:) 
		ifTrue: [ index _ serverName indexOf: $:.
			port _ (serverName copyFrom: index+1 to: serverName size) asNumber.
			serverName _ serverName copyFrom: 1 to: index-1. ]
		ifFalse: [ port _ self defaultPort ].
	page size = 0 ifTrue: [page _ '/'].
	"add arguments"
	args ifNotNil: [page _ page, (self argString: args) ].


	(self shouldUseProxy: serverName)
		ifFalse: [ 
			connectToHost _ serverName.
			connectToPort _ port ]
		ifTrue:  [
			page _ 'http://', serverName, ':', port printString, page.		"put back 
together"
			connectToHost _ HTTPProxyServer.
			connectToPort _ HTTPProxyPort].
	

	serverAddr _ NetNameResolver addressForName: connectToHost timeout: 20.
	serverAddr ifNil: [
		^ 'Could not resolve the server named: ', connectToHost].

3 timesRepeat: [
	sock _ HTTPSocket new.
	sock connectTo: serverAddr port: connectToPort.
	(sock waitForConnectionUntil: (self deadlineSecs: 30)) ifFalse: [
		Socket deadServer: connectToHost.  sock destroy.
		^ 'Server ',connectToHost,' is not responding'].
	"Transcript cr;show: url; cr.
	Transcript show: page; cr."
	sock sendCommand: 'GET ', page, ' HTTP/1.0', CrLf, 
		(mimeType ifNotNil: ['ACCEPT: ', mimeType, CrLf] ifNil: ['']),
		'ACCEPT: text/html', CrLf,	"Always accept plain text"
		HTTPBlabEmail,	"may be empty"
		requestString,	"extra user request. Authorization"
		self userAgentString, CrLf,
		'Host: ', serverName, ':', port printString, CrLf.	"blank line 
automatically added"

	list _ sock getResponseUpTo: CrLf, CrLf ignoring: (String with: CR).	"list = header, CrLf, CrLf, 
beginningOfData"
	header _ list at: 1.
	"Transcript show: page; cr; show: header; cr."
	firstData _ list at: 3.
	header isEmpty 
		ifTrue: [aStream _ 'server aborted early']
		ifFalse: [
			"dig out some headers"
			sock header: header.
			length _ sock getHeader: 'content-length'.
			length ifNotNil: [ length _ length asNumber ].
			type _ sock getHeader: 'content-type'.
			sock responseCode first = $3 ifTrue: [
				newUrl _ sock getHeader: 'location'.
				newUrl ifNotNil: [ 
					Transcript show: 'redirecting to ', newUrl; cr.
					sock destroy.
					newUrl _ self expandUrl: newUrl ip: serverAddr port: connectToPort.
					^self httpGetDocument: newUrl args: args  accept: mimeType request: requestString] ].
			aStream _ sock getRestOfBuffer: firstData totalLength: length.
			"a 400-series error"
			sock responseCode first = $4 ifTrue: [^ header, aStream contents].
			].
	sock destroy.	"Always OK to destroy!!"
	aStream class ~~ String ifTrue: [
 		^ MIMEDocument contentType: type content: aStream contents url: url].
	aStream = 'server aborted early' ifFalse: [
		]
	].

{'HTTPSocket class>>httpGetDocument:args:accept:request:'. aStream. url} inspect.

	^'some other bad thing happened!!'! !

!Text methodsFor: '*monticello-converting' stamp: 'nk 7/24/2003 15:05'!
withSqueakLineEndings
	^ self class new setString: string withSqueakLineEndings setRunsChecking: runs copy! !

TestCase subclass: #MCMessageStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:48'!
testNestedArrays
	self
		assertChunk:  'Foo bar: #(1 2.1 (foo bar))'
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #((1 2.1 (foo bar))))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:43'!
assertChunk: aString produces: expected
	| reader actual |
	reader _ self createReaderFor: aString.
	actual _ reader next.
	self assert: actual = expected
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:35'!
testBinary
	self
		assertChunk: 'Foo + bar'
	 	produces: (MCMessageSend receiver: #Foo selector: #+ arguments: #(bar))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 17:13'!
testNilAsString
	self
		assertChunk:  'Foo bar: ''nil'''
		produces: (MCMessageSend receiver: #Foo selector: #bar: argument: 'nil')
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:36'!
testSingleNamed
	self
		assertChunk:  'Foo bar: baz'
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #(baz))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:07'!
testNil
	self
		assertChunk:  'Foo bar: nil'
		produces: (MCMessageSend receiver: #Foo selector: #bar: argument: nil)
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:39'!
testIntegerLiteral
	self
		assertChunk:  'Foo bar: 2'
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #(2))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:40'!
testFloatLiteral
	self
		assertChunk:  'Foo bar: 2.1'
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #(2.1))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:07'!
testTrue
	self
		assertChunk:  'Foo bar: true'
		produces: (MCMessageSend receiver: #Foo selector: #bar: argument: true)
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:47'!
testArrayLiteral
	self
		assertChunk:  'Foo bar: #(1 2.1 ''3f'')'
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #((1 2.1 '3f')))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:38'!
testStringLiteral
	self
		assertChunk:  'Foo bar: ''baz'''
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #('baz'))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 00:48'!
createReaderFor: aString
	| stream |
	stream _ RWBinaryOrTextStream on: String new.
	stream nextChunkPut: aString.
	stream reset.
	^ MCMessageStream on: stream.! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:33'!
testUnary
	self 
		assertChunk: 'Foo bar'
		produces: (MCMessageSend receiver: #Foo selector: #bar)
! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:49'!
testCharacterLiteral
	self
		assertChunk:  'Foo bar: $f'
		produces: (MCMessageSend receiver: #Foo selector: #bar: arguments: #($f))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 01:37'!
testDoubleNamed
	self
		assertChunk:  'Foo bar: baz biz: quux'
		produces: (MCMessageSend receiver: #Foo selector: #bar:biz: arguments: #(baz quux))
	! !

!MCMessageStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 02:08'!
testFalse
	self
		assertChunk:  'Foo bar: false'
		produces: (MCMessageSend receiver: #Foo selector: #bar: argument: false)
	! !

TestCase subclass: #MCDependencySorterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:11'!
testCycle
	self assertItems: #(
		(a (x) (y))
		(b (y) (x)))
	orderAs: #()
	withRequired: #()
	toLoad: #(a b)	! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:11'!
testMultiRequirementOrdering
	self assertItems: #(
		(a (x) (z))
		(b (y) ())
		(c (z) ())
		(d () (x y z)))
		orderAs: #(b c a d)
		withRequired: #()
		toLoad: #()! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:11'!
testCascadingUnresolved
	self assertItems: #(
		(a (x) (z))
		(b () (x))
		(c () ()))
	orderAs: #(c)
	withRequired: #(z)
	toLoad: #(a b)	! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:12'!
testSimpleUnresolved
	self assertItems: #(
		(a () (z)))
	orderAs: #()
	withRequired: #(z)
	toLoad: #(a)
		! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 14:08'!
itemWithSpec: anArray
	^ MCMockDependentItem new
		name: anArray first;
		provides: anArray second;
		requires: anArray third! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:11'!
testSimpleOrdering
	self assertItems: #((a (x) ())
								 (c () (y))
								 (b (y) (x)))
		orderAs: #(a b c)
		withRequired: #()
		toLoad: #()! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:10'!
testAlternateProvider
	self assertItems: #(
		(a (x) (z))
		(b () (x))
		(c (x) ()))
	orderAs: #(c b)
	withRequired: #(z)
	toLoad: #(a)	! !

!MCDependencySorterTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 01:16'!
assertItems: anArray orderAs: depOrder withRequired: missingDeps toLoad: unloadableItems
	| order sorter items missing unloadable |
	items _ anArray collect: [:ea | self itemWithSpec: ea].
	sorter _ MCDependencySorter items: items.
	order _ (sorter orderedItems collect: [:ea | ea name]) asArray.
	self assert: order = depOrder.
	missing _ sorter externalRequirements.
	self assert: missing asSet = missingDeps asSet.
	unloadable _ (sorter itemsWithMissingRequirements collect: [:ea | ea name]) asArray.
	self assert: unloadable asSet = unloadableItems asSet! !

TestCase subclass: #MCSortingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCSortingTest methodsFor: 'as yet unclassified' stamp: 'ab 4/8/2003 17:56'!
classNamed: aSymbol
	^ MCClassDefinition
		name: aSymbol
		superclassName: #Object
		category: ''
		instVarNames: #()
		comment: ''! !

!MCSortingTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:01'!
sortDefinitions: aCollection
	^ aCollection asSortedCollection asArray! !

!MCSortingTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 17:57'!
testConsistentSorting
	| definitions shuffledAndSorted|
	definitions _
		{self methodNamed: #a class: #A meta: false.
		self methodNamed: #a class: #A meta: true.
		self methodNamed: #a class: #B meta: false.
		self methodNamed: #b class: #A meta: false.
		self methodNamed: #b class: #B meta: false.
		self classNamed: #A.
		self classNamed: #B}.
	shuffledAndSorted _
		(1 to: 100) collect: [:ea | self sortDefinitions: definitions shuffled].
	self assert: shuffledAndSorted asSet size = 1.
! !

!MCSortingTest methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 17:08'!
testSortOrder
	| aA aAm aB bA bB A B cA bAm cAm |
	aA _ self methodNamed: #a class: #A meta: false.
	bA _ self methodNamed: #b class: #A meta: false.
	cA _ self methodNamed: #c class: #A meta: false.
	aAm _ self methodNamed: #a class: #A meta: true.
	bAm _ self methodNamed: #b class: #A meta: true.
	cAm _ self methodNamed: #c class: #A meta: true.
	aB _ self methodNamed: #a class: #B meta: false.
	bB _ self methodNamed: #b class: #B meta: false.
	A _ self classNamed: #A.
	B _ self classNamed: #B.
	self assert: (self sortDefinitions: {aA. aAm. cAm. aB. bAm. bA. bB. A. cA. B})
					= {A. aAm. bAm. cAm. aA. bA. cA. B. aB.  bB}! !

!MCSortingTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 17:56'!
sortKeyFor: aDefinition
	^ String streamContents:
		[:s |
		aDefinition description
			do: [:ea | s nextPutAll: ea asString]
			separatedBy: [s nextPut: $.]]! !

!MCSortingTest methodsFor: 'as yet unclassified' stamp: 'ab 4/8/2003 18:03'!
methodNamed: aSymbol class: className meta: aBoolean
	^ MCMethodDefinition
		className: className
		classIsMeta: aBoolean
		selector: aSymbol
		category: ''
		timeStamp: ''
		source: ''! !

TestCase subclass: #MCTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCTestCase methodsFor: 'mocks' stamp: 'ab 1/15/2003 17:55'!
mockToken: aSymbol
	^ MCMockDefinition token: aSymbol! !

MCTestCase subclass: #MCMethodDefinitionTest
	instanceVariableNames: 'navigation truth moreTruth one classOne aTwo bTwo '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 17:52'!
testComparison
	|d1 d2 d3 d4 d5 |
	d1 _ self mockMethod: #one class: 'A' source: '1' meta: false.
	d2 _ self mockMethod: #one class: 'A' source: '2' meta: false.
	d3 _ self mockMethod: #one class: 'A' source: '1' meta: true.
	d4 _ self mockMethod: #two class: 'A' source: '1' meta: false.
	d5 _ self mockMethod: #two class: 'A' source: '1' meta: false.
	
	self assert: (d1 isRevisionOf: d2).
	self deny: (d1 isSameRevisionAs: d2).
	
	self deny: (d1 isRevisionOf: d3).
	self deny: (d1 isRevisionOf: d4).
	
	self assert: (d4 isSameRevisionAs: d5).! !

!MCMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 18:57'!
setUp
	navigation _ (Smalltalk hasClassNamed: #SystemNavigation)
		ifTrue: [(Smalltalk at: #SystemNavigation) new]
		ifFalse: [Smalltalk]! !

!MCMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:09'!
testLoadAndUnload
	|definition|
	definition _ self mockMethod: #one class: 'MCMockClassA' source: 'one ^2' meta: false.
	self assert: self mockInstanceA one = 1.
	definition load.
	self assert: self mockInstanceA one = 2.
	definition unload.
	self deny: (self mockInstanceA respondsTo: #one)! !

!MCMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2003 17:24'!
tearDown
	self restoreMocks! !

!MCMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 18:57'!
testCannotLoad
	| definition |
	definition _ self mockMethod: #kjahs87 class: 'NoSuchClass' source: 'kjahs87 ^self' meta: false.
	definition load.
	self assert: (navigation allImplementorsOf: #kjahs87) isEmpty! !

MCTestCase subclass: #MCStWriterTest
	instanceVariableNames: 'stream writer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/2/2003 17:27'!
expectedMethodDefinition
	^ '
!!MCMockClassA methodsFor: ''numeric'' stamp: ''cwp 8/2/2003 17:26''!!
one
	^ 1!! !!
'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'ab 8/8/2003 17:02'!
testInitializerDefinition
	|chunk lastChunk|
	writer visitSnapshot: self mockSnapshot.
	stream reset.
	[stream atEnd] whileFalse:
		[chunk _ stream nextChunk.
		chunk isAllSeparators ifFalse: [lastChunk _ chunk]].
	self assertContentsOf: lastChunk readStream match: self expectedInitializerA! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:11'!
testClassDefinitionA
	writer visitClassDefinition: (self mockClassA asClassDefinition).
	self assertContentsOf: stream match: self expectedClassDefinitionA.
	stream reset.
	2 timesRepeat: [self assertChunkIsWellFormed: stream nextChunk]! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/9/2003 14:52'!
testMethodDefinitionWithBangs
	writer visitMethodDefinition: (MethodReference 
									class: self class 
									selector: #methodWithBangs) asMethodDefinition.
	self assertContentsOf: stream match: self expectedMethodDefinitionWithBangs.
	stream reset.
	self assert: stream nextChunk isAllSeparators.
	self assertChunkIsWellFormed: stream nextChunk.
	self assertMethodChunkIsWellFormed: stream nextChunk.
	self assert: stream nextChunk isAllSeparators ! !

!MCStWriterTest methodsFor: 'asserting' stamp: 'cwp 8/2/2003 12:47'!
assertMethodChunkIsWellFormed: chunk
	Parser new
		parse: chunk readStream 
		class: UndefinedObject 
		noPattern: false
		context: nil
		notifying: nil
		ifFail: [self assert: false]! !

!MCStWriterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2003 11:34'!
assertChunkIsWellFormed: chunk
	Parser new
		parse: chunk readStream 
		class: UndefinedObject 
		noPattern: true
		context: nil
		notifying: nil
		ifFail: [self assert: false]! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/9/2003 14:58'!
expectedMethodDefinitionWithBangs
	^ '
!!MCStWriterTest methodsFor: ''testing'' stamp: ''cwp 8/9/2003 14:55''!!
methodWithBangs
	^ ''
	^ ReadStream on: 
''''MCRevisionInfo packageName: ''''MonticelloCompatibilityTest''''!!!!!!!!
MCOrganizationDeclaration categories: 
  #(
  ''''Monticello-Mocks'''')!!!!!!!!

MCClassDeclaration
  name: #MCMockClassD
  superclassName: #Object
  category: #''''Monticello-Mocks''''
  instVarNames: #()
  comment: ''''''''!!!!!!!!

MCMethodDeclaration className: #MCMockClassD selector: #one category: #''''as yet unclassified'''' timeStamp: ''''cwp 7/8/2003 21:21'''' source: 
''''one
	^ 1''''!!!!!!!!
''''
''
!! !!
'! !

!MCStWriterTest methodsFor: 'asserting' stamp: 'cwp 8/2/2003 17:26'!
assertContentsOf: stream match: expected
	| actual |
	actual _ stream contents.
	self assert: actual size = expected size.
	actual with: expected do: [:a :e | self assert: a=e]
	
	! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/2/2003 12:14'!
expectedOrganizationDefinition
	^ 'SystemOrganization addCategory: ''Monticello-Mocks''!!
'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:11'!
testMethodDefinition
	writer visitMethodDefinition: (MethodReference class: self mockClassA selector: #one) 									asMethodDefinition.
	self assertContentsOf: stream match: self expectedMethodDefinition.
	stream reset.
	self assert: stream nextChunk isAllSeparators.
	self assertChunkIsWellFormed: stream nextChunk.
	self assertMethodChunkIsWellFormed: stream nextChunk.
	self assert: stream nextChunk isAllSeparators ! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 9/14/2003 18:51'!
testClassDefinitionB
	writer visitClassDefinition: (MCMockClassB asClassDefinition).
	self assertContentsOf: stream match: self expectedClassDefinitionB.
	! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 9/14/2003 18:48'!
expectedClassDefinitionB
 ^ '
MCMock subclass: #MCMockClassB
	instanceVariableNames: ''ivarb ''
	classVariableNames: ''CVar ''
	poolDictionaries: ''MCMockClassPoolDictionary ''
	category: ''Monticello-Mocks''!!

MCMockClassB class
	instanceVariableNames: ''ciVar ''!!

!!MCMockClassB commentStamp: '''' prior: 0!!
This comment has a bang!!!! Bang!!!! Bang!!!!!!
'! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/2/2003 14:43'!
expectedClassMethodDefinition
	^ '
!!MCMockClassA class methodsFor: ''as yet unclassified'' stamp: ''ab 7/7/2003 23:21''!!
one

	^ 1!! !!
'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'ab 8/8/2003 17:01'!
expectedInitializerA
	^ 'MCMockClassA initialize'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/2/2003 12:03'!
setUp
	stream _ RWBinaryOrTextStream on: String new.
	writer _ MCStWriter on: stream.
! !

!MCStWriterTest methodsFor: 'asserting' stamp: 'cwp 8/2/2003 12:13'!
assertAllChunksAreWellFormed
	stream reset.
	stream 
		untilEnd: [self assertChunkIsWellFormed: stream nextChunk]
		displayingProgress: 'Checking syntax...'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/2/2003 12:13'!
testOrganizationDefinition
	| definition |
	definition _ MCOrganizationDefinition categories: 
					(self mockPackage packageInfo systemCategories).
	writer visitOrganizationDefinition: definition.
	self assertContentsOf: stream match: self expectedOrganizationDefinition.
	self assertAllChunksAreWellFormed.! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/10/2003 18:02'!
expectedClassDefinitionA
 ^ '
MCMock subclass: #MCMockClassA
	instanceVariableNames: ''ivar ''
	classVariableNames: ''CVar ''
	poolDictionaries: ''''
	category: ''Monticello-Mocks''!!

!!MCMockClassA commentStamp: ''cwp 8/10/2003 16:43'' prior: 0!!
This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.!!
'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:11'!
testClassMethodDefinition
	writer visitMethodDefinition: (MethodReference class: self mockClassA class selector: #one) 									asMethodDefinition.
	self assertContentsOf: stream match: self expectedClassMethodDefinition.
	stream reset.
	self assert: stream nextChunk isAllSeparators.
	self assertChunkIsWellFormed: stream nextChunk.
	self assertMethodChunkIsWellFormed: stream nextChunk.
	self assert: stream nextChunk isAllSeparators ! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/9/2003 14:55'!
methodWithBangs
	^ '
	^ ReadStream on: 
''MCRevisionInfo packageName: ''MonticelloCompatibilityTest''!!!!
MCOrganizationDeclaration categories: 
  #(
  ''Monticello-Mocks'')!!!!

MCClassDeclaration
  name: #MCMockClassD
  superclassName: #Object
  category: #''Monticello-Mocks''
  instVarNames: #()
  comment: ''''!!!!

MCMethodDeclaration className: #MCMockClassD selector: #one category: #''as yet unclassified'' timeStamp: ''cwp 7/8/2003 21:21'' source: 
''one
	^ 1''!!!!
''
'
! !

MCTestCase subclass: #MCSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/1/2003 14:57'!
assertExtensionProvidedBy: aClass
	self shouldnt: [aClass readerClass extension] raise: Exception.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/8/2003 23:01'!
assertClass: readerClass providesServices: labels
	| services suffix |
	suffix _ readerClass extension.
	self assert: (FileList isReaderNamedRegistered: readerClass name).
	services _ readerClass fileReaderServicesForFile: 'foo' suffix: suffix.
	self assert: ((services collect: [:service | service buttonLabel]) includesAllOf: labels)! !

!MCSerializationTest methodsFor: 'testing' stamp: 'cwp 8/8/2003 23:50'!
testServiceRegistration
	self assertAppropriateServicesProvidedBy: MCMcReader.
	self assertAppropriateServicesProvidedBy: MCMcvReader.
	self assertAppropriateServicesProvidedBy: MCMczReader.
! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 9/14/2003 18:37'!
assertAppropriateServicesProvidedBy: readerClass
	readerClass isAbstract ifTrue: [^ self].
	readerClass supportsVersions 
		ifTrue: [self assertClass: readerClass providesServices: #(open merge loadV)]
		ifFalse: [readerClass supportsPackageName
					ifTrue: [self assertClass: readerClass providesServices: #(loadS)]]! !

!MCSerializationTest methodsFor: 'testing' stamp: 'ab 8/20/2003 20:21'!
testMczSerialization
	self assertVersionsMatchWith: MCMczWriter.
	self assertExtensionProvidedBy: MCMczWriter.
	self assertVersionInfosMatchWith: MCMczWriter.! !

!MCSerializationTest methodsFor: 'testing' stamp: 'cwp 8/1/2003 14:55'!
testMcSerialization
	self assertSnapshotsMatchWith: MCMcWriter.
	self assertExtensionProvidedBy: MCMcWriter.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/10/2003 17:37'!
assertSnapshotsMatchWith: writerClass
	| readerClass expected stream actual |
	readerClass _ writerClass readerClass.
	expected _ self mockSnapshot.
	stream _ RWBinaryOrTextStream on: String new.
	writerClass fileOut: expected on: stream.
	actual _ readerClass snapshotFromStream: stream reset.
	self assertSnapshot: actual matches: expected.! !

!MCSerializationTest methodsFor: 'testing' stamp: 'ab 8/20/2003 20:21'!
testMcvSerialization
	self assertSnapshotsMatchWith: MCMcvWriter.
	self assertVersionsMatchWith: MCMcvWriter.
	self assertExtensionProvidedBy: MCMcvWriter.
	self assertVersionInfosMatchWith: MCMcvWriter.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/8/2003 15:02'!
assertVersionsMatchWith: writerClass
	| stream readerClass expected actual |
	readerClass _ writerClass readerClass.
	expected _ self mockVersion.
	stream _ RWBinaryOrTextStream on: String new.
	writerClass fileOut: expected on: stream.
	actual _ readerClass versionFromStream: stream reset.
	self assertVersion: actual matches: expected.! !

!MCSerializationTest methodsFor: 'testing' stamp: 'cwp 8/3/2003 18:43'!
testStSerialization
	self assertSnapshotsMatchWith: MCStWriter.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'ab 8/20/2003 20:22'!
assertVersionInfosMatchWith: writerClass
	| stream readerClass expected actual |
	readerClass _ writerClass readerClass.
	expected _ self mockVersion.
	stream _ RWBinaryOrTextStream on: String new.
	writerClass fileOut: expected on: stream.
	actual _ readerClass versionInfoFromStream: stream reset.
	self assert: actual = expected info.! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/30/2003 19:24'!
mockMessageString
	^ 'A version generated for testing purposes.'! !

MCTestCase subclass: #MCSnapshotBrowserTest
	instanceVariableNames: 'model morph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 09:12'!
assertButtonExists: aString
	self buttonMorphs detect: [:m | m label = aString] ifNone: [self assert: false].
				! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 09:14'!
testThreeButtons
	self assertButtonExists: 'instance'.
	self assertButtonExists: '?'.
	self assertButtonExists: 'class'.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 13:04'!
testClassSelected
	self selectMockClassA.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: self classADefinitionString.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 13:06'!
testClassSideClassSelected
	self clickOnButton: 'class'.
	self selectMockClassA.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAClassProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: self classADefinitionString.! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 09:27'!
denyButtonOn: aString
	self deny: (self findButtonWithLabel: aString) getModelState.
	! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classAProtocols
	^ self protocolsForClass: self mockClassA.! !

!MCSnapshotBrowserTest methodsFor: 'running' stamp: 'ab 7/16/2003 14:41'!
setUp
	model _ MCSnapshotBrowser forSnapshot: MCSnapshotResource current snapshot.
	morph _ model buildWindow.! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/13/2003 02:23'!
classABooleanMethods
	^ #(falsehood moreTruth truth)! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 01:19'!
assertAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getList includesAllOf: anArrayOfStrings]
			ifNone: [self assert: false].! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 08:51'!
denyAListHasSelection: aString
	| found |
	found _ true.
	self listMorphs 
			detect: [:m | m selection = aString]
			ifNone: [found _ false].
	self deny: found.! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 02:38'!
assertTextIs: aString
	self assert: self textMorph contents = aString.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 08:46'!
testProtocolIsCleared
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockASubclass'.
	self clickOnListItem: 'as yet unclassified'.
	self clickOnListItem: 'MCMockClassA'.
	
	self denyAListHasSelection: 'as yet unclassified'.! !

!MCSnapshotBrowserTest methodsFor: 'simulating' stamp: 'cwp 7/13/2003 01:53'!
clickOnListItem: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	listMorph changeModelSelection: (listMorph getList indexOf: aString).! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:37'!
testTextPane
	self shouldnt: [self textMorph] raise: Exception.! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 01:39'!
assertAListMatches: strings
	| listMorphs list |
	listMorphs _ self listMorphs.
	listMorphs 
		detect: [:m | list _ m getList. (list size = strings size) and: [list includesAllOf: strings]]
		ifNone: [self assert: false].! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/28/2003 22:21'!
annotationTextMorph
	^ (self morphsOfClass: TextMorph) first! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 09:12'!
buttonMorphs
	^ self morphsOfClass: PluggableButtonMorph! !

!MCSnapshotBrowserTest methodsFor: 'simulating' stamp: 'cwp 7/13/2003 09:22'!
clickOnButton: aString
	(self findButtonWithLabel: aString) performAction.! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classADefinitionString
	^ self mockClassA definition! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:58'!
allMethods
	^ MCSnapshotResource current definitions
		select: [:def | def isMethodDefinition]
		thenCollect: [:def | def selector]		! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:40'!
testCategorySelected
	self clickOnListItem: self mockCategoryName.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self denyAListIncludesAnyOf: self allProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: ''.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:50'!
testMethodSelected
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	self clickOnListItem: 'boolean'.
	self clickOnListItem: 'falsehood'.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAProtocols.
	self assertAListMatches: self classABooleanMethods.
	self assertTextIs: self falsehoodMethodSource.! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/28/2003 22:21'!
textMorph
	^ (self morphsOfClass: TextMorph) last! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 01:28'!
findListContaining: aString
	^ self listMorphs detect: [:m | m getList includes: aString]! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 02:34'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/28/2003 22:29'!
testAnnotationPane
	| oldPref |
	oldPref _ Preferences annotationPanes.

	Preferences disable: #annotationPanes.
	morph _ model buildWindow.
	self assert: (self morphsOfClass: TextMorph) size = 1.

	Preferences enable: #annotationPanes.
	morph _ model buildWindow.
	self assert: (self morphsOfClass: TextMorph) size = 2.

	Preferences setPreference: #annotationPanes toValue: oldPref! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:59'!
definedClasses
	^ MCSnapshotResource current definitions 
		select: [:def | def isClassDefinition] 
		thenCollect: [:def | def className].! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 09:31'!
testButtonMutex
	self assertButtonOn: 'instance'.
	self denyButtonOn: '?'.
	self denyButtonOn: 'class'.
	
	self clickOnButton: '?'.
	self assertButtonOn: '?'.
	self denyButtonOn: 'instance'.
	self denyButtonOn: 'class'.
	
	self clickOnButton: 'class'.
	self assertButtonOn: 'class'.
	self denyButtonOn: '?'.
	self denyButtonOn: 'instance'.
! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:46'!
allCategories
	^ Array with: model extensionsCategory with: self mockCategoryName.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 08:52'!
testProtocolSelected
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	self clickOnListItem: 'boolean'.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAProtocols.
	self assertAListMatches: self classABooleanMethods.
	self assertTextIs: ''.		! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/13/2003 13:15'!
protocolsForClass: aClass
	| protocols |
	protocols _ aClass organization categories.
	protocols size > 1 ifTrue: [protocols _ protocols copyWith: '-- all --'].
	^ protocols.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 12:52'!
testComment
	self clickOnButton: '?'.
	self assertTextIs: ''.
	
	self clickOnListItem: self mockCategoryName.
	self assertTextIs: ''.
	
	self clickOnListItem: 'MCMockClassA'.
	self assertTextIs: self classAComment.! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:58'!
allProtocols
	^ MCSnapshotResource current definitions
		select: [:def | def isMethodDefinition]
		thenCollect: [:def | def category]		! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/14/2003 14:44'!
morphsOfClass: aMorphClass
	| morphs |
	morphs _ OrderedCollection new.
	morph allMorphsDo: [:m | (m isKindOf: aMorphClass) ifTrue: [morphs add: m]].
	^ morphs! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 09:00'!
testMethodIsCleared
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	self clickOnListItem: 'boolean'.
	self clickOnListItem: 'falsehood'.
	self clickOnListItem: '-- all --'.
	
	self denyAListHasSelection: 'falsehood'.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:39'!
testNoSelection
	self assertAListMatches: self allCategories.
	self denyAListIncludesAnyOf: self definedClasses.
	self denyAListIncludesAnyOf: self allProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: ''.! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 09:26'!
assertButtonOn: aString
	self assert: (self findButtonWithLabel: aString) getModelState.
	! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/13/2003 02:53'!
falsehoodMethodSource
	^ 'falsehood
	^ false'! !

!MCSnapshotBrowserTest methodsFor: 'selecting' stamp: 'cwp 7/13/2003 13:04'!
selectMockClassA
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:30'!
testFourColumns
	self assert: self listMorphs size = 4.! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 09:19'!
findButtonWithLabel: aString
	^ self buttonMorphs detect: [:m | m label = aString]! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classAClassProtocols
	^ self protocolsForClass: self mockClassA class.! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classAComment
	^ self mockClassA organization classComment.! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 02:05'!
denyAListIncludesAnyOf: anArrayOfStrings
	| found |
	found _ true.
	self listMorphs 
			detect: [:m | m getList includesAnyOf: anArrayOfStrings]
			ifNone: [found _ false].
	self deny: found.! !

!MCSnapshotBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 14:59'!
resources
	^ Array with: MCSnapshotResource! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 23:25'!
assertSnapshot: actual matches: expected
	| diff |
	diff _ actual patchRelativeToBase: expected.
	self assert: diff isEmpty
! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/30/2003 19:23'!
mockVersion
	^ MCVersion 
		package: self mockPackage
		info: self mockVersionInfo
		snapshot: self mockSnapshot! !

MCTestCase subclass: #MCInitializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCInitializationTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2003 23:06'!
tearDown
	(MCWorkingCopy forPackage: self mockPackage) unregister! !

!MCInitializationTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 12:11'!
isAbstract
	^ (Smalltalk hasClassNamed: #MczInstaller) not
		! !

!MCInitializationTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2003 23:50'!
testWorkingCopy
	MczInstaller storeVersionInfo: self mockVersion.
	MCWorkingCopy initialize.
	MCWorkingCopy allManagers
						detect: [:man | man package name = self mockPackage name]
						ifNone: [self assert: false]! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 16:53'!
commentStampForClass: name
	^ 'tester-', name,  ' 1/1/2000 00:00'! !

MCTestCase subclass: #MCPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 23:43'!
testUnload
	self mockPackage unload.
	self deny: (Smalltalk hasClassNamed: #MCMockClassA).
	self deny: (MCSnapshotTest includesSelector: #mockClassExtension)! !

!MCPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 23:43'!
tearDown
	self mockSnapshot install! !

MCTestCase subclass: #MCPatchTest
	instanceVariableNames: 'patch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCPatchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2003 17:24'!
tearDown
	self restoreMocks! !

!MCPatchTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:31'!
testPatchContents
	self assert: patch operations size = 1.
	self assert: patch operations first isModification.
	self assert: patch operations first definition selector = #one.
! !

!MCPatchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2003 17:24'!
setUp
	|rev1 rev2|
	rev1 _  MCSnapshotResource takeSnapshot.
	self change: #one toReturn: 2.
	rev2 _  MCSnapshotResource takeSnapshot.
	patch _ rev2 patchRelativeToBase: rev1.
	self change: #one toReturn: 1.! !

MCTestCase subclass: #MCWorkingCopyTest
	instanceVariableNames: 'workingCopy repositoryGroup versions versions2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 20:19'!
testMergeIntoUnmodifiedImage
	| base revA |

	base _ self snapshot.
	self change: #a toReturn: 'a1'.
	revA _ self snapshot.
	
	self load: base.

	self merge: revA.

	self assert: (workingCopy versionInfo ancestors size = 1)
	! !

!MCWorkingCopyTest methodsFor: 'private' stamp: 'cwp 8/2/2003 15:03'!
packageName
	^ self mockPackage name! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 20:21'!
basicMerge: aVersion
	workingCopy merge: aVersion! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 20:22'!
merge: aVersion
	[[self basicMerge: aVersion]
		on: MCMergeResolutionRequest do: [:n | n resume: true]]
			on: MCNoChangesException do: [:n | ]! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 18:02'!
description
	^ self class name! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:47'!
testRedundantMerge
	| base |
	base _  self snapshot.
	self merge: base.
	self shouldnt: [self merge: base] raise: Error.! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:13'!
testRepeatedMerge
	| base mother1 mother2 inst |

	base _  self snapshot.
	self change: #one toReturn: 2.
	mother1 _  self snapshot.
	self change: #two toReturn: 3.
	mother2 _  self snapshot.	
	
	self load: base.
	self change: #truth toReturn: false.
	self snapshot.

	inst _ self mockInstanceA.
	self assert: inst one = 1.
	self assert: inst two = 2.	

	self merge: mother1.
	self assert: inst one = 2.
	self assert: inst two = 2.	
	
	self change: #one toReturn: 7.
	self assert: inst one = 7.
	self assert: inst two = 2.
	
	self shouldnt: [self merge: mother2] raise: Error.
	self assert: inst one = 7.
	self assert: inst two = 3.! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:36'!
assertNumberWhenSavingTo: aRepository is: aNumber
	| name |
	name _ nil.
	[aRepository storeVersion: workingCopy newVersion]
		on: MCVersionNameAndMessageRequest
		do: [:n | name _ n suggestedName. n resume: (Array with: name with: '')].
	self assert: name = (self packageName, '-', Utilities authorInitials, '.', aNumber asString)! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:14'!
testSnapshotAndLoad
	| base inst |
	inst _ self mockInstanceA.
	base _  self snapshot.
	self change: #one toReturn: 2.
	self assert: inst one = 2.
	self load: base.
	self assert: inst one = 1.! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:13'!
testSimpleMerge
	| mother base inst |
	inst _ self mockInstanceA.
	base _  self snapshot.
	self change: #one toReturn: 2.
	mother _  self snapshot.
	self load: base.
	self change: #two toReturn: 3.
	self snapshot.
	self assert: inst one = 1.
	self assert: inst two = 3.
	
	self merge: mother.
	self assert: inst one = 2.
	self assert: inst two = 3.! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:14'!
testSnapshotAndRevert
	| inst |
	inst _ self mockInstanceA.
	self snapshot.
	self change: #one toReturn: 2.
	self assert: inst one = 2.
	workingCopy revert.
	self assert: inst one = 1! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 01:05'!
testNaming
	| repos version |
	repos _ MCDictionaryRepository new.
	self assertNumberWhenSavingTo: repos is: 1.
	self assertNumberWhenSavingTo: repos is: 2.
	repos _ MCDictionaryRepository new.
	self assertNumberWhenSavingTo: repos is: 3.
	version _ self snapshot.
	version info setName: 'foo.32' message: ''.
	workingCopy load: version.
	self assertNumberWhenSavingTo: repos is: 33.
	self assertNumberWhenSavingTo: repos is: 34.
	version info setName: (self packageName, '-', Utilities authorInitials, '.35') message: ''.
	repos storeVersion: version.
	self assertNumberWhenSavingTo: repos is: 36.
	self assertNumberWhenSavingTo: repos is: 37.
	version info setName: 'foo.10' message: ''.
	repos storeVersion: version.
	self assertNumberWhenSavingTo: repos is: 38.
	version info setName: 'foo2-ab.40' message: ''.
	workingCopy load: version.
	self assertNumberWhenSavingTo: repos is: 41.! !

!MCWorkingCopyTest methodsFor: 'running' stamp: 'cwp 8/2/2003 15:06'!
tearDown
	workingCopy unregister.
	self restoreMocks.! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:36'!
snapshot
	| version |
	[version _ workingCopy newVersion]
		on: MCVersionNameAndMessageRequest
		do: [:n | n resume: (Array with: n suggestedName with: '')].
	versions at: version info put: version.
	^ version! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:48'!
load: aVersion
	workingCopy load: aVersion! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 20:12'!
testMergeIntoImageWithNoChanges
	| base revB revA1 |

	self change: #a toReturn: 'a'.
	base _ self snapshot.
	self change: #b toReturn: 'b'.
	revB _ self snapshot.
	
	self load: base.
	self change: #a toReturn: 'a1'.
	revA1 _ self snapshot.

	self change: #a toReturn: 'a'.
	self snapshot.
	self merge: revB.

	self assert: (workingCopy versionInfo ancestors size = 2)
	! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'jf 8/21/2003 20:23'!
testAncestorMerge
	| base revA revB revC |

	base _ self snapshot.
	self change: #a toReturn: 'a1'.
	revA _  self snapshot.
	self change: #b toReturn: 'b1'.
	revB _  self snapshot.	
	self change: #c toReturn: 'c1'.
	revC _  self snapshot.	

	self should: [self basicMerge: revA] raise: MCNoChangesException.
	! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:12'!
testDoubleRepeatedMerge
	| base motherA1 motherA2 motherB1 motherB2 inst |

	base _ self snapshot.
	self change: #a toReturn: 'a1'.
	motherA1 _  self snapshot.
	self change: #c toReturn: 'c1'.
	motherA2 _  self snapshot.	
	
	self load: base.
	self change: #b toReturn: 'b1'.
	motherB1 _  self snapshot.
	self change: #d toReturn: 'd1'.
	motherB2 _  self snapshot.
	
	self load: base.
	self merge: motherA1.
	self merge: motherB1.
	self change: #a toReturn: 'a2'.
	self change: #b toReturn: 'b2'.
	self snapshot.

	self shouldnt: [self merge: motherA2] raise: Error.
	self shouldnt: [self merge: motherB2] raise: Error.
	
	inst _ self mockInstanceA.
	self assert: inst a = 'a2'.
	self assert: inst b = 'b2'.
	self assert: inst c = 'c1'.
	self assert: inst d = 'd1'.
	! !

!MCWorkingCopyTest methodsFor: 'running' stamp: 'avi 8/31/2003 15:38'!
setUp
	| repos1 repos2 |
	repositoryGroup _ MCRepositoryGroup new.
	workingCopy _ MCWorkingCopy forPackage: self mockPackage.
	versions _ Dictionary new.
	versions2 _ Dictionary new.
	repos1 _ MCDictionaryRepository new dictionary: versions.
	repos2 _ MCDictionaryRepository new dictionary: versions2.
	repositoryGroup addRepository: repos1.
	repositoryGroup addRepository: repos2.
	MCRepositoryGroup default removeRepository: repos1; removeRepository: repos2.
	workingCopy repositoryGroup: repositoryGroup.! !

!MCWorkingCopyTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2003 18:53'!
testRepositoryFallback
	| version |
	version _ self snapshot.
	self assert: (repositoryGroup versionWithInfo: version info) == version.
	versions removeKey: version info.
	versions2 at: version info put: version.
	self assert: ( repositoryGroup versionWithInfo: version info) == version.
	versions2 removeKey: version info.
	MCVersion clearCache.
	self should: [repositoryGroup versionWithInfo: version info] raise: Error.! !

MCTestCase subclass: #MCStReaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2003 23:35'!
commentWithStyle
	^ '!!AEDesc commentStamp: ''<historical>'' prior: 0!!
I represent an Apple Event Descriptor.  I am a low-level representation of Apple Event (and hence Applescript) information.  For further Information, see Apple''s Inside Macintosh: Interapplication Communications, at

	http://developer.apple.com/techpubs/mac/IAC/IAC-2.html.

Essentially, I represent a record comprising a one-word "string" (treating the word as fourbyte characters) representing a data type, followed by a pointer to a pointer (a handle) to the data I represent.  Care must be taken to assure that the Handle data is disposed after use, or memory leaks result.  At this time, I make no effort to do this automatically through finalization.!!
]style[(218 54 384)f1,f1Rhttp://developer.apple.com/techpubs/mac/IAC/IAC-2.html;,f1!!
'! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 16:52'!
testCommentWithoutStyle
	| reader |
	reader _ MCStReader on: self commentWithoutStyle readStream.
	self assert: (reader definitions anySatisfy: [:ea | ea isMethodDefinition]).! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2003 23:41'!
testCommentWithStyle
	| reader |
	reader _ MCStReader on: self commentWithStyle readStream.
	reader definitions! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2003 23:07'!
methodWithStyle
	^ '!!EventHandler methodsFor: ''copying'' stamp: ''tk 1/22/2001 17:39''!!
veryDeepInner: deepCopier
	"ALL fields are weakly copied.  Can''t duplicate an object by duplicating a button that activates it.  See DeepCopier."

	super veryDeepInner: deepCopier.
	"just keep old pointers to all fields"
	clickRecipient _ clickRecipient.!!
]style[(25 108 10 111)f1b,f1,f1LDeepCopier Comment;,f1!! !!

'! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 16:52'!
commentWithoutStyle
	^ '
CharacterScanner subclass: #CanvasCharacterScanner
	instanceVariableNames: ''canvas fillBlt foregroundColor runX lineY ''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Morphic-Support''!!

!!CanvasCharacterScanner commentStamp: ''<historical>'' prior: 0!!
A displaying scanner which draws its output to a Morphic canvas.!!

!!CanvasCharacterScanner methodsFor: ''stop conditions'' stamp: ''ar 12/15/2001 23:27''!!
setStopConditions
	"Set the font and the stop conditions for the current run."

	self setFont.
	stopConditions
		at: Space asciiValue + 1
		put: (alignment = Justified ifTrue: [#paddedSpace])!! !!'! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2003 23:47'!
testMethodWithStyle
	| reader |
	reader _ MCStReader on: self methodWithStyle readStream.
	self assert: reader definitions first isMethodDefinition.! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 16:51'!
commentForClass: name
	^ 'This is a comment for ', name! !

MCTestCase subclass: #MCCompatibilityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 14:01'!
assertReaderClass: readerClass forPackageAccepts: spec
	| reader result |
	reader _ readerClass on: spec mockStream.
	result _ reader package.
	spec compare: result using: [:actual :expected | self assert: actual = expected]! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 14:01'!
test70RevisionInfo
	self 
		assertReaderClass: MCMcReader
		forPackageAccepts: (MCMessageSpec
			definition: (MCPackage named: 'MonticelloMocks')
			receiver: #MCRevisionInfo
			selector: #packageName:
			attributes: #(name))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:23'!
testMc159CommentBug
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			definition: (self mockClassA asClassDefinition)
			receiver: #MCClassDeclaration
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:comment:
			attributes: #(className superclassName instVarNames classVarNames poolDictionaries classInstVarNames comment)
			arguments: #(MCMockClassA #MCMock #'Monticello-Mocks' #('ivar') #('CVar') #() #() #(Text string: 'This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.' runs: (RunArray runs: #(110 ) values: ((Array new: 1) at: 1 put: ((Array new: 1) at: 1 put: (TextFontChange basicNew instVarAt: 1 put: 1; yourself); yourself); yourself)))))! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:17'!
testMc204ClassDeclaration3
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClass: $E
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:type:comment:
			attributes: #(className superclassName category instVarNames classVarNames poolDictionaries classInstVarNames type comment))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:22'!
test70MethodDeclaration1
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forMethod: #one 
			ofClass: $D
			receiver: #MCMethodDeclaration
			selector: #className:selector:category:timeStamp:source:
			attributes: #(className selector category timeStamp source))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:23'!
test70ClassDeclaration1
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClass: $D
			receiver: #MCClassDeclaration
			selector: #name:superclassName:category:instVarNames:comment:
			attributes: #(className superclassName category instVarNames comment))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:16'!
testMcv204ClassDeclaration2
	self 
		assertReaderClass: MCMcvReader
		accepts: (MCMessageSpec
			forClass: $F
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:comment:
			attributes: #( className superclassName category instVarNames classVarNames poolDictionaries classInstVarNames comment))
	
! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:22'!
test70ClassDeclaration3
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClass: $E
			receiver: #MCClassDeclaration
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:type:comment:
			attributes: #(className superclassName category instVarNames classVarNames poolDictionaries classInstVarNames type comment))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:17'!
testMcv204ClassDeclaration3
	self 
		assertReaderClass: MCMcvReader
		accepts: (MCMessageSpec
			forClass: $E
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:type:comment:
			attributes: #(className superclassName category instVarNames classVarNames poolDictionaries classInstVarNames type comment))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:22'!
testMcv159CommentBug
	self 
		assertReaderClass: MCMcvReader
		accepts: (MCMessageSpec
			definition: (self mockClassA asClassDefinition)
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:comment:
			attributes: #(className superclassName instVarNames classVarNames poolDictionaries classInstVarNames comment)
			arguments: #(MCMockClassA #MCMock #'Monticello-Mocks' #('ivar') #('CVar') #() #() #(Text string: 'This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.' runs: (RunArray runs: #(110 ) values: ((Array new: 1) at: 1 put: ((Array new: 1) at: 1 put: (TextFontChange basicNew instVarAt: 1 put: 1; yourself); yourself); yourself)))))! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:14'!
testMcv204ClassDefinition1
	self 
		assertReaderClass: MCMcvReader
		accepts: (MCMessageSpec
			forClass: $D
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:comment:
			attributes: #(className superclassName category instVarNames comment))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:31'!
test70MethodDeclaration2
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClassMethod: #two 
			ofClass: $E
			receiver: #MCMethodDeclaration
			selector: #className:classIsMeta:selector:category:timeStamp:source:
			attributes: #(className classIsMeta selector category timeStamp source))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:44'!
test70Organization
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			definition: (MCOrganizationDefinition categories: #('Monticello-Mocks'))
			receiver: #MCOrganizationDeclaration
			selector: #categories:
			attributes: #(categories))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:19'!
assertReaderClass: readerClass accepts: spec
	| reader result |
	reader _ readerClass on: spec mockStream.
	result _ reader definitions first.
	spec compare: result using: [:actual :expected | self assert: actual = expected]! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:14'!
testMc204ClassDefinition1
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClass: $D
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:comment:
			attributes: #(className superclassName category instVarNames comment))
		! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:16'!
testMc204ClassDeclaration2
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClass: $F
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:comment:
			attributes: #( className superclassName category instVarNames classVarNames poolDictionaries classInstVarNames comment))
	
! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 13:23'!
test70ClassDeclaration2
	self 
		assertReaderClass: MCMcReader
		accepts: (MCMessageSpec
			forClass: $F
			receiver: #MCClassDeclaration
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:comment:
			attributes: #( className superclassName category instVarNames classVarNames poolDictionaries classInstVarNames comment))
	
! !

!MCCompatibilityTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:07'!
test159CommentBug
	self 
		assertReaderClass: MCMcvReader
		accepts: (MCMessageSpec
			definition: (self mockClassA asClassDefinition)
			receiver: #MCClassDefinition
			selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:comment:
			attributes: #(className superclassName instVarNames classVarNames poolDictionaries classInstVarNames comment)
			arguments: #(MCMockClassA #MCMock #'Monticello-Mocks' #('ivar') #('CVar') #() #() #(Text string: 'This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.' runs: (RunArray runs: #(110 ) values: ((Array new: 1) at: 1 put: ((Array new: 1) at: 1 put: (TextFontChange basicNew instVarAt: 1 put: 1; yourself); yourself); yourself)))))! !

MCTestCase subclass: #MCSnapshotTest
	instanceVariableNames: 'snapshot '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCSnapshotTest methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:14'!
testInstanceReuse
	| x m n y |
	x _ (MCPackage new name: self mockCategoryName) snapshot.
	Smalltalk garbageCollect.
	n _ MCDefinition allSubInstances size.
	y _ (MCPackage new name: self mockCategoryName) snapshot.
	Smalltalk garbageCollect.
	m _ MCDefinition allSubInstances size.
	self assert: m = n! !

!MCSnapshotTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 13:38'!
setUp
	snapshot _  self mockSnapshot.! !

!MCSnapshotTest methodsFor: '*monticello-mocks' stamp: 'ab 7/7/2003 23:21'!
mockClassExtension! !

!MCSnapshotTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 13:38'!
testCreation
	|d|
	d _  self mockSnapshot definitions.
	self assert: (d anySatisfy: [:ea | ea isClassDefinition and: [ea className = #MCMockClassA]]).
	self assert: (d anySatisfy: [:ea | ea isMethodDefinition and: [ea selector = #mockClassExtension]]).
	self assert: (d allSatisfy: [:ea | ea isClassDefinition not or: [ea category endsWith: 'Mocks']]).
	! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 14:58'!
assertPackage: actual matches: expected
	self assert: actual = expected
! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/14/2003 15:07'!
mockSnapshot
	^ MCSnapshotResource current snapshot! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/8/2003 15:48'!
mockVersionInfo: tag 
	^ MCVersionInfo new
		setName: self mockVersionName, '-', tag asString
		message: self mockMessageString, '-', tag asString! !

!MCTestCase methodsFor: 'mocks' stamp: 'ab 4/1/2003 02:02'!
mockMethod: aSymbol class: className source: sourceString meta: aBoolean
	^ MCMethodDefinition
		className: className
		classIsMeta: aBoolean
		selector:  aSymbol
		category: 'as yet unclassified'
		timeStamp: ''
		source: sourceString! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/30/2003 19:25'!
mockVersionName
	^ 'MonticelloTest-xxx.1'! !

!MCTestCase methodsFor: 'mocks' stamp: 'ab 7/19/2003 15:43'!
mockCategoryName
	^ 'Monticello-Mocks'! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/1/2003 20:27'!
mockPackage
	^ MCSnapshotResource mockPackage! !

MCTestCase subclass: #MCFileInTest
	instanceVariableNames: 'stream expected diff '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 00:13'!
testStWriter
	self
		assertFileOutFrom: MCStWriter
		canBeFiledInWith: [stream fileIn].
! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:30'!
assertSuccessfulLoadWith: aBlock
	stream reset.
	aBlock value.
	self assertNoChange.
	self assertInitializersCalled.! !

!MCFileInTest methodsFor: 'running' stamp: 'cwp 8/2/2003 13:01'!
setUp
	expected _ self mockSnapshot.
	stream _ RWBinaryOrTextStream on: String new.! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:30'!
assertFileOutFrom: writerClass canBeFiledInWith: aBlock
	writerClass fileOut: self mockVersion on: stream.
	self alterInitialState.
	self assertSuccessfulLoadWith: aBlock.
	self mockPackage unload.
	self assertSuccessfulLoadWith: aBlock.
! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:08'!
assertInitializersCalled
	| cvar |
	cvar _ self mockClassA cVar.
	self assert: cvar = #initialized! !

!MCFileInTest methodsFor: 'asserting' stamp: 'cwp 8/2/2003 13:02'!
assertNoChange
	| actual |
	actual _ MCSnapshotResource takeSnapshot.
	diff _ actual patchRelativeToBase: expected.
	self assert: diff isEmpty! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/12/2003 01:45'!
testBootstrapMcv
	self 
		assertFileOutFrom: MCMcvWriter
		canBeFiledInWith: [MCBootstrapLoader loadStream: stream].
! !

!MCFileInTest methodsFor: 'running' stamp: 'cwp 8/10/2003 00:27'!
tearDown
	(diff isNil or: [diff isEmpty not])
		 ifTrue: [expected updatePackage: self mockPackage]! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/12/2003 01:45'!
testBootstrapMc
	self 
		assertFileOutFrom: MCMcWriter 
		canBeFiledInWith: [MCBootstrapLoader loadStream: stream].
! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:08'!
alterInitialState
	self mockClassA touchCVar! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/8/2003 15:49'!
mockVersionInfo
	| a b c d |
	a _ self mockVersionInfo: 'a'.
	b _ self mockVersionInfo: 'b'.
	c _ self mockVersionInfo: 'c'.
	d _ self mockVersionInfo: 'd'.
	b addAncestor: a.
	d addAncestor: b.
	d addAncestor: c.
	^ d! !

MCTestCase subclass: #MCMczInstallerTest
	instanceVariableNames: 'expected diff '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 18:16'!
fileStream
	^ FileStream forceNewFileNamed: self fileName.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 18:18'!
deleteFile
	(FileDirectory default fileExists: self fileName)
		ifTrue: [FileDirectory default deleteFileNamed: self fileName]! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 19:58'!
assertDict: dict matchesInfo: info
	#(name id message date time author)
		do: [:sel | self assert: (dict at: sel) = (info perform: sel)].
	info ancestors 
			with: (dict at: #ancestors) 
			do: [:i :d | self assertDict: d matchesInfo: i]! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 18:15'!
fileName
	^ 'InstallerTest.mcz'! !

!MCMczInstallerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 12:11'!
isAbstract
	^ (Smalltalk hasClassNamed: #MczInstaller) not
		! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 19:31'!
setUp
	expected _ self mockVersion.
	self change: #one toReturn: 2.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:25'!
testInstallFromFile
	MCMczWriter fileOut: expected on: self fileStream.
	MczInstaller installFileNamed: self fileName.
	self assertNoChange.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:25'!
testInstallFromStream
	| stream |
	stream _ RWBinaryOrTextStream on: String new.
	MCMczWriter fileOut: expected on: stream.
	MczInstaller installStream: stream reset.
	self assertNoChange.
	self assertVersionInfoPresent.
	! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 19:38'!
assertNoChange
	| actual |
	actual _ MCSnapshotResource takeSnapshot.
	diff _ actual patchRelativeToBase: expected snapshot.
	self assert: diff isEmpty! !

!MCMczInstallerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 11:56'!
suite
	^ (Smalltalk hasClassNamed: #MczInstaller)
		ifTrue: [super suite]
		ifFalse: [TestSuite new name: self name asString]! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:25'!
assertVersionInfoPresent
	| dict info |
	dict _ MczInstaller versionInfo at: self mockPackage name.
	info _ expected info.
	self assertDict: dict matchesInfo: info.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 19:36'!
tearDown
	expected snapshot updatePackage: self mockPackage.
	self deleteFile.! !

MCTestCase subclass: #MCOrganizationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCOrganizationTest methodsFor: 'as yet unclassified' stamp: 'JF 7/23/2003 17:57'!
testReorderingWithNoCategoriesInVersion
	|dec cats newCats |
	dec _ MCOrganizationDefinition categories: #().
	cats _ #(X Y B Z C A Q).
	newCats _ dec reorderCategories: cats.
	self assert: newCats asArray = cats.! !

!MCOrganizationTest methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 13:39'!
testReordering
	|dec cats newCats |
	dec _ MCOrganizationDefinition categories: #(A B C).
	cats _ #(X Y B Z C A Q).
	newCats _ dec reorderCategories: cats.
	self assert: newCats asArray = #(X Y A B C Z Q).! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 15:50'!
assertVersionInfo: actual matches: expected
	self assert: actual name = expected name.
	self assert: actual message = expected message.
	self assert: actual ancestors size = expected ancestors size.
	actual ancestors with: expected ancestors do: [:a :e | self assertVersionInfo: a matches: e]
	! !

MCTestCase subclass: #MCClassDefinitionTest
	instanceVariableNames: 'previousChangeSet '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCClassDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 17:59'!
classACommentStamp
	^  'cwp 8/10/2003 16:43'! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 17:12'!
testCannotLoad
	| d c |
	d _  self mockClass: 'MCMockClassC' super: 'NotAnObject'.
	d load.
	self deny: (Smalltalk hasClassNamed: 'MCMockClassC').! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:39'!
testCreation
	| d |
	d _  self mockClassA asClassDefinition.
	self assert: d className = #MCMockClassA.
	self assert: d superclassName = #MCMock.
	self assert: d type = #normal.
	self assert: d category = self mockCategoryName.
	self assert: d instVarNames asArray = #('ivar').
	self assert: d classVarNames asArray = #('CVar').
	self assert: d classInstVarNames asArray = #().
	self assert: d comment isString.
	self assert: d comment = self classAComment.
	self assert: d commentStamp = self mockClassA organization commentStamp! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:57'!
tearDown
	Smalltalk at: 'MCMockClassC' ifPresent: [:c | c removeFromSystem]! !

!MCClassDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:20'!
classAComment
	^ 'This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.'! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 17:20'!
testEquals
	| a b |
	a _ self mockClass: 'ClassA' super: 'SuperA'.
	b _ self mockClass: 'ClassA' super: 'SuperA'.
	self assert: a = b! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:06'!
testDefinitionString
	| d |
	d _ self mockClassA asClassDefinition.
	self assert: d definitionString = self mockClassA definition.! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 17:53'!
testComparison
	| d1 d2 d3 d4 |
	d1 _ self mockClass: 'A' super: 'X'.
	d2 _ self mockClass: 'A' super: 'Y'.
	d3 _ self mockClass: 'B' super: 'X'.
	d4 _ self mockClass: 'B' super: 'X'.
	
	self assert: (d1 isRevisionOf: d2).
	self deny: (d1 isSameRevisionAs: d2).

	self assert: (d3 isRevisionOf: d4).
	self assert: (d3 isSameRevisionAs: d4).
	
	self deny: (d1 isRevisionOf: d3).
	self deny: (d4 isRevisionOf: d2).! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:20'!
classAComment
	^ self class classAComment! !

!MCClassDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:01'!
restoreClassAComment
	Smalltalk 
		at: #MCMockClassA 
		ifPresent: [:a | a classComment: self classAComment stamp: self classACommentStamp]! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 17:17'!
creationMessage
	^ MessageSend
		receiver: MCClassDefinition
		selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:type:comment:commentStamp:! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:07'!
testKindOfSubclass
	| classes d |
	classes _ {self mockClassA. String. MethodContext. WeakArray. Float}.
	classes do: [:c |
		d _  c asClassDefinition.
		self assert: d kindOfSubclass = c kindOfSubclass.
	].! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2003 02:37'!
testEqualsSensitivity
	| message a b defA args defB |
	message _ self creationMessage.
	a _ #(ClassA SuperA CategoryA #(iVarA) #(CVarA) #(PoolA) #(ciVarA)
			typeA 'A comment' 'A').
	b _ #(ClassB SuperB CategoryB #(iVarB) #(CVarB) #(PoolB) #(ciVarB)
			typeB 'B comment' 'B').
	
	defA _ message valueWithArguments: a.
	1 to: 8 do: [:index |
				args _ a copy.
				args at: index put: (b at: index).
				defB _ message valueWithArguments: args.
				self deny: defA = defB.]! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:54'!
testLoadAndUnload
	| d c |
	d _  self mockClass: 'MCMockClassC' super: 'Object'.
	d load.
	self assert: (Smalltalk hasClassNamed: 'MCMockClassC').
	c _ (Smalltalk classNamed: 'MCMockClassC').
	self assert: (c isKindOf: Class).
	self assert: c superclass = Object.
	self assert: c instVarNames isEmpty.
	self assert: c classVarNames isEmpty.
	self assert: c sharedPools isEmpty.
	self assert: c category = self mockCategoryName.
	self assert: c organization classComment = (self commentForClass: 'MCMockClassC').
	self assert: c organization commentStamp = (self commentStampForClass: 'MCMockClassC').
	d unload.
	self deny: (Smalltalk hasClassNamed: 'MCMockClassC').! !

MCTestCase subclass: #MCMergingTest
	instanceVariableNames: 'conflictBlock conflicts '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:42'!
handleConflict: aConflict	
	|l r|
	l _ #removed.
	r _ #removed.
	aConflict localDefinition ifNotNilDo: [:d | l _ d token].
	aConflict remoteDefinition ifNotNilDo: [:d | r _ d token].	
	conflicts _ conflicts copyWith: (Array with: r with: l).
	(l = #removed or: [r = #removed])
		ifTrue: [aConflict chooseRemote]
		ifFalse:
			[l > r
				ifTrue: [aConflict chooseLocal]
				ifFalse: [aConflict chooseRemote]]
		! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:44'!
testLocalModifyRemoteRemove
	self assertMerge: #(a2 b1)
				with: #(b1)
				base: #(a1 b1)
				
				gives: #(b1)
				conflicts: #((removed a2)).
				
	self assertMerge: #(a1 b1)
				with: #(b1)
				base: #(a2 b1)
				
				gives: #(b1)
				conflicts: #((removed a1)).! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:38'!
testSimultaneousModification
	self assertMerge: #(a2)
				with: #(a3)
				base: #(a1)
				
				gives: #(a3)
				conflicts: #((a3 a2)).! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 00:27'!
testComplexConflictlessMerge
	self 
		assertMerge: #(a1 b1 d1)
				with: #(a2 c1)
				base: #(a1 c1 d1)
				
				gives: #(a2 b1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 23:48'!
snapshotWithElements: anArray
	^ MCSnapshot
		fromDefinitions: (anArray collect: [:t | self mockToken: t])! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 01:31'!
testSubtractiveConflictlessMerge
	self assertMerge: #(a1 b1)
				with: #()
				base: #(a1)
				
				gives: #(b1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 00:28'!
testIdenticalModification
	self
		assertMerge: #(a2 b1)
				with: #(a2 b1)
				base: #(a1 b1)
				
				gives: #(a2 b1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:25'!
assertMerge: local with: remote base: ancestor gives: result conflicts: conflictResult
	| merger |
	conflicts _ #().
	merger _ MCThreeWayMerger
				base: (self snapshotWithElements: local)
				target: (self snapshotWithElements: remote)
				ancestor: (self snapshotWithElements: ancestor).
	merger conflicts do: [:ea | self handleConflict: ea].
	self assert: merger mergedSnapshot definitions hasElements: result.
	self assert: conflicts asSet = conflictResult asSet.! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 01:27'!
testSimultaneousRemove
	self assertMerge: #(a1)
				with: #(a1)
				base: #(a1 b1)
				
				gives: #(a1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 16:46'!
assert: aCollection hasElements: anArray
	self assert: (aCollection collect: [:ea | ea token]) asSet = anArray asSet! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 12/5/2002 00:28'!
testAdditiveConflictlessMerge
	self
		assertMerge: #(a1 b1)
				with: #(a1 c1)
				base: #(a1)
			
				gives: #(a1 b1 c1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:38'!
testMultipleConflicts
	self assertMerge: #(a1 b3 c1)
				with: #(a1 b2 d1)
				base: #(a1 b1 c2)
				
				gives: #(a1 b3 d1)
				conflicts: #((removed c1) (b2 b3))
! !

!MCMergingTest methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 01:43'!
testLocalRemoveRemoteModify
	self assertMerge: #(b1)
				with: #(a1 b1)
				base: #(a2 b1)
				
				gives: #(a1 b1)
				conflicts: #((a1 removed)).

	self assertMerge: #(b1)
				with: #(a2 b1)
				base: #(a1 b1)
				
				gives: #(a2 b1)
				conflicts: #((a2 removed)).! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 02:05'!
mockClassA
	^ Smalltalk at: #MCMockClassA! !

!MCTestCase methodsFor: 'compiling' stamp: 'cwp 8/2/2003 15:05'!
restoreMocks
	self mockSnapshot updatePackage: self mockPackage! !

MCTestCase subclass: #MCRepositoryTest
	instanceVariableNames: 'repository ancestors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

MCRepositoryTest subclass: #MCDirectoryRepositoryTest
	instanceVariableNames: 'directory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/21/2003 12:44'!
addVersion: aVersion
	| file |
	file _ FileStream newFileNamed: (directory fullNameFor: aVersion info name, '.', repository defaultWriterClass extension).
	repository defaultWriterClass fileOut: aVersion on: file.
	file close.! !

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:48'!
directory
	directory ifNil:
		[directory _ FileDirectory default directoryNamed: 'mctest'.
		directory assureExistence].
	^ directory! !

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:49'!
setUp
	repository _ MCDirectoryRepository new directory: self directory! !

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:53'!
tearDown
	self directory recursiveDelete! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2003 23:59'!
testIncludesName
	self deny: (repository includesVersionNamed: 'rev1').
	self saveSnapshot1.
	self assert: (repository includesVersionNamed: 'rev1').
	self deny: (repository includesVersionNamed: 'rev2').
	self saveSnapshot2.
	self assert:  (repository includesVersionNamed: 'rev2').! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:22'!
testStoreAndLoad
	| node node2 |
	node _ self saveSnapshot1.
	node2 _ self saveSnapshot2.
	self assert: (self snapshotAt: node) = self snapshot1.
	self assert: (self snapshotAt: node2) = self snapshot2.! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:45'!
saveSnapshot: aSnapshot named: aString
	| version |
	version _ self versionWithSnapshot: aSnapshot name: aString.
	repository storeVersion: version.
	^ version info
	! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:46'!
addVersionWithSnapshot: aSnapshot name: aString
	| version |
	version _ self versionWithSnapshot: aSnapshot name: aString.
	self addVersion: version.
	^ version info! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 01:03'!
snapshot1
	^ (MCSnapshot fromDefinitions: (Array with: (MCOrganizationDefinition categories: #('y'))))! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:20'!
saveSnapshot2
	^ self saveSnapshot: self snapshot2 named: 'rev2'! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:46'!
addVersion: aVersion
	self subclassResponsibility ! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:52'!
testAddAndLoad
	| node |
	node _ self addVersionWithSnapshot: self snapshot1 name: 'rev1'.
	self assert: (self snapshotAt: node) = self snapshot1.
! !

!MCRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:45'!
isAbstract
	^ self = MCRepositoryTest! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:44'!
versionWithSnapshot: aSnapshot name: aString
	| info |
	info _ MCVersionInfo new.
	info setName: aString message: ''.
	^ MCVersion 
		package: (MCPackage new name: aString)
		info: info
		snapshot: aSnapshot! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:20'!
saveSnapshot1
	^ self saveSnapshot: self snapshot1 named: 'rev1'! !

MCRepositoryTest subclass: #MCDictionaryRepositoryTest
	instanceVariableNames: 'dict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:06'!
dictionary
	^ dict ifNil: [dict _ Dictionary new]! !

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:06'!
deleteNode: aNode
	dict removeKey: aNode! !

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:49'!
setUp
	repository _  MCDictionaryRepository new dictionary: self dictionary! !

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:53'!
addVersion: aVersion
	dict at: aVersion info put: aVersion! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 23:59'!
assertMissing: aVersionInfo
	self assert: (repository versionWithInfo: aVersionInfo) isNil! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 23:59'!
testLoadMissingNode
	| node |
	node _ MCVersionInfo new.
	self assertMissing: node! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 14:32'!
snapshotAt: aVersionInfo
	^ (repository versionWithInfo: aVersionInfo) snapshot! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 18:07'!
assertVersionInfos: aCollection
	self assert: repository allVersionInfos asSet = aCollection asSet! !

!MCRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 01:03'!
snapshot2
	^ (MCSnapshot fromDefinitions: (Array with: (MCOrganizationDefinition categories: #('x'))))! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 16:50'!
mockClass: className super: superclassName
	^ MCClassDefinition
		name:  className
		superclassName:  superclassName
		category: self mockCategoryName
		instVarNames: #()
		classVarNames: #()
		poolDictionaryNames: #()
		classInstVarNames: #()
		type: #normal
		comment: (self commentForClass: className)
		commentStamp: (self commentStampForClass: className)! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 14:58'!
assertVersion: actual matches: expected
	self assertPackage: actual package matches: expected package.	
	self assertVersionInfo: actual info matches: expected info.
	self assertSnapshot: actual snapshot matches: expected snapshot.! !

!MCTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:12'!
isAbstract
	^ self = MCTestCase! !

!MCTestCase methodsFor: 'compiling' stamp: 'cwp 7/21/2003 22:51'!
compileClass: aClass source: source category: category
	aClass compileInobtrusively: source classified: category! !

!MCTestCase methodsFor: 'compiling' stamp: 'cwp 8/10/2003 02:12'!
change: aSelector toReturn: anObject
	self 
		compileClass: self mockClassA 
		source: aSelector, ' ^ ', anObject printString 
		category: 'numeric'! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 02:06'!
mockInstanceA
	^ self mockClassA new! !

MCTestCase subclass: #MCAncestryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Tests'!

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 21:21'!
tree
	^ self treeFrom:
		#(c1
			((e2
				((e1
					((a1
						(('00')))))))
			(a2
				((a1
					(('00')))))
			(b3
				((b2
					((b1
						((b0
							(('00')))))))
				(a1
					(('00')))))
			(d1)))! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 20:45'!
testLinearPath
	self assertPathTo: #b1 is: #(b3 b2)! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 23:14'!
versionForName: name in: tree
	(tree name = name) ifTrue: [^ tree].
	
	tree ancestors do: [:ea | (self versionForName: name in: ea) ifNotNilDo: [:v | ^ v]].
	
	^ nil! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 23:00'!
assertCommonAncestorOf: leftName and: rightName is: ancestorName in: tree
	| left right ancestor |
	left _ self versionForName: leftName in: tree.
	right _ self versionForName: rightName in: tree.
	
	ancestor _ left commonAncestorWith: right.
	
	self assert: ancestor name = ancestorName! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 20:30'!
assertNamesOf: versionInfoCollection are: nameArray
	| names |
	names _ versionInfoCollection collect: [:ea | ea name].
	
	self assert: names asArray = nameArray! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 22:42'!
testAllAncestors
	"- ancestors appear in the order in which they were merged in (hence e2 before a2)
	- children always come before parents (e1 before a1 and b1 before 00 at same depth; b0 before 00 even though b0 is deeper)"
	
	self assertNamesOf: self tree allAncestors are: #(e2 a2 b3 d1 e1 b2 a1 b1 b0 '00')! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 22:42'!
testWithAllAncestors
	"see comments in testAllAncestors"
	
	self assertNamesOf: self tree withAllAncestors are: #(c1 e2 a2 b3 d1 e1 b2 a1 b1 b0 '00')! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 20:19'!
transformTree: anArray
	| name newArray |
	name _ anArray first.
	newArray _ Array with: name asString with: '00000000-0000-0000-0000-0000000000', name asString with: ''.
	^ anArray size > 1
		ifFalse: [newArray]
		ifTrue: [newArray copyWith: (anArray second collect: [:ea | self transformTree: ea])]
! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 23:42'!
assertPathTo: aSymbol is: anArray
	self
		assertNamesOf: (self tree allAncestorsOnPathTo: (self treeFrom: {aSymbol}))
		are: anArray! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 20:09'!
treeFrom: anArray
	^ MCVersionInfo fromArray: (self transformTree: anArray)! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 22:55'!
twoPersonTree
	^ self treeFrom:
		#(c1
			((a4
				((a1)
				(b3
					((b2
						((a1)))))))
			(b5
				((b2
					((a1)))))))! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 20:42'!
testPathToMissingAncestor
	self assert: (self tree allAncestorsOnPathTo: MCVersionInfo new) isEmpty! !

!MCAncestryTest methodsFor: 'as yet unclassified' stamp: 'jf 8/16/2003 23:48'!
testCommonAncestors
	self assertCommonAncestorOf: #a2 and: #e2 is: #a1 in: self tree.
	self assertCommonAncestorOf: #e2 and: #b3 is: #a1 in: self tree.
	self assertCommonAncestorOf: #b2 and: #e2 is: #'00' in: self tree.
	
	self assertCommonAncestorOf: #a4 and: #b5 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b5 and: #b3 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b2 and: #a4 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b2 and: #b2 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b2 and: #a1 is: #a1 in: self twoPersonTree.
	self assertCommonAncestorOf: #a1 and: #b2 is: #a1 in: self twoPersonTree.! !

!MCTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:05'!
resources
	^ Array with: MCSnapshotResource! !

ReadStream subclass: #MCMockMessageStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockMessageStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2003 12:04'!
isMessageStream
	^ true! !

!Stream methodsFor: '*monticello' stamp: 'cwp 8/9/2003 12:02'!
isMessageStream
	^ false! !

!Class methodsFor: '*monticello' stamp: 'cwp 8/10/2003 16:41'!
asClassDefinition
	^ MCClassDefinition
		name: self name
		superclassName: self superclass name
		category: self category 
		instVarNames: self instVarNames
		classVarNames: self classVarNames
		poolDictionaryNames: self poolDictionaryNames
		classInstVarNames: self class instVarNames
		type: self typeOfClass
		comment: self organization classComment	 asString
		commentStamp: self organization commentStamp	! !

!Class methodsFor: '*monticello' stamp: 'ab 4/14/2003 22:30'!
poolDictionaryNames
	^ self sharedPools collect: [:ea | self environment keyAtIdentityValue: ea]! !

Notification subclass: #MCVersionNameAndMessageRequest
	instanceVariableNames: 'suggestion '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 20:39'!
defaultAction
	^ MCSaveVersionDialog new
		versionName: suggestion;
		showModally! !

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 01:07'!
suggestedName: aString
	suggestion _ aString! !

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 01:07'!
suggestedName
	^ suggestion! !

Notification subclass: #MCMergeResolutionRequest
	instanceVariableNames: 'merger '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCMergeResolutionRequest methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:19'!
merger
	^ merger! !

!MCMergeResolutionRequest methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:19'!
defaultAction
	^ (MCMergeBrowser new merger: merger) showModally! !

!MCMergeResolutionRequest methodsFor: 'as yet unclassified' stamp: 'ab 7/18/2003 18:18'!
merger: aMerger
	merger _ aMerger! !

!PackageInfo methodsFor: '*monticello' stamp: 'dvf 7/23/2003 14:06'!
includesMethodCategory: categoryName ofClassNamed: aClass
	^ (self isYourClassExtension: categoryName)
		or: [(self includesClassNamed: aClass)
				and: [(self isForeignClassExtension: categoryName) not]]! !

PackageInfo subclass: #MCDirtyPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCDirtyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
packageName
	^ 'MCDirtyPackage'! !

!MCDirtyPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:08'!
methods
	^ self mockClassA selectors
		select: [:ea | ea beginsWith: 'ordinal']
		thenCollect:
			[:ea | 
				MethodReference new 
					setStandardClass: MCMockClassA 
					methodSymbol: ea].! !

!MCDirtyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
classes
	^ Array new: 0.! !

!MCDirtyPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:45'!
wantsChangeSetLogging
	^ false! !

PackageInfo subclass: #MCMockPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 20:25'!
extensionMethods
	^ Array with: (MethodReference new 
					setStandardClass: MCSnapshotTest 
					methodSymbol: #mockClassExtension)! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 7/31/2003 15:30'!
systemCategories
	^ Array with: 'Monticello-Mocks'! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:12'!
classes
	^ self classNames 
		select: [:name | Smalltalk hasClassNamed: name]
		thenCollect: [:name | Smalltalk at: name]! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 20:31'!
packageName
	^ 'MonticelloMocks'! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:09'!
classNames
	^ #(	MCMockClassA
		 	MCMockASubclass
			MCMockClassB
			MCMockClassD
			MCMockClassE
			MCMockClassF
			MCMockClassG
			MCMockClassH
			MCMockClassI
		)! !

!PackageInfo methodsFor: '*monticello' stamp: 'dvf 7/23/2003 14:08'!
includesClassNamed: aClassName
	^ self includesSystemCategory: ((SystemOrganization categoryOfElement: aClassName) ifNil: [^false])! !

!PackageInfo methodsFor: '*monticello' stamp: 'cwp 8/9/2003 23:32'!
unload
	self classes do: [:c | Smalltalk removeClassFromSystem: c logged: false].
	self extensionMethods do: [:m | m actualClass removeSelector: m methodSymbol].! !

PackageInfo subclass: #MCEmptyPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Mocks'!

!MCEmptyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
methods
	^ #()! !

!MCEmptyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
classes
	^ #()! !

!MCEmptyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
packageName
	^ 'MCEmptyPackage'! !

!MCEmptyPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:45'!
wantsChangeSetLogging
	^ false! !
MCBootstrapLoader initialize!
MCMessageStream initialize!
MCMethodDefinition initialize!
MCMockClassA initialize!
MCReader initialize!
MCVersion initialize!
MCWorkingCopy initialize!
MCWorkingCopyBrowser initialize!
